dim $Total_Timers[1]
dim $Timer_Index[1]
dim $Timer_remain[1]
dim $Timer_repeat[1]
dim $Timer_repeat_First[1]
dim $Timer_old_time[1]

func _Start_Timer()
	Local $total_items = _GUICtrlListViewGetItemCount($Timer_listview)
	Local $Start_Counter = 0
	redim $Total_Timers[1]
	redim $Timer_Index[1]
	ReDim $Timer_remain[1]
	ReDim $Timer_repeat[1]
	reDim $Timer_repeat_First[1]
	ReDim $Timer_old_time[1]
	for $i = 0 to $total_items-1
		if _GUICtrlListViewGetCheckedState($Timer_listview, $i) = 1 Then
			$Start_Counter += 1
			redim $Total_Timers[$Start_Counter]
			$Total_Timers[$Start_Counter-1] = TimerInit()
			redim $Timer_Index[$Start_Counter]
			$Timer_Index[$Start_Counter-1] = $i
			ReDim $Timer_remain[$Start_Counter]
			Local $Time = _GUICtrlListViewGetItemText($Timer_listview, $i, 2)
			ReDim $Timer_repeat[$Start_Counter]
			reDim $Timer_repeat_First[$Start_Counter]
			ReDim $Timer_old_time[$Start_Counter]
			$Timer_repeat[$Start_Counter-1] = _GUICtrlListViewGetItemText($Timer_listview, $i, 1)
			$Timer_repeat_First[$Start_Counter-1] = $Timer_repeat[$Start_Counter-1]
			Local $time_split = StringSplit($Time, ":")
			Local $remmaing_time = Number($time_split[1])*3600000+Number($time_split[2])*60000+Number($time_split[3])*1000
			$Timer_old_time[$Start_Counter-1] = $Time
			$Timer_remain[$Start_Counter-1] = $remmaing_time
		EndIf
	Next
	$Timer_check = True
	GUICtrlSetState($Timer_Add_button, $GUI_DISABLE)
	GUICtrlSetState($Timer_Edit_button, $GUI_DISABLE)
	GUICtrlSetState($Timer_Delete_button, $GUI_DISABLE)
	GUICtrlSetState($Timer_listview, $GUI_DISABLE)
	GUICtrlSetState($Timer_check_all, $GUI_DISABLE)
	GUICtrlSetState($Timer_Start_button, $GUI_DISABLE)
	GUICtrlSetState($Timer_Stop_button, $GUI_ENABLE)
	Return 0
EndFunc

func _Stop_Timer()
	$Timer_check = False
	for $i = 0 to UBound($Timer_Index)-1
		_GUICtrlListViewSetItemText($Timer_listview, $Timer_Index[$i], 1, $Timer_repeat_First[$i])
		_GUICtrlListViewSetItemText($Timer_listview, $Timer_Index[$i], 3, _GUICtrlListViewGetItemText($Timer_listview, $Timer_Index[$i], 2))
	Next
	GUICtrlSetState($Timer_Add_button, $GUI_ENABLE)
	GUICtrlSetState($Timer_Edit_button, $GUI_ENABLE)
	GUICtrlSetState($Timer_Delete_button, $GUI_ENABLE)
	GUICtrlSetState($Timer_listview, $GUI_ENABLE)
	GUICtrlSetState($Timer_check_all, $GUI_ENABLE)
	GUICtrlSetState($Timer_Stop_button, $GUI_DISABLE)
	GUICtrlSetState($Timer_Start_button, $GUI_ENABLE)
	Local $ControlData
	Switch GUICtrlRead($Tab2)
		case 0
			$ControlData = ($AE_Current_operation)
		case 1
			$ControlData = ($EE_Current_operation)
		case 2
			$ControlData = ($SM_Current_operation)
		case 3
			$ControlData = ($BK_Current_operation)
		case 4
			$ControlData = ($DL_Current_operation)
		case 5
			$ControlData = ($Macro_Current_operation)
	EndSwitch
	GUICtrlSetData($ControlData, "STOPPED")
	GUICtrlSetColor($ControlData, $boje_crvena_STOP)
	Return 0
EndFunc

func _Timer_check()
;~ 	if $DEBUGGING = True then FileWrite($Debug_file, "check timer operation" & @TAB & @TAB & @HOUR & ":" & @MIN & ":" & @SEC & @TAB & @MDAY & "\" & @MON & "\" & @YDAY & @CRLF)
	Local $ControlData
	for $i = 0 to (UBound($Timer_Index)-1)
		if $Timer_repeat[$i] = "infinite" OR Number($Timer_repeat[$i]) <> 0 then
			if TimerDiff($Total_Timers[$i]) >= $Timer_remain[$i] OR TimerDiff($Total_Timers[$i]) < 0 then
				Switch GUICtrlRead($Tab2)
					case 0 ;AE
						$ControlData = ($AE_Current_operation)
					case 1 ;EE
						$ControlData = ($EE_Current_operation)
					case 2 ;SM
						$ControlData = ($SM_Current_operation)
					case 3 ;BK
						$ControlData = ($BK_Current_operation)
					case 4 ;DL
						$ControlData = ($DL_Current_operation)
					case 5 ;Macro
						$ControlData = ($Macro_Current_operation)
				EndSwitch
				GUICtrlSetData($ControlData, "Timer act.")
				GUICtrlSetColor($ControlData, $boje_plava_tamno)
				if Number($Timer_repeat[$i]) <> 0 OR $Timer_repeat[$i] = "infinite" Then _GUICtrlListViewSetItemText($Timer_listview, $Timer_Index[$i], 3, "Performing action")
				if $Timer_repeat[$i] <> "infinite" then $Timer_repeat[$i] = string(Number($Timer_repeat[$i])-1)
				$Total_Timers[$i] = TimerInit()
				_GUICtrlListViewSetItemText($Timer_listview, $Timer_Index[$i], 1, $Timer_repeat[$i])
				Local $Full_Operation = _GUICtrlListViewGetItemText($Timer_listview, $Timer_Index[$i], 0)
				Local $First_op = StringLeft($Full_Operation, StringInStr($Full_Operation, ":")-1)
				Local $Second_op = StringTrimLeft($Full_Operation, StringInStr($Full_Operation, ":")+1)
				Local $Varzx = 0
;~ 				_Force_MU_activation()
;~ 				if WinExists("MU") and NOT WinActive("MU") then WinActivate("MU")
				;--------------------------------- timer operation -----------------------------------
				Switch $First_op
					Case "Activate"
						Switch $Second_op
							Case "Infinite arrow"
								GUICtrlSetState($AE_Infinite_arrow_checkbox, $GUI_CHECKED)
								_AE_Infinite_arrow()
							case "Auto party"
								GUICtrlSetState($AutoParty_checkbox, $GUI_CHECKED)
								_Auto_party()
								$AutoParty_timer = TimerInit()
								$AutoParty_ready = True
								$AutoParty_regulator = True
							case "Repair items"
								GUICtrlSetState($Repair_items_checkbox, $GUI_CHECKED)
								_Repair_items()
								$Repair_items_timer = TimerInit()
								$repair_ready = True
								$repair_regulator = True
							case "Drop items"
								GUICtrlSetState($Drop_items_checkbox, $GUI_CHECKED)
								_Drop_items()
								$Drop_items_timer = TimerInit()
								$drop_ready = True
								$drop_regulator = True
							Case "Check 4 DC"
								_Start_check_dc()
						EndSwitch
					case "Exit"
						Switch $Second_op
							Case "Exit MU Game"
								WinClose("MU")
								if WinExists("MU") then WinKill("MU")
							case "Close bot"
								_Stop_Timer()
								_Close_bot()
							case "Shutdown PC"
								WinClose("MU")
								if WinExists("MU") then WinKill("MU")
								Shutdown(1+4)
								_Stop_Timer()
								_Close_bot()
							case "Restart PC"
								WinClose("MU")
								if WinExists("MU") then WinKill("MU")
								Shutdown(2+4)
								_Stop_Timer()
								_Close_bot()
							case "DC Internet"
								Run(@ComSpec & " /c " & "rasdial /disconnect", "", @SW_HIDE)
						EndSwitch
					case "Warp to"
;~ 						$Is_Bot_Key = True
;~ 						if WinExists("MU") AND WinActive("MU") then send("{ENTER}")
;~ 						_sleep_ex($AfteR_Enter)
						_type_txt("/warp " & $Second_op, 1)
;~ 						_sleep_ex($AfteR_Enter)
;~ 						if WinExists("MU") AND WinActive("MU") then send("{ENTER}")
;~ 						$Is_Bot_Key = False
					case "Set speed"
						Local $Will_start_bot = False
						if $ANY_BOT = True Then
							_Stop_Bot()
							$Will_start_bot = True
						EndIf
						Switch GUICtrlRead($Tab2)
							Case 0 ;AE
								Local $Speed_xxx = Int(Number($Second_op))
								if $Speed_xxx > 10 then $Speed_xxx = 10
								if $Speed_xxx < 0 then $Speed_xxx = 0
								GUICtrlSetData($AE_Direction_Speed_Slider, $Speed_xxx)
								GUICtrlSetData($AE_Direction_Speed_Status, $Speed_xxx)
								if $Will_start_bot = True then _Real_AE_bot()
							Case 1 ;EE
								Local $Speed_xxx = Int(Number($Second_op))
								if $Speed_xxx > 60 then $Speed_xxx = 60
								if $Speed_xxx < 0 then $Speed_xxx = 0
								GUICtrlSetData($EE_Buff_delay_input, $Speed_xxx)
								if $Will_start_bot = True then _Real_EE_bot()
							Case 2 ;SM
								Local $Speed_xxx = $Second_op
								$Speed_xxx = StringReplace($Speed_xxx, ".", ",")
								if StringInStr($Speed_xxx, ",") <> 0 then
									Local $first_number = Number(StringLeft($Speed_xxx, StringInStr($Speed_xxx, ",")-1))
									Local $second_number = Number(StringLeft(StringTrimLeft($Speed_xxx, StringInStr($Speed_xxx, ",")), 1))
									if $first_number > 9 Then $first_number = 9
									if $second_number > 9 then $second_number = 9
								Else
									Local $First_number = Int($Speed_xxx)
									if Number($First_number) > 9 then $First_number = 9
									Local $second_number = 0
								EndIf
								if Int($First_number) = 0 AND Int($second_number) = 0 Then
									GUICtrlSetData($SM_Main_afk_skill_delay_input, "0")
								Else
									GUICtrlSetData($SM_Main_afk_skill_delay_input, $First_number & "," & $second_number)
								EndIf
								if $Will_start_bot = True then _Real_SM_bot()
							case 3 ;BK
								Local $Speed_xxx = $Second_op
								$Speed_xxx = StringReplace($Speed_xxx, ".", ",")
								if StringInStr($Speed_xxx, ",") <> 0 then
									Local $first_number = Number(StringLeft($Speed_xxx, StringInStr($Speed_xxx, ",")-1))
									Local $second_number = Number(StringLeft(StringTrimLeft($Speed_xxx, StringInStr($Speed_xxx, ",")), 1))
									if $first_number > 9 Then $first_number = 9
									if $second_number > 9 then $second_number = 9
								Else
									Local $First_number = Int($Speed_xxx)
									if Number($First_number) > 9 then $First_number = 9
									Local $second_number = 0
								EndIf
								if Int($First_number) = 0 AND Int($second_number) = 0 Then
									GUICtrlSetData($BK_Main_skill_interval_input, "0")
								Else
									GUICtrlSetData($BK_Main_skill_interval_input, $First_number & "," & $second_number)
								EndIf
								if $Will_start_bot = True then _Real_BK_bot()
							case 4 ;DL
								Local $Speed_xxx = Int($Second_op)
								if $Speed_xxx > 10 then $Speed_xxx = 10
								if $Speed_xxx < 0 then $Speed_xxx = 0
								GUICtrlSetData($DL_Mouse_movement_slider, $Speed_xxx)
								GUICtrlSetData($DL_Mouse_movement_label, $Speed_xxx)
								if $Will_start_bot = True then _Real_DL_bot()
						EndSwitch
					case "Say"
;~ 						$Is_Bot_Key = True
;~ 						if WinExists("MU") AND WinActive("MU") then send("{ENTER}")
;~ 						_sleep_ex($AfteR_Enter)
						_type_txt($Second_op, 1)
;~ 						_sleep_ex($AfteR_Enter)
;~ 						if WinExists("MU") AND WinActive("MU") then send("{ENTER}")
;~ 						$Is_Bot_Key = False
					case "Switch char"
						Local $Will_start_bot = False
						if $ANY_BOT = True Then
							_Stop_Bot()
							$Will_start_bot = True
						EndIf
						$Second_op = StringRight($Second_op, 1)
						Local $prev_send1 = IniRead($Save_file, "Misc", "KeyboardDelay", $default_sleep_for_opts)
						Opt ("SendKeyDelay", $Mouse_Down_Click)
						Opt ("SendKeyDownDelay", $Mouse_Down_Click)
						Send("{ESC}")
						Opt ("SendKeyDelay", $prev_send1)
						Opt ("SendKeyDownDelay", $prev_send1)
						If _Switch_char($Second_op) <> 1 then
							Opt ("SendKeyDelay", $Mouse_Down_Click)
							Opt ("SendKeyDownDelay", $Mouse_Down_Click)
							Send("{ESC}")
							Opt ("SendKeyDelay", $prev_send1)
							Opt ("SendKeyDownDelay", $prev_send1)
						EndIf
						if $Will_start_bot = True then
							Switch GUICtrlRead($Tab2)
								case 0 ;AE
									_Real_AE_bot()
								case 1 ;EE
									_Real_EE_bot()
								case 2 ;SM
									_Real_SM_bot()
								case 3 ;BK
									_Real_BK_bot()
								case 4 ;DL
									_Real_DL_bot()
								case 5 ;Macro
									_Real_Macro_bot()
							EndSwitch
						EndIf
					case "Switch bot"
						Local $Will_start_bot = False
						if $ANY_BOT = True Then
							_Stop_Bot()
							$Will_start_bot = True
						EndIf
						GUISetState(@SW_SHOWNOACTIVATE, $Form1)
						_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab1), 2)
						GUISetState(@SW_SHOWNOACTIVATE, $Form2)
						Switch $Second_op
							Case "AE"
								_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab2), 0)
								if $Will_start_bot = True then _Real_AE_bot()
							case "EE"
								_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab2), 1)
								if $Will_start_bot = True then _Real_EE_bot()
							case "SM"
								_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab2), 2)
								if $Will_start_bot = True then _Real_SM_bot()
							case "BK"
								_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab2), 3)
								if $Will_start_bot = True then _Real_BK_bot()
							case "DL"
								_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab2), 4)
								if $Will_start_bot = True then _Real_DL_bot()
							case "Macro"
								_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab2), 5)
								if $Will_start_bot = True then _Real_Macro_bot()
						EndSwitch
					case "Make"
						Switch $Second_op
							case "ScreenShot"
								Send("{PRINTSCREEN}"); DOWN}")
								_sleep_ex($AfteR_Enter)
;~ 								Send("{PRINTSCREEN UP}")
						EndSwitch
				EndSwitch
				if Number($Timer_repeat[$i]) = 0 AND $Timer_repeat[$i] <> "infinite" Then _GUICtrlListViewSetItemText($Timer_listview, $Timer_Index[$i], 3, "Finished")
			Else
				Local $remain_time = _Convert_to_time($Timer_remain[$i]-TimerDiff($Total_Timers[$i]))
				if $Timer_old_time[$i] <> $remain_time Then
					$Timer_old_time[$i] = $remain_time
					_GUICtrlListViewSetItemText($Timer_listview, $Timer_Index[$i], 3, $remain_time)
				EndIf
			EndIf
		EndIf
	Next
	Return 0
EndFunc

func _Convert_to_time($expression)
	Local $time_int = Int($expression/1000)
	Local $Hours = Int($time_int/3600)
	Local $Minutes = Int(($time_int-$Hours*3600)/60)
	Local $Seconds = $time_int-$Hours*3600-$Minutes*60
	if StringLen($Hours) < 2 then $Hours = "0" & $Hours
	if StringLen($Minutes) < 2 then $Minutes = "0" & $Minutes
	if StringLen($Seconds) < 2 then $Seconds = "0" & $Seconds
	Local $return_string = $Hours & ":" & $Minutes & ":" & $Seconds
	Return $return_string
EndFunc

Func _Switch_char($character)
	Local $polovina_x = Number(StringLeft(GUICtrlRead($Resolution_combo), StringInStr(GUICtrlRead($Resolution_combo), "x")-1))
	Local $polovina_Y = Number(StringTrimLeft(GUICtrlRead($Resolution_combo), StringInStr(GUICtrlRead($Resolution_combo), "x")))
	Switch $polovina_x
		case 800
			dim $check_color_x[7] = [230, 487, 433, 702, 771, 530, 400]
			dim $check_color_y[7] = [279, 333, 467, 527, 509, 246, 246]
			$Character_x_distance = 122
			$Character_X = 163+($character-1)*$Character_x_distance
			$Character_Y = 420
		case 1024
			dim $check_color_x[7] = [364, 585, 638, 898, 987, 619, 512]
			dim $check_color_y[7] = [363, 311, 392, 696, 651, 330, 315]
			$Character_x_distance = 147
			$Character_X = 227+($character-1)*$Character_x_distance
			$Character_Y = 515
		case else
			dim $check_color_x[7] = [453, 716, 767, 1174, 1234, 750, 640]
			dim $check_color_y[7] = [491, 465, 563, 940, 868, 458, 420]
			$Character_x_distance = 193
			$Character_X = 266+($character-1)*$Character_x_distance
			$Character_Y = 680
	EndSwitch
	
		Opt ("MouseClickDelay", $Mouse_Down_Click)
		Opt ("MouseClickDownDelay", $Mouse_Down_Click)
		MouseClick("Left", $check_color_x[6], $check_color_y[6], 2, 0)
		Opt ("MouseClickDelay", IniRead($Save_file, "Misc", "MouseDelay", $default_sleep_for_opts))
		Opt ("MouseClickDownDelay", IniRead($Save_file, "Misc", "MouseDelay", $default_sleep_for_opts))
		
	_sleep_ex(5000)
	Local $Temp_Timer = TimerInit()
	Local $boje = 1
	$Starting_to_login = True
	Do
		if TimerDiff($Temp_Timer) >= 60000  OR TimerDiff($Temp_Timer) < 0 OR NOT WinExists("MU") Then
;~ 			MsgBox(0, "", ">= 60" & @CRLF & "< 0" & @CRLF & "win not exist")
			Return 0
			ExitLoop
		EndIf
		if $Starting_to_login = False Then
;~ 			MsgBox(0, "", "prekinuto")
			Return 0
			ExitLoop
		EndIf
		if $Virtual_Box = False then
			$boje = _napravi_sliku_pixela($check_color_x[3], $check_color_y[3])
		Else
			for $i = 7 to 0 Step -1
				if $Starting_to_login = False Then
					$Check_for_DC = False
					Return 0
					ExitLoop
				EndIf
				_sleep_ex(1000)
			Next
			$boje = 0
		EndIf
	Until $boje = 0
	_sleep_ex(500)

		Opt ("MouseClickDelay", $Mouse_Down_Click)
		Opt ("MouseClickDownDelay", $Mouse_Down_Click)
		MouseClick("Left", $Character_X, $Character_Y, 1, 4)
		Opt ("MouseClickDelay", IniRead($Save_file, "Misc", "MouseDelay", $default_sleep_for_opts))
		Opt ("MouseClickDownDelay", IniRead($Save_file, "Misc", "MouseDelay", $default_sleep_for_opts))

	Opt ("SendKeyDelay", $Mouse_Down_Click)
	Opt ("SendKeyDownDelay", $Mouse_Down_Click)
	Send("{ENTER}"); DOWN}")
	Opt ("SendKeyDownDelay", IniRead($Save_file, "Misc", "KeyboardDelay", $default_sleep_for_opts))
	Opt ("SendKeyDelay", IniRead($Save_file, "Misc", "KeyboardDelay", $default_sleep_for_opts))
	_sleep_ex($AfteR_Enter)
	_sleep_ex(1000)
	$Temp_Timer = TimerInit()
	$boje = 0
	Do
		if TimerDiff($Temp_Timer) >= 60000  OR TimerDiff($Temp_Timer) < 0 OR NOT WinExists("MU") Then
			Return 0
			ExitLoop
		EndIf
		if $Starting_to_login = False Then
			Return 0
			ExitLoop
		EndIf
		if $Virtual_Box = False then
			$boje = _napravi_sliku_pixela($check_color_x[4], $check_color_y[4])
		Else
			for $i = 7 to 0 Step -1
				if $Starting_to_login = False Then
					Return 0
					ExitLoop
				EndIf
				_sleep_ex(1000)
			Next
			$boje = 1
		EndIf
	Until $boje <> 0
	_sleep_ex(500)
	_Request_off()
;~ 	Send("{ALT}"); DOWN}")
	_sleep_ex($AfteR_Enter)
	_Move_Mouse_Ex($polovina_x/2, $polovina_y/2, 0)
	Return 1
EndFunc