#RequireAdmin
#NoTrayIcon
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <EditConstants.au3>
#include <TabConstants.au3>
#include <WindowsConstants.au3>
#Include <GuiTab.au3>
#include <ComboConstants.au3>
#include <String.au3>
#include <File.au3>
#include <GuiTreeView.au3>
#include <TreeViewConstants.au3>
#Include <GuiListView.au3>
#include <Process.au3>

Global $main_bot_title = "Snd.Bot"
Global $Version_of_the_bot = "2.0.0"
Global $Is_beta = True
Global $beta_version = "1.82"
Global $signature = "sandin"

Global $Title = $main_bot_title & " v" & $Version_of_the_bot;"Snd.Bot v2.0.0 (Beta 1.82) - by sandin"
If $Is_beta = True then $Title &= " (Beta " & $beta_version & ")"
$Title &= " - by " & $signature

DirCreate(@ScriptDir & "\Data")
FileInstall("c:\SndBot\data\GPPMX.dll", @ScriptDir & "\Data\GPPMX.dll")
FileInstall("c:\SndBot\data\Icons.dll", @ScriptDir & "\Data\Icons.dll")
FileInstall("c:\SndBot\data\SndChat.exe", @ScriptDir & "\Data\SndChat.exe")
FileInstall("c:\SndBot\data\Hor.jpg", @ScriptDir & "\Data\Hor.jpg")
FileInstall("c:\SndBot\data\Ver.jpg", @ScriptDir & "\Data\Ver.jpg")
FileInstall("c:\SndBot\data\Cir.jpg", @ScriptDir & "\Data\Cir.jpg")
FileInstall("c:\SndBot\data\Ran.jpg", @ScriptDir & "\Data\Ran.jpg")
FileInstall("c:\SndBot\data\HotkeysList.txt", @ScriptDir & "\Data\HotkeysList.txt")

$encryption_password = "Pa$$w0rD" ;you can change this in order to have unique encrypt/decryptor
$encryption_level = "3"

Global $default_sleep_for_opts = 180

;boje
Global $boje_crvena_STOP = 0xFF0000, $boje_zelena_GO = 0x008B00, $boje_plava_tamno = 0x0341AB

Global $Slide_in_speed = 250, $Slide_out_speed = 150

Global Const $WM_COMMAND = 0x0111
;~ Global Const $WM_NOTIFY = 0x004E

Global $MU_REG_CONFIG = "HKEY_CURRENT_USER\Software\Webzen\Mu\Config", $DISPLAY_SAVING, $Icons_file = @ScriptDir & "\Data\Icons.dll"
Global $General_tab, $Options_tab, $BOTS_tab, $Timer_tab, $Form2, $Tab2, $AE_Bot_Tab, $EE_Bot_tab, $SM_Bot_tab, $BK_Bot_tab, $DL_Bot_Tab, $Macro_bot_tab, $Chat_tab, $DC_TAB, $Form_4_shade
Global $SHELL32 = @SystemDir & "\shell32.dll", $DC_Log_file = @ScriptDir & "\Data\DC_Log.txt"
Global $DEBUGGING = False, $Debug_file = @ScriptDir & "\Data\Debug.txt", $ByPassDll = DllOpen(@ScriptDir & "\Data\GPPMX.dll"), $dll_load = DllOpen("user32.dll"), $NTDll=DllOpen("ntdll.dll")

if WinExists($title) Then
;~ 	Local $Proc_list = ProcessList()
;~ 	Local $close_previous_q = False
;~ 	for $i = 1 to $Proc_list[0][0]
;~ 		if $Proc_list[$i][1] = WinGetProcess($title) AND $Proc_list[$i][0] = @ScriptName then
;~ 			$close_previous_q = True
;~ 			ExitLoop
;~ 		EndIf
;~ 	Next
;~ 	if $close_previous_q = True then
		Switch MsgBox(3, "Error", "Bot is already running..." & @CRLF & "Would you like me to close working bot," & @CRLF & "in order to start this one?")
			case 6 ;yes
				Local $proc_pid = WinGetProcess($Title)
				ProcessClose($proc_pid)
				Do
				Until NOT ProcessExists($proc_pid)
			case 2, 7 ;cancel, no
				Exit
		EndSwitch
;~ 	EndIf
EndIf

;General tab:
Global $Resolution_combo, $destination_input, $destination_browse, $Window_mode_radio, $Fullscreen_mode_radio, $Sound_checkbox, $Music_checkbox, $Username_Input, $START_MU_BUTTON, $Auto_START_GAME_checkbox, $GMO_STARTER_help_icon, $StrID_Input, $Get_str_ID_button, $Save_User_button, $Delete_User_button

;Options tab:
Global $Isolate_jewel_button, $Isolate_jewel_status, $Isolate_jewel_help_icon, $Repair_items_checkbox, $Repair_items_interval_input, $AutoParty_checkbox, $AutoParty_Interval_input, $AutoParty_Side_combo, $Drop_items_checkbox, $Drop_Items_Interval, $Drop_items_setup_button, $PK_Button, $Form7_PkTool, $PK_Status_label, $PK_Tool_help_icon, $PK_Tool_close_button, $PK_tool_is_out = False, $PK_active = False, $Pause_bot_when_Chat_checkbox, $Pause_bot_when_Chat_help_icon, $AutoParty_Help_icon, $Additional_Setup_Button

;Additional setup window:
Global $Form8_Add_setup, $Pause_bot_when_Chat_checkbox, $Change_Hotkeys_button, $DropItemsDetectColorCheckbox, $SendF6Checkbox, $DontDropManaCheckbox, $ManaColorInput, $ColorToleranceInput, $CheckInventory
Global $CheckifItemInHandCheckbox, $DrinkHPPotsCheckbox, $HpDrinkPcntgInput, $HPHotkeyInput, $CaptureMouseCheckbox, $NoGGCheckbox, $HaveLauncherCheckbox, $NotGMOPlayerCheckbox, $ServerIPButton
Global $KeyboardDelayInput, $MouseDelayInput, $DropRepairDelayInput, $AcceptAddSetupButton, $KillAddSetupButton, $CheckHPIntervalinput, $Skill_when_drop_items, $Force_Mu_active_checkbox, $Repair_all_items_button
Global $CheckAGCheckbox, $ChecKAGIntervalInput, $CheckAGLowPcntgInput, $CheckAGskill2Input, $CheckAGhighPcntgInput, $CheckAGskill1Input, $IsoSoundGemBtn, $IsoSoundLVLUPChck, $IsoSoundLVLUPBtn, $IsoSoundMaleDieChck
Global $IsoSoundJewelChck, $IsoSoundJewelBtn, $IsoSoundMailChck, $IsoSoundMailBtn, $IsoSoundWhispChck, $IsoSoundWhispBtn, $IsoSoundGemChck, $IsoSoundBeepChck, $IsoSoundBeepBtn, $Force_Mu_active_timer, $IsoSoundMaleDieBtn
Dim $IsoDropChk[6]
Dim $IsoDropInp[6]
Dim $Repair_items[13]

;hotkeys:
Global $HK_Start, $HK_Stop, $HK_Left_clck, $HK_Tog_Pick, $HK_Rq_On, $HK_Filt_On, $HK_Filt_Off, $HK_Set_Drop, $HK_Set_Pt, $HK_Act_PK, $HK_Stop_DC, $HK_Force_Drop, $HK_Force_Repair, $HK_Force_Exit, $HK_Get_Color
Dim $HK_EE_PT[7]

;Drop items child window:
Global $Form_Drop_items, $Drop_Items_fill_random_button, $Drop_items_random_perc_input, $Drop_items_fill_all_button, $drop_items_side_combo, $drop_items_close_button, $AE_All_direction_button, $Drop_items_side_help_icon
dim $Drop_items_field[9][9]

;AE BOT tab:
Global $Direction_by_order_radio, $Direction_random_radio, $AE_Direction_Speed_Slider, $AE_Direction_Speed_Status, $AE_Direction_Status_old, $AE_Pickup_items_checkbox, $AE_Weapon_skill, $AE_Heal_buff_checkbox, $AE_Heal_buff_skill, $AE_Dmg_buff_checkbox, $AE_Dmg_buff_skill, $AE_Infinite_arrow_checkbox, $AE_Infinite_arrow_skill, $AE_Multishot_skill, $AE_Combine_skills, $AE_Skills_Help_icon, $AE_Def_buff_checkbox, $AE_Def_buff_skill, $AE_Current_operation, $AE_Mouse_reduce_button
dim $AE_Direction_Checkbox[9]

;EE Bot tab:
Global $EE_all_members_button, $EE_all_members_all_buff_button, $EE_all_members_heal_button, $EE_all_members_def_button, $EE_all_members_dmg_button, $EE_all_members_FREE_button, $EE_all_members_SUPER_button, $EE_members_buff_help_icon, $EE_Heal_skill_input, $EE_Def_skill_input, $EE_Dmg_skill_input, $EE_Buff_delay_input, $EE_Free_heal_delay_input, $EE_Free_heal_delay_UpDown, $EE_buff_delay_help_icon, $EE_Current_operation, $EE_Pickup_items, $EE_all_members_DP_button
dim $EE_Party_members_checkbox[7]
dim $EE_Heal_members_checkbox[7]
dim $EE_Def_members_checkbox[7]
dim $EE_Dmg_members_checkbox[7]
dim $EE_Free_members_checkbox[7]
dim $EE_SUper_members_checkbox[7]
dim $EE_ALL_members_buff_button[7]
dim $EE_DP_checkbox[7]

;SM Bot tab:
Global $SM_bot_type_help_icon, $SM_regular_bot_radio, $SM_NOVA_bot_radio, $SM_NOVA_delay_input, $SM_NOVA_delay_up_down, $SM_nova_spawn_help_icon, $SM_Main_afk_skill_input, $SM_Main_afk_skill_delay_input, $SM_Main_afk_skill_delay_up_down, $SM_Nova_skill_input, $Nova_skill_progress, $SM_afk_skill_2_checkbox, $SM_afk_skill_2_input, $SM_afk_skill2_delay_input, $SM_afk_skill_3_checkbox, $SM_afk_skill_3_input, $SM_afk_skill3_delay_input, $SM_afk_skill_4_checkbox, $SM_afk_skill_4_input, $SM_afk_skill4_delay_input, $SM_pickup_items_checkbox, $SM_skills_help_icon, $SM_Current_operation, $SM_main_afk_skill_checkbox

;BK Bot tab:
Global $BK_Main_skill_input, $BK_Main_skill_interval_input, $BK_Main_skill_interval_up_down, $BK_Skill_2_checkbox, $BK_Skill_2_input, $BK_skill_2_interval, $BK_Skill_3_checkbox, $BK_Skill_3_input, $BK_skill_3_interval, $BK_Skill_4_checkbox, $BK_Skill_4_input, $BK_skill_4_interval, $BK_skills_help_icon, $BK_Combo_skill_1_input, $BK_Combo_skill_2_input, $BK_Combo_skill_3_input, $BK_Combo_skill_1_interval, $BK_Combo_skill_2_interval, $BK_Combo_skill_3_interval, $BK_combo_help_icon, $BK_Current_operation, $BK_Pickup_items_checkbox, $BK_Combo_instructions_label, $BK_Main_skill_checkbox

;DL Bot tab:
Global $DL_Mouse_movement_vert_radio, $DL_Mouse_movement_horiz_radio, $DL_Mouse_movement_round_radio, $DL_Mouse_movement_slider, $DL_Mouse_movement_label, $DL_Main_skill_input, $DL_Skill2_checkbox, $DL_Skill2_input, $DL_Skill3_checkbox, $DL_Skill3_input, $DL_skill3_interval, $DL_Skill4_checkbox, $DL_Skill4_input, $DL_skill4_interval, $DL_pickup_items_checkbox, $DL_skills_help_icon, $DL_Current_operation, $DL_skill2_interval, $DL_speed_old, $DL_Pic_ver, $DL_Pic_Hor, $DL_Pic_Cir, $DL_Pic_Ran, $DL_Mouse_movement_random_radio, $DL_Mouse_reduce_button

;Macro bot tab:
Global $Macro_all_button, $Macro_Send_text_radio, $Macro_Alt_Number_radio, $Macro_help_icon, $MACRO_Current_operation, $Macro_interval_input
dim $Macro_checkbox[10]
dim $Macro_input[10]

;Timer tab:
Global $Timer_listview, $Timer_contextMenu, $Timer_context_Add_item, $Timer_context_Edit_item, $Timer_context_Delete_item, $Timer_Add_button, $Timer_Edit_button, $Timer_Delete_button, $Timer_Start_button, $Timer_Stop_button, $Timer_help_icon, $timer_treeview, $Form3_Add_timer_item, $Timer_check_all

;Chat tab:
Global $CHAT_nickname_input, $CHAT_keep_logs_checkbox, $CHAT_Logs_folder_input, $CHAT_browse_folder_button, $CHAT_browse_folder_button, $CHAT_Start_program_button, $CHAT_Forum_label, $CHAT_Mail_label, $Chat_view_logs_button, $CHAT_Official_Website_label, $CHAT_check_for_update_button

;Disconnect tab:
Global $Form5_DC_setup, $DC_bot_type_combo, $DC_bot_char_number_combo, $DC_Bot_realm_combo, $DC_bot_server_combo, $DC_Logs_checkbox, $DC_View_logs_button, $DC_Setup_close_button, $DC_Nickname_input, $DC_Password_input, $DC_StrID_input, $DC_GetStrID_button, $DC_Save_pair_button, $DC_Delete_pair_button, $DC_Bot_and_server_setup, $DC_User_info_help_icon, $DC_Counter_list, $DC_Start_button, $DC_Stop_button, $DC_TOTAL_help_icon

#include <Create INI Files.au3>

Global $oMyError = ObjEvent("AutoIt.Error","MyErrFunc"), $f_COMError = False

Global Const $WS_EX_COMPOSITED = -1;0x2000000

$Form1 = GUICreate($Title, 447, 200+20, -1, -1, -1, $WS_EX_COMPOSITED)
;~ GUISetFont(9, 400, -1, "Segoe UI")
GUISetBkColor(0xFFFFFF)
$position = WinGetPos($form1)
$position2 = WinGetClientSize($form1)
$light_border = ($position[2]-$position2[0])/2
$Thick_border = $position[3]-$position2[1]-$light_border
WinMove($form1, "", @DesktopWidth-$position[2]-$light_border/2, 0)
$Donate_PayPal_ico = GUICtrlCreateIcon($Icons_file, -18, 3, 202, 32, 32)
GUICtrlSetCursor(-1, 0)
GUICtrlSetTip(-1, "Thank you for donating...", "", 1, 1)
$Donate_Label = GUICtrlCreateLabel("If you support my work, feel free to donate few bucks to my PayPal account, tnx!", 42, 203, 380, 17)
GUICtrlSetColor(-1, $boje_plava_tamno)
GUICtrlSetCursor(-1, 0)
GUICtrlSetTip(-1, "Thank you for donating...", "", 1, 1)
$Donate_Smiley = GUICtrlCreateIcon($Icons_file, -17, 427, 201, 16, 16)
GUICtrlSetCursor(-1, 0)
GUICtrlSetTip(-1, "Thank you for donating...", "", 1, 1)
$Tab1 = GUICtrlCreateTab(0, 0, $position2[0], $position2[1]-20)
_General_tab()
_Options_tab()
_BOTS_tab()
_Timer_tab()
_Chat_tab()
_Disconnect_tab()
_Create_bots_tabs()
;~ if GUICtrlRead($Tab1) = 2 then
;~ 	GUISetState(@SW_SHOW, $Form2)
;~ Else
;~ 	GUISetState(@SW_HIDE, $Form2)
;~ EndIf
_Create_child_drop_items()
_Create_DC_setup_window()
_Create_PK_Tool_window()
;~ _Create_Additional_Setup_Window()
_set_names_()
_Create_shade_window_child()

;~ _add_item_child()

func _Create_bots_tabs()
	$Form2 = GUICreate("", 447, 178, 0, 22, $WS_POPUP, $WS_EX_MDICHILD, $Form1)
;~ 	WinSetTrans($form2, "", 255)
	GUISetBkColor(0xFFFFFF, $form2)
	$Tab2 = GUICtrlCreateTab(0, 0, 447, 178)
	_AE_BOT_tab()
	_EE_BOT_tab()
	_SM_BOT_tab()
	_BK_BOT_tab()
	_DL_BOT_tab()
	_Macro_BOT_tab()
	GUISetState(@SW_SHOWNOACTIVATE, $Form2)
	_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab2), IniRead($save_file, "Misc", "Sec tab", "0"))
	GUISetState(@SW_SHOWNOACTIVATE, $Form1)
	_GUICtrlTabSetCurFocus(GUICtrlGetHandle($Tab1), IniRead($save_file, "Misc", "Main tab", "0"))
EndFunc

func _check_all2($msg)
	Local $number = (Number(Dec(StringRight($msg, 4)))-($EE_ALL_members_buff_button[1]-8))/8
;~ 	MsgBox(0, (Number(Dec(StringRight($msg, 4)))), $number)
	Local $all_check = True
	if GUICtrlRead($EE_Heal_members_checkbox[$number]) = $GUI_UNCHECKED then $all_check = False
	if GUICtrlRead($EE_Def_members_checkbox[$number]) = $GUI_UNCHECKED then $all_check = False
	if GUICtrlRead($EE_Dmg_members_checkbox[$number]) = $GUI_UNCHECKED then $all_check = False
	if $all_check = False Then
		GUICtrlSetState($EE_Heal_members_checkbox[$number], $GUI_CHECKED)
		GUICtrlSetState($EE_Def_members_checkbox[$number], $GUI_CHECKED)
		GUICtrlSetState($EE_Dmg_members_checkbox[$number], $GUI_CHECKED)
	Else
		GUICtrlSetState($EE_Heal_members_checkbox[$number], $GUI_UNCHECKED)
		GUICtrlSetState($EE_Def_members_checkbox[$number], $GUI_UNCHECKED)
		GUICtrlSetState($EE_Dmg_members_checkbox[$number], $GUI_UNCHECKED)
	EndIf
EndFunc

func _check_all_ult()
	Local $all_check = True
	for $i = 1 to 6
		if GUICtrlRead($EE_Heal_members_checkbox[$i]) = $GUI_UNCHECKED Then $all_check = False
		if GUICtrlRead($EE_Def_members_checkbox[$i]) = $GUI_UNCHECKED Then $all_check = False
		if GUICtrlRead($EE_Dmg_members_checkbox[$i]) = $GUI_UNCHECKED Then $all_check = False
	Next
	if $all_check = False Then
		for $i = 1 to 6
			GUICtrlSetState($EE_Heal_members_checkbox[$i], $GUI_CHECKED)
			GUICtrlSetState($EE_Def_members_checkbox[$i], $GUI_CHECKED)
			GUICtrlSetState($EE_Dmg_members_checkbox[$i], $GUI_CHECKED)
		Next
	Else
		for $i = 1 to 6
			GUICtrlSetState($EE_Heal_members_checkbox[$i], $GUI_UNCHECKED)
			GUICtrlSetState($EE_Def_members_checkbox[$i], $GUI_UNCHECKED)
			GUICtrlSetState($EE_Dmg_members_checkbox[$i], $GUI_UNCHECKED)
		Next
	EndIf
EndFunc

func _cos($expression)
	Local $pi = 3.14159265358979
	Return Cos($pi/180*$expression)
EndFunc

func _sin($expression)
	Local $pi = 3.14159265358979
	Return Sin($pi/180*$expression)
EndFunc

func _check_all($array, $jo = 1)
	Local $all_check = True
	for $i = $jo to UBound($array)-1
		if GUICtrlRead($array[$i]) = $GUI_UNCHECKED Then $all_check = False
	Next
	if $all_check = False Then
		for $i = $jo to UBound($array)-1
			if GUICtrlRead($array[$i]) = $GUI_UNCHECKED Then GUICtrlSetState($array[$i], $GUI_CHECKED)
		Next
	Else
		for $i = $jo to UBound($array)-1
			GUICtrlSetState($array[$i], $GUI_UNCHECKED)
		Next
	EndIf
EndFunc

func _Create_child_drop_items()
	$Form_Drop_items = GUICreate("", 155, 290, 275, 131, $WS_POPUP, $WS_EX_MDICHILD, $Form1)
;~ 	WinSetTrans($Form_Drop_items, "", 255)
	GUICtrlCreateGraphic(0, 0, 155, 290, $SS_BLACKFRAME)
	GUISetBkColor(0xFFFFFF)
	GUICtrlCreateLabel("Select inventory drop fields:", 5, 5, 145, 17, $ES_CENTER)
	dim $Drop_items_field[9][9]
	Local $Drop_items_x = 11
	Local $Drop_items_y = 25
	for $i = 1 to 8
		for $j = 1 to 8
			$Drop_items_field[$i][$j] = GUICtrlCreateCheckbox("", $Drop_items_x, $Drop_items_y, 17, 17)
			GUICtrlSetState(-1, IniRead($Drop_items_File, "Coordinate", $i*8-(8-$j), "4"))
			$Drop_items_x += 17
		Next
		$Drop_items_x = 11
		$Drop_items_y += 17
	Next
	$Drop_Items_fill_random_button = GUICtrlCreateButton("Fill Random", 11, 165, 65, 21)
	$Drop_items_random_perc_input = GUICtrlCreateInput(IniRead($save_file, "Options", "Drop Items Random", "33"), 80, 165, 42, 21, $ES_NUMBER+$ES_READONLY)
	GUICtrlSetBkColor(-1, 0xFFFFFF)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 100, 0)
	GUICtrlCreateLabel("%", 128, 168, 17, 17)
	GUICtrlSetFont(-1, 10, 800)
	$Drop_items_fill_all_button = GUICtrlCreateButton("FILL ALL", 11, 190, 133, 21)
	GUICtrlCreateLabel("Drop items side:", 11, 215, 100, 17)
	$Drop_items_side_help_icon = GUICtrlCreateIcon($SHELL32, -211, 127, 213, 16, 16)
	GUICtrlSetCursor(-1, 0)
	$drop_items_side_combo = GUICtrlCreateCombo("", 11, 232, 133, -1, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "Above my Char|Bellow my Char|To the Right|To the Left|Manual (Shift+F7)", IniRead($save_file, "Options", "Drop Items Side", "To the Right"))
	$drop_items_close_button = GUICtrlCreateButton("Close", 11, 260, 133, 21)
	GUISetState(@SW_HIDE, $Form_Drop_items)
EndFunc

func _Create_DC_setup_window()
	$Form5_DC_setup = GUICreate("", 154, 160, 15, 183, $WS_POPUP, $WS_EX_MDICHILD, $Form1)
;~ 	WinSetTrans($Form5_DC_setup, "", 255)
	GUICtrlCreateGraphic(0, 0, 154, 160, $SS_BLACKFRAME)
	GUICtrlCreateLabel("BOT type:", 7, 18, 50, 17)
	$DC_bot_type_combo = GUICtrlCreateCombo("", 60, 15, 85, 20, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "AE|EE|SM|BK|DL|Macro", IniRead($save_file, "DC", "Bot type", "AE"))
	GUICtrlCreateLabel("Char. No:", 7, 18+20, 50, 17)
	$DC_bot_char_number_combo = GUICtrlCreateCombo("", 60, 15+20, 85, 20, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "1|2|3|4|5", IniRead($save_file, "DC", "Character", "1"))
	GUICtrlCreateLabel("Realm:", 7, 18+20*2, 50, 17)
	$DC_Bot_realm_combo = GUICtrlCreateCombo("", 60, 15+20*2, 85, 20, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "Valhalla|Helheim|Midgard", IniRead($save_file, "DC", "Realm", "Valhalla"))
	GUICtrlCreateLabel("Server:", 7, 18+20*3, 50, 17)
	$DC_bot_server_combo = GUICtrlCreateCombo("", 60, 15+20*3, 85, 20)
	GUICtrlSetData(-1, "1|2|3|4|5|6|7|8|9", IniRead($save_file, "DC", "Server", "1"))
	$DC_Logs_checkbox = GUICtrlCreateCheckbox("Save LOG", 7, 18+20*4+5, 70, 17)
	GUICtrlSetState(-1, IniRead($save_file, "DC", "Logs", "1"))
	$DC_View_logs_button = GUICtrlCreateButton("View LOG", 80, 15+20*4+5, 65, 20)
	$DC_Setup_close_button = GUICtrlCreateButton("Close", 11, 130, 133, 21)
	GUISetBkColor(0xFFFFFF)
	GUISetState(@SW_HIDE, $Form5_DC_setup)
EndFunc

func _Create_PK_Tool_window()
	$Form7_PkTool = GUICreate("", 200, 160, $position[2]-200-$light_border, 200+$light_border+20, $WS_POPUP, $WS_EX_MDICHILD, $Form1)
;~ 	WinSetTrans($Form7_PkTool, "", 255)
	GUICtrlCreateGraphic(0, 0, 200, 160, $SS_BLACKFRAME)

	GUICtrlCreateGroup("Instructions", 7, 7, 186, 60)
	GUICtrlCreateLabel("Activate CTRL" & @TAB & @TAB & "= F5", 25, 25, 160, 17);, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_zelena_GO)
	GUICtrlCreateLabel("Deactivate CTRL" & "     " & "= Ctrl+F5", 25, 45, 160, 17);, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Status", 7, 74, 186, 45)
	$PK_Status_label = GUICtrlCreateLabel("CTRL is UP", 15, 90, 160, 25, $ES_CENTER)
	GUICtrlSetFont(-1, 14, 800, 2, "Arial")
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	$PK_Tool_help_icon = GUICtrlCreateIcon($SHELL32, -211, 7, 125, 32, 32)
	GUICtrlSetCursor(-1, 0)
	$PK_Tool_close_button = GUICtrlCreateButton("Close", 45, 130, 145, 21)
	GUISetBkColor(0xFFFFFF)

	GUISetState(@SW_HIDE, $Form7_PkTool)
EndFunc

Func _Create_Additional_Setup_Window()
	$Form8_Add_setup = GUICreate("Additional bot options", 455+6, 310+31+60+20+110, -((461-447)/2), 60, $WS_CLIPSIBLINGS, $WS_EX_MDICHILD, $Form1)
	GUISetBkColor(0xFFFFFF)

	GUICtrlCreateGroup("Pause bot for chat:", 5, 5, 190, 40)
	$Pause_bot_when_Chat_help_icon = GUICtrlCreateIcon($SHELL32, -211, 173, 3, 16, 16)
	GUICtrlSetCursor(-1, 0)
	$Pause_bot_when_Chat_checkbox = GUICtrlCreateCheckbox("Pause bot if chat window is open", 15, 21, 177, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("If repairing, repair only this items:", 5, 50, 190, 120)
	$Repair_items[1] = GUICtrlCreateCheckbox("Helm", 15, 72-5, 49, 17)
	$Repair_items[2] = GUICtrlCreateCheckbox("Wings", 15, 88-5, 49, 17)
	$Repair_items[3] = GUICtrlCreateCheckbox("Weapon", 15, 104-5, 65, 17)
	$Repair_items[4] = GUICtrlCreateCheckbox("Armor", 15, 120-5, 49, 17)
	$Repair_items[5] = GUICtrlCreateCheckbox("Shield", 15, 136-5, 49, 17)
	$Repair_items[6] = GUICtrlCreateCheckbox("Gloves", 112, 72-5, 65, 17)
	$Repair_items[7] = GUICtrlCreateCheckbox("Pants", 112, 88-5, 49, 17)
	$Repair_items[8] = GUICtrlCreateCheckbox("Boots", 112, 104-5, 49, 17)
	$Repair_items[9] = GUICtrlCreateCheckbox("Pendant", 112, 120-5, 65, 17)
	$Repair_items[10] = GUICtrlCreateCheckbox("Left ring", 112, 136-5, 65, 17)
	$Repair_items[11] = GUICtrlCreateCheckbox("Right ring", 112, 152-5, 65, 17)
	$Repair_items[12] = GUICtrlCreateCheckbox("Horse", 15, 152-5, 49, 17)
	$Repair_all_items_button = GUICtrlCreateButton("all", 80, 152-5, 25, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	$Change_Hotkeys_button = GUICtrlCreateButton("Change the hotkeys", 5, 177, 190, 20, 0)

	GUICtrlCreateGroup("Drop items additional setup", 200, 5, 250, 110+12)
	$DropItemsDetectColorCheckbox = GUICtrlCreateCheckbox("Detect pixel's colors for dropping", 207, 24-3, 201, 17)
	$SendF6Checkbox = GUICtrlCreateCheckbox("Send F6 before dropping", 207, 40-3, 137, 17)
	$CheckInventory = GUICtrlCreateCheckbox("Check Inventory", 350, 40-4, 95, 17)
	$DontDropManaCheckbox = GUICtrlCreateCheckbox("Don't drop Mana", 207, 56-3, 97, 17)
	GUICtrlCreateLabel("Mana color:", 325, 58-3, 60, 17)
	$ManaColorInput = GUICtrlCreateInput("0x0303CD", 385, 56-3, 57, 17)
	GUICtrlSetColor(-1, 0xFFFFFF)
	GUICtrlSetBKColor(-1, 0x0303CD)
	GUICtrlSetLimit(-1, 8)
	GUICtrlCreateLabel("Pixel detection color tolerance:", 207, 78-3-2, 149, 17)
	$ColorToleranceInput = GUICtrlCreateInput("5", 368, 76-3-2, 57, 17, $ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 0)
	$CheckifItemInHandCheckbox = GUICtrlCreateCheckbox("Check if item is in hand before dropping", 207, 95-3-4, 209, 17)
	$Skill_when_drop_items = GUICtrlCreateCheckbox("Use main skill after each dropped item", 207, 105, 209, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Other:", 200, 119+10, 250, 80-5)
	$DrinkHPPotsCheckbox = GUICtrlCreateCheckbox("Drink HP pots when HP is bellow", 207, 136+3+5, 175, 17)
	$HpDrinkPcntgInput = GUICtrlCreateInput("33", 385, 136+3+5, 40, 17, $ES_NUMBER)
	GUICtrlSetColor(-1, 0xFFFFFF)
	GUICtrlSetBkColor(-1, 0xFF0000)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 90, 10)
	GUICtrlCreateLabel("%", 433, 138+3+5, 12, 17)
	GUICtrlCreateLabel("Check for HP interval", 207, 154+3+3+5, 105, 17)
	$CheckHPIntervalinput = GUICtrlCreateInput("1000", 315, 152+3+3+5, 55, 17, $ES_NUMBER)
	GUICtrlSetColor(-1, 0xFFFFFF)
	GUICtrlSetBkColor(-1, 0xFF0000)
	GUICtrlCreateUpdown(-1)
	GUICtrlCreateLabel("HP hotkey", 376, 154+3+3+5, 54, 17)
	$HPHotkeyInput = GUICtrlCreateInput("Q", 430, 152+3+3+5, 17, 17)
	GUICtrlSetColor(-1, 0xFFFFFF)
	GUICtrlSetBkColor(-1, 0xFF0000)
	GUICtrlSetLimit(-1, 1)
	$CaptureMouseCheckbox = GUICtrlCreateCheckbox("Capture mouse when bot is active", 207, 176+5, 180, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("non-GMO users:", 200, 204, 250, 70)
	$NoGGCheckbox = GUICtrlCreateCheckbox("My server have GameGuard", 207, 240-5, 153, 17)
	$HaveLauncherCheckbox = GUICtrlCreateCheckbox("My server have Launcher", 207, 256-5, 153, 17)
	$NotGMOPlayerCheckbox = GUICtrlCreateCheckbox("I AM Global Mu Online player", 207, 224-5, 169, 17)
	$ServerIPButton = GUICtrlCreateButton("Server IP setup", 392-15, 224-5, 67, 49, $BS_MULTILINE)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Click delays [milisec]:", 5, 204, 190, 70)
	GUICtrlCreateLabel("Keyboard keys delay:", 15, 224-5, 110, 17)
	$KeyboardDelayInput = GUICtrlCreateInput("300", 135, 219, 50, 17, $ES_NUMBER)
	GUICtrlCreateUpdown(-1)
	GUICtrlCreateLabel("Mouse clicks delay:", 15, 240-5, 110, 17)
	$MouseDelayInput = GUICtrlCreateInput("300", 135, 235, 50, 17, $ES_NUMBER)
	GUICtrlCreateUpdown(-1)
	GUICtrlCreateLabel("Repair/drop click delay:", 15, 256-5, 117, 17)
	$DropRepairDelayInput = GUICtrlCreateInput("300", 135, 251, 50, 17, $ES_NUMBER)
	GUICtrlCreateUpdown(-1)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("AG related stuff", 5, 280-3, 445, 55)
	$CheckAGCheckbox = GUICtrlCreateCheckbox("Check for AG (and switch skills as AG change) each [ms]:", 15, 295-3, 290, 17)
	$ChecKAGIntervalInput = GUICtrlCreateInput("", 305, 294-3, 55, 17, $ES_NUMBER)
	GUICtrlCreateUpdown(-1)
	GUICtrlCreateLabel("When AG is bellow", 15, 314-3, 100, 17)
	$CheckAGLowPcntgInput = GUICtrlCreateInput("", 110, 312-3, 40, 17, $ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 90, 10)
	GUICtrlCreateLabel("%, use skill", 155, 314-3, 60, 17)
	$CheckAGskill2Input = GUICtrlCreateInput("", 210, 312-3, 30, 17)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	GUICtrlCreateLabel(", when it's back to", 243, 314-3, 90, 17)
	$CheckAGhighPcntgInput = GUICtrlCreateInput("", 335, 312-3, 40, 17, $ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 90, 10)
	GUICtrlCreateLabel("% use", 377, 314-3, 29, 17)
	$CheckAGskill1Input = GUICtrlCreateInput("", 410, 312-3, 30, 17)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Isolate sounds", 5, 280-5+60, 445, 55)
	$IsoSoundJewelChck = GUICtrlCreateCheckbox("Jewel", 15, 294-5+60, 47, 17)
	$IsoSoundJewelBtn = GUICtrlCreateButton("Test", 15, 294-5+78, 47, 17)
	$IsoSoundMailChck = GUICtrlCreateCheckbox("Mail", 15+60-3*1, 294-5+60, 47, 17)
	$IsoSoundMailBtn = GUICtrlCreateButton("Test", 15+60-3*1, 294-5+78, 47, 17)
	$IsoSoundWhispChck = GUICtrlCreateCheckbox("Whisper", 15+60*2-3*2, 294-5+60, 60, 17)
	$IsoSoundWhispBtn = GUICtrlCreateButton("Test", 15+60*2-3*2, 294-5+78, 60, 17)
	$IsoSoundGemChck = GUICtrlCreateCheckbox("Gemstone", 15+60*2+70-3*3, 294-5+60, 65, 17)
	$IsoSoundGemBtn = GUICtrlCreateButton("Test", 15+60*2+70-3*3, 294-5+78, 65, 17)
	$IsoSoundLVLUPChck = GUICtrlCreateCheckbox("Lvl UP", 15+60*2+70+75-3*4, 294-5+60, 55, 17)
	$IsoSoundLVLUPBtn = GUICtrlCreateButton("Test", 15+60*2+70+75-3*4, 294-5+78, 55, 17)
	$IsoSoundMaleDieChck = GUICtrlCreateCheckbox("Male die", 15+60*2+70+75+65-3*5, 294-5+60, 55, 17)
	$IsoSoundMaleDieBtn = GUICtrlCreateButton("Test", 15+60*2+70+75+65-3*5, 294-5+78, 55, 17)
	$IsoSoundBeepChck = GUICtrlCreateCheckbox("Beep", 15+60*2+70+75+65*2-3*6, 294-5+60, 47, 17)
	$IsoSoundBeepBtn = GUICtrlCreateButton("Test", 15+60*2+70+75+65*2-3*6, 294-5+78, 47, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Ignore drop of these colors (when dropping items)", 5, 280-5+60+60, 445, 45)
	For $i = 1 to 5
		$IsoDropChk[$i] = GUICtrlCreateCheckbox("", 15+($i-1)*88, 300-5+60*2, 17, 17)
		$IsoDropInp[$i] = GUICtrlCreateInput("0x000000", 15+16+($i-1)*88, 300-5+60*2, 57, 17)
		GUICtrlSetColor(-1, 0xFFFFFF)
		GUICtrlSetBKColor(-1, 0x000000)
		GUICtrlSetLimit(-1, 8)
	Next
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	Local $move_down = 125

	$Force_Mu_active_checkbox = GUICtrlCreateCheckbox("Detect if a MU window is not currently active window and set it as active each", 5, 280+37+$move_down, 387, 17)
	$Force_Mu_active_timer = GUICtrlCreateInput("1000", 395, 280+37+$move_down, 55, 17, $ES_NUMBER)
	GUICtrlCreateUpdown(-1)

	GUICtrlCreateLabel("If you don't understand what any of these setups are and what they do, don't touch anything!", 5, 280+60+$move_down, 230, 35)
	GUICtrlSetColor(-1, 0xFF0000)

	$AcceptAddSetupButton = GUICtrlCreateButton("Apply", 378-80, 280+60+$move_down, 75)
	$KillAddSetupButton = GUICtrlCreateButton("Cancel", 375, 280+60+$move_down, 75)
	_Load_Additional_setup_data()

	GUISetState(@SW_DISABLE, $Form1)
	GUISetState(@SW_SHOW, $Form_4_shade)
	GUISetState(@SW_SHOW, $Form8_add_setup)

	_unload_hotkeys()

;~ 	GUISetState(@SW_SHOW);, $Form8_add_setup)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $ManaColorInput
				GUICtrlSetBkColor($ManaColorInput, GUICtrlRead($ManaColorInput))
			Case $IsoDropInp[1] to $IsoDropInp[5]
				Local $numbb = ($nMsg-($IsoDropInp[1]-2))/2
;~ 				MsgBox(0, "", $numbb)
				GUICtrlSetBkColor($IsoDropInp[$numbb], GUICtrlRead($IsoDropInp[$numbb]))
			Case $GUI_EVENT_CLOSE, $KillAddSetupButton
				_Load_Hotkeys()
;~ 				_set_jewel_status_in_opt()
				GUISetState(@SW_HIDE, $Form_4_shade)
				GUISetState(@SW_ENABLE, $Form1)
				GUIDelete($Form8_add_setup)
				if NOT WinActive($form1) then WinActivate($Form1)
				ExitLoop
			Case $AcceptAddSetupButton
				_Load_Hotkeys()
				_Save_Additional_Setup_data()
				_set_jewel_status_in_opt()
				GUISetState(@SW_HIDE, $Form_4_shade)
				GUISetState(@SW_ENABLE, $Form1)
				GUIDelete($Form8_add_setup)
				if NOT WinActive($form1) then WinActivate($Form1)
				ExitLoop
		EndSwitch
	WEnd
EndFunc

Func _set_jewel_status_in_opt()
	Local $jewel_sound_status = _jewel_sound_status()
	Local $button_name = "Isolate", $status_jewel = "Sounds NOT isolated", $status_color = $boje_crvena_STOP
	if $jewel_sound_status = 1 then
		$button_name = "Return original"
		$status_jewel = "Sound are isolated"
		$status_color = $boje_zelena_GO
	ElseIf $jewel_sound_status = 2 Then
		$button_name = "Return original"
		$status_jewel = "Partially    isolated"
		$status_color = 0xFF8000
	EndIf
	GUICtrlSetData($Isolate_jewel_button, $button_name)
	GUICtrlSetData($Isolate_jewel_status, $status_jewel)
	GUICtrlSetColor($Isolate_jewel_status, $status_color)
EndFunc

Func _set_the_mouse_reduction($type)
	Local $old_reading_mouse_movement = 0
	Local $old_reading_mouse_movement2 = 0
	If $type = "AE" Then
		Local $get_cur_red = Number(IniRead($Save_file, "AE Bot", "Movement reduction", "0"))
		Local $size_yy = 60
		Local $x_poz = 170
		Local $y_poz = 140
		Local $buttons_disp = 0
		Local $additional_disp = 0
	Else ;DL
		Local $get_cur_red = Number(IniRead($Save_file, "DL Bot", "Movement reduction", "-10"))
		Local $get_cur_red2 = Number(IniRead($Save_file, "DL Bot", "Movement reduction2", "-10"))
		Local $size_yy = 100
		Local $x_poz = 95
		Local $y_poz = 112
		Local $buttons_disp = 40
		Local $additional_disp = 9
	EndIf
	Local $form9_reduce_mouse = GUICreate("", 200+$buttons_disp+$additional_disp, $size_yy, $x_poz, $y_poz, $WS_POPUP, $WS_EX_MDICHILD, $form1)
	GUICtrlCreateGraphic(0, 0, 200+$buttons_disp+$additional_disp, $size_yy, 0x07);$SS_BLACKFRAME)
	GUICtrlCreateLabel("Reduce mouse movement:", 1, 3, 149, 17, 0x0001)
	Local $mouse_movement_slider = GUICtrlCreateSlider(8+8, 17, 150-8-7, 40, 0x0008)
	GUICtrlSetLimit(-1, 400, 0)
	GUICtrlSetData(-1, $get_cur_red+200)
	GUICtrlSetBkColor(-1, 0xFFFFFF)
	Local $Mouse_movement_input = GUICtrlCreateInput($get_cur_red, 150, 2+$buttons_disp/2, 48, 17, 0x0800)
	GUICtrlSetLimit(-1, 3)
	Local $Mouse_movement_up_down = GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 200, -200)

	If $type <> "AE" Then
		GUICtrlCreateLabel(" x:", 5, 28, 18, 17)
		GUICtrlCreateLabel(" y:", 5, 28+40, 18, 17)
		Local $mouse_movement_slider2 = GUICtrlCreateSlider(8+8, 17+40, 150-8-7, 40, 0x0008)
		GUICtrlSetLimit(-1, 400, 0)
		GUICtrlSetData(-1, $get_cur_red2+200)
		GUICtrlSetBkColor(-1, 0xFFFFFF)
		Local $Mouse_movement_input2 = GUICtrlCreateInput($get_cur_red2, 150, 62, 48, 17, 0x0800)
		GUICtrlSetLimit(-1, 3)
		Local $Mouse_movement_up_down2 = GUICtrlCreateUpdown(-1)
		GUICtrlSetLimit(-1, 200, -200)
	EndIf

	Local $ok_form9_button = GUICtrlCreateButton("OK", 150+$buttons_disp+$additional_disp, 19+$buttons_disp, 49, 20)
	Local $cancel_form9_button = GUICtrlCreateButton("Cancel", 150+$buttons_disp+$additional_disp, 39+$buttons_disp, 49, 20)
	GUISetBkColor(0xFFFFFF, $form9_reduce_mouse)
	GUISetState(@SW_DISABLE, $Form1)
	GUISetState(@SW_SHOW, $Form_4_shade)
	GUISetState(@SW_SHOW, $form9_reduce_mouse)

	While 1
		Local $new_reading_mouse_movement = GUICtrlRead($mouse_movement_slider)
		If $new_reading_mouse_movement <> $old_reading_mouse_movement Then
			$old_reading_mouse_movement = $new_reading_mouse_movement
			GUICtrlSetData($Mouse_movement_input, $new_reading_mouse_movement-200)
		EndIf
		$nMsg = GUIGetMsg()
		If $type <> "AE" Then
			Local $new_reading_mouse_movement2 = GUICtrlRead($mouse_movement_slider2)
			If $new_reading_mouse_movement2 <> $old_reading_mouse_movement2 Then
				$old_reading_mouse_movement2 = $new_reading_mouse_movement2
				GUICtrlSetData($Mouse_movement_input2, $new_reading_mouse_movement2-200)
			EndIf
			If $nMsg = $Mouse_movement_up_down2 then GUICtrlSetData($mouse_movement_slider2, GUICtrlRead($Mouse_movement_input2)+200)
		EndIf
		Switch $nMsg
			Case $Mouse_movement_up_down
				GUICtrlSetData($mouse_movement_slider, GUICtrlRead($Mouse_movement_input)+200)
;~ 			Case $Mouse_movement_up_down2
;~ 				GUICtrlSetData($mouse_movement_slider2, GUICtrlRead($Mouse_movement_input2)+200)
			Case $ok_form9_button
				IniWrite($Save_file, $type & " Bot", "Movement reduction", GUICtrlRead($Mouse_movement_input))
				If $type <> "AE" Then IniWrite($Save_file, $type & " Bot", "Movement reduction2", GUICtrlRead($Mouse_movement_input2))
				GUISetState(@SW_HIDE, $Form_4_shade)
				GUISetState(@SW_ENABLE, $Form1)
				GUIDelete($form9_reduce_mouse)
				if NOT WinActive($form1) then WinActivate($Form1)
				ExitLoop
			Case $cancel_form9_button
				GUISetState(@SW_HIDE, $Form_4_shade)
				GUISetState(@SW_ENABLE, $Form1)
				GUIDelete($form9_reduce_mouse)
				if NOT WinActive($form1) then WinActivate($Form1)
				ExitLoop
		EndSwitch
	WEnd
EndFunc

Func _Save_Additional_Setup_data()
	IniWrite($save_file, "Options", "CheckForEnterPause", GUICtrlRead($Pause_bot_when_Chat_checkbox))
	Local $repair_this = ""
	For $i = 1 to 12
		If GUICtrlRead($Repair_items[$i]) = $GUI_CHECKED then $repair_this &= $i & ";"
	Next
	IniWrite($save_file, "Misc", "Repair items", StringTrimRight($repair_this, 1))
	IniWrite($save_file, "Misc", "ColorDetectDrop", GUICtrlRead($DropItemsDetectColorCheckbox))
	IniWrite($save_file, "Misc", "F6BeforeDrop", GUICtrlRead($SendF6Checkbox))
	IniWrite($save_file, "Misc", "DontDropMana", GUICtrlRead($DontDropManaCheckbox))
	IniWrite($save_file, "Misc", "ManaColor", GUICtrlRead($ManaColorInput))
	IniWrite($save_file, "Misc", "DropColorTolerance", GUICtrlRead($ColorToleranceInput))
	IniWrite($save_file, "Misc", "DropCheckIfItemIsInHand", GUICtrlRead($CheckifItemInHandCheckbox))
	IniWrite($save_file, "Misc", "Detect Inventory", GUICtrlRead($CheckInventory))
	IniWrite($save_file, "Misc", "Drink HP", GUICtrlRead($DrinkHPPotsCheckbox))
	IniWrite($save_file, "Misc", "Drink HP when HP% is", GUICtrlRead($HpDrinkPcntgInput))
	IniWrite($save_file, "Misc", "HP Pots hotkey", GUICtrlRead($HPHotkeyInput))
	IniWrite($save_file, "Misc", "Check 4 HP interval", GUICtrlRead($CheckHPIntervalinput))
	IniWrite($save_file, "Misc", "Capture Mouse", GUICtrlRead($CaptureMouseCheckbox))
	IniWrite($DC_File, "Options", "Have GG", GUICtrlRead($NoGGCheckbox))
	IniWrite($DC_File, "Options", "Have launcher", GUICtrlRead($HaveLauncherCheckbox))
	IniWrite($DC_File, "Options", "GMO Server", GUICtrlRead($NotGMOPlayerCheckbox))
	IniWrite($save_file, "Misc", "KeyboardDelay", GUICtrlRead($KeyboardDelayInput))
	IniWrite($save_file, "Misc", "MouseDelay", GUICtrlRead($MouseDelayInput))
	IniWrite($save_file, "Misc", "RepairDropClickDelay", GUICtrlRead($DropRepairDelayInput))
	IniWrite($save_file, "Options", "Use Skill While Drop", GUICtrlRead($Skill_when_drop_items))
	IniWrite($save_file, "Misc", "Check AG", GUICtrlRead($CheckAGCheckbox))
	IniWrite($save_file, "Misc", "Check AG interval", GUICtrlRead($ChecKAGIntervalInput))
	IniWrite($save_file, "Misc", "Check AG recharge%", GUICtrlRead($CheckAGLowPcntgInput))
	IniWrite($save_file, "Misc", "Check AG high%", GUICtrlRead($CheckAGhighPcntgInput))
	IniWrite($save_file, "Misc", "AG Skill 2", GUICtrlRead($CheckAGskill2Input))
	IniWrite($save_file, "Misc", "AG Skill 1", GUICtrlRead($CheckAGskill1Input))
	IniWrite($save_file, "Misc", "CheckIfMuIsActive", GUICtrlRead($Force_Mu_active_checkbox))
	IniWrite($save_file, "Misc", "CheckIfMuIsActiveInv", GUICtrlRead($Force_Mu_active_timer))

	IniWrite($save_file, "Misc", "IsoSoundJewel", GUICtrlRead($IsoSoundJewelChck))
	IniWrite($save_file, "Misc", "IsoSoundMailChck", GUICtrlRead($IsoSoundMailChck))
	IniWrite($save_file, "Misc", "IsoSoundWhispChck", GUICtrlRead($IsoSoundWhispChck))
	IniWrite($save_file, "Misc", "IsoSoundGemChck", GUICtrlRead($IsoSoundGemChck))
	IniWrite($save_file, "Misc", "IsoSoundLVLUPChck", GUICtrlRead($IsoSoundLVLUPChck))
	IniWrite($save_file, "Misc", "IsoSoundMaleDieChck", GUICtrlRead($IsoSoundMaleDieChck))
	IniWrite($save_file, "Misc", "IsoSoundBeepChck", GUICtrlRead($IsoSoundBeepChck))

	For $i = 1 to 5
		IniWrite($save_file, "Misc", "IsoDropChk" & $i, GUICtrlRead($IsoDropChk[$i]))
		IniWrite($save_file, "Misc", "IsoDropCol" & $i, GUICtrlRead($IsoDropInp[$i]))
	Next

	Opt ("MouseClickDownDelay", IniRead($Save_file, "Misc", "MouseDelay", GUICtrlRead($MouseDelayInput)))
	Opt ("MouseClickDelay", IniRead($Save_file, "Misc", "MouseDelay", GUICtrlRead($MouseDelayInput)))
	Opt ("SendKeyDownDelay", IniRead($Save_file, "Misc", "KeyboardDelay", GUICtrlRead($KeyboardDelayInput)))
	Opt ("SendKeyDelay", IniRead($Save_file, "Misc", "KeyboardDelay", GUICtrlRead($KeyboardDelayInput)))
	$Mouse_Down_Click = GUICtrlRead($DropRepairDelayInput)
	$checkifmuisactiveini = IniRead($save_file, "Misc", "CheckIfMuIsActive", "4")
	$check4pauseIni = IniRead($save_file, "Misc", "CheckForEnterPause", "1")
;~ 	_Load_Hotkeys()
EndFunc

Func _ArraySearch_Ex($array, $search_string)
	Local $ret_val = -1
	For $i = 1 to UBound($array)-1
		If $array[$i] = $search_string Then
			$ret_val = $i
			ExitLoop
		EndIf
	Next
	Return $ret_val
EndFunc

Func _Load_Additional_setup_data()
	GUICtrlSetState($Pause_bot_when_Chat_checkbox, IniRead($save_file, "Options", "CheckForEnterPause", "1"))
	Local $repair_this = IniRead($save_file, "Misc", "Repair items", "1;2;3;4;5;6;7;8;9;10;11")
	$repair_this = StringSplit($repair_this, ";")
;~ 	_ArrayDisplay($repair_this)
	For $i = 1 to 12
		If _ArraySearch_Ex($repair_this, $i) <> -1 then GUICtrlSetState($Repair_items[$i], $GUI_CHECKED)
	Next
	GUICtrlSetState($DropItemsDetectColorCheckbox, IniRead($save_file, "Misc", "ColorDetectDrop", "1"))
	GUICtrlSetState($SendF6Checkbox, IniRead($save_file, "Misc", "F6BeforeDrop", "0"))
	GUICtrlSetState($DontDropManaCheckbox, IniRead($save_file, "Misc", "DontDropMana", "1"))
	GUICtrlSetData($ManaColorInput, IniRead($save_file, "Misc", "ManaColor", "0x0303CD"))
	GUICtrlSetBKColor($ManaColorInput, IniRead($save_file, "Misc", "ManaColor", "0x0303CD"))
	GUICtrlSetData($ColorToleranceInput, IniRead($save_file, "Misc", "DropColorTolerance", "5"))
	GUICtrlSetState($CheckifItemInHandCheckbox, IniRead($save_file, "Misc", "DropCheckIfItemIsInHand", "1"))
	GUICtrlSetState($CheckInventory, IniRead($save_file, "Misc", "Detect Inventory", "1"))
	GUICtrlSetState($DrinkHPPotsCheckbox, IniRead($save_file, "Misc", "Drink HP", "4"))
	GUICtrlSetData($HpDrinkPcntgInput, IniRead($save_file, "Misc", "Drink HP when HP% is", "33"))
	GUICtrlSetData($HPHotkeyInput, IniRead($save_file, "Misc", "HP Pots hotkey", "Q"))
	GUICtrlSetData($CheckHPIntervalinput, IniRead($save_file, "Misc", "Check 4 HP interval", "1000"))
	GUICtrlSetState($CaptureMouseCheckbox, IniRead($save_file, "Misc", "Capture Mouse", "1"))
	GUICtrlSetState($NoGGCheckbox, IniRead($DC_File, "Options", "Have GG", "1"))
	GUICtrlSetState($HaveLauncherCheckbox, IniRead($DC_File, "Options", "Have launcher", "1"))
	GUICtrlSetState($NotGMOPlayerCheckbox, IniRead($DC_File, "Options", "GMO Server", "1"))
	GUICtrlSetData($KeyboardDelayInput, IniRead($save_file, "Misc", "KeyboardDelay", $default_sleep_for_opts))
	GUICtrlSetData($MouseDelayInput, IniRead($save_file, "Misc", "MouseDelay", $default_sleep_for_opts))
	GUICtrlSetData($DropRepairDelayInput, IniRead($save_file, "Misc", "RepairDropClickDelay", "500"))
	GUICtrlSetState($Skill_when_drop_items, IniRead($save_file, "Options", "Use Skill While Drop", "1"))
	GUICtrlSetState($CheckAGCheckbox, IniRead($save_file, "Misc", "Check AG", "4"))
	GUICtrlSetData($ChecKAGIntervalInput, IniRead($save_file, "Misc", "Check AG interval", "1000"))
	GUICtrlSetData($CheckAGLowPcntgInput, IniRead($save_file, "Misc", "Check AG recharge%", "10"))
	GUICtrlSetData($CheckAGhighPcntgInput, IniRead($save_file, "Misc", "Check AG high%", "90"))
	GUICtrlSetData($CheckAGskill2Input, IniRead($save_file, "Misc", "AG Skill 2", "2"))
	GUICtrlSetData($CheckAGskill1Input, IniRead($save_file, "Misc", "AG Skill 1", "1"))
	GUICtrlSetState($Force_Mu_active_checkbox, IniRead($save_file, "Misc", "CheckIfMuIsActive", "4"))
	GUICtrlSetData($Force_Mu_active_timer, IniRead($save_file, "Misc", "CheckIfMuIsActiveInv", "1000"))

	GUICtrlSetState($IsoSoundJewelChck, IniRead($save_file, "Misc", "IsoSoundJewel", "1"))
	GUICtrlSetState($IsoSoundMailChck, IniRead($save_file, "Misc", "IsoSoundMailChck", "4"))
	GUICtrlSetState($IsoSoundWhispChck, IniRead($save_file, "Misc", "IsoSoundWhispChck", "4"))
	GUICtrlSetState($IsoSoundGemChck, IniRead($save_file, "Misc", "IsoSoundGemChck", "4"))
	GUICtrlSetState($IsoSoundLVLUPChck, IniRead($save_file, "Misc", "IsoSoundLVLUPChck", "4"))
	GUICtrlSetState($IsoSoundMaleDieChck, IniRead($save_file, "Misc", "IsoSoundMaleDieChck", "4"))
	GUICtrlSetState($IsoSoundBeepChck, IniRead($save_file, "Misc", "IsoSoundBeepChck", "4"))

	For $i = 1 to 5
		GUICtrlSetState($IsoDropChk[$i], IniRead($save_file, "Misc", "IsoDropChk" & $i, "4"))
		GUICtrlSetData($IsoDropInp[$i], IniRead($save_file, "Misc", "IsoDropCol" & $i, "0x000000"))
		GUICtrlSetBkColor($IsoDropInp[$i], GUICtrlRead($IsoDropInp[$i]))
	Next
EndFunc

Func _sound_destination()
	if GUICtrlRead($destination_input) = "" Then
		MsgBox(0, "Error", "Please setup MU destination on the General tab.")
		Return 0
	EndIf
	dim $return_value[2]
	Local $splitting = StringSplit(GUICtrlRead($destination_input), "\")
	for $i = 1 to $splitting[0]-1
		$return_value[0] &= $splitting[$i] & "\"
	Next
	$return_value[0] &= "Data\Sound"
	$return_value[1] = $return_value[0] & "8"
	Return $return_value
EndFunc

Func _jewel_sound_status()
	Local $sound_destination_x = _sound_destination()
	if $sound_destination_x = 0 then Return 0
	Local $sound_destination = $sound_destination_x[0], $sound8_destination = $sound_destination_x[1], $isolated = 0
	Local $Counter = 0
	Local $sound_status = 1
	Local $file_sound_list = _FileListToArray($sound_destination)
	if @error then
		DirCreate($sound_destination)
		FileCopy($sound8_destination & "\eGem.wav", $sound_destination, 1)
		$file_sound_list = _FileListToArray($sound_destination)
		if @error then Return 0
	EndIf
	If _ArraySearch_Ex($file_sound_list, "eGem.wav") <> -1 then
;~ 	If IniRead($save_file, "Misc", "IsoSoundJewel", "1") = "1" Then
		$Counter += 1
		If IniRead($save_file, "Misc", "IsoSoundJewel", "1") = "1" Then
;~ 		If _ArraySearch_Ex($file_sound_list, "eGem.wav") <> -1 then
;~ 			If $sound_status = 1
		Else
			$sound_status = 0
		EndIf
	Else
		If IniRead($save_file, "Misc", "IsoSoundJewel", "1") = "1" Then $sound_status = 0
	EndIf
	If _ArraySearch_Ex($file_sound_list, "iFMailAlert.wav") <> -1 then
;~ 	If IniRead($save_file, "Misc", "IsoSoundMailChck", "4") = "1" Then
		$Counter += 1
		If IniRead($save_file, "Misc", "IsoSoundMailChck", "4") = "1" Then
;~ 		If _ArraySearch_Ex($file_sound_list, "iFMailAlert.wav") <> -1 then
;~ 			$sound_status = 1
		Else
			$sound_status = 0
		EndIf
	Else
		If IniRead($save_file, "Misc", "IsoSoundMailChck", "4") = "1" Then $sound_status = 0
	EndIf
	If _ArraySearch_Ex($file_sound_list, "iWhisper.wav") <> -1 then
;~ 	If IniRead($save_file, "Misc", "IsoSoundWhispChck", "4") = "1" Then
		$Counter += 1
		If IniRead($save_file, "Misc", "IsoSoundWhispChck", "4") = "1" Then
;~ 		If _ArraySearch_Ex($file_sound_list, "iWhisper.wav") <> -1 then
;~ 			$sound_status = 1
		Else
			$sound_status = 0
		EndIf
	Else
		If IniRead($save_file, "Misc", "IsoSoundWhispChck", "4") = "1" Then $sound_status = 0
	EndIf
	If _ArraySearch_Ex($file_sound_list, "Jewel_Sound.wav") <> -1 then
		$Counter += 1
		If IniRead($save_file, "Misc", "IsoSoundGemChck", "4") = "1" Then
;~ 			$sound_status = 1
		Else
			$sound_status = 0
		EndIf
	Else
		If IniRead($save_file, "Misc", "IsoSoundGemChck", "4") = "1" Then $sound_status = 0
	EndIf
	If _ArraySearch_Ex($file_sound_list, "pLevelUp.wav") <> -1 then
		$Counter += 1
		If IniRead($save_file, "Misc", "IsoSoundLVLUPChck", "4") = "1" Then
;~ 			$sound_status = 1
		Else
			$sound_status = 0
		EndIf
	Else
		If IniRead($save_file, "Misc", "IsoSoundLVLUPChck", "4") = "1" Then $sound_status = 0
	EndIf
	If _ArraySearch_Ex($file_sound_list, "pMaleDie.wav") <> -1 then
		$Counter += 1
		If IniRead($save_file, "Misc", "IsoSoundMaleDieChck", "4") = "1" Then
;~ 			$sound_status = 1
		Else
			$sound_status = 0
		EndIf
	Else
		If IniRead($save_file, "Misc", "IsoSoundMaleDieChck", "4") = "1" Then $sound_status = 0
	EndIf
	If _ArraySearch_Ex($file_sound_list, "beep.wav") <> -1 then
		$Counter += 1
		If IniRead($save_file, "Misc", "IsoSoundBeepChck", "4") = "1" Then
;~ 			$sound_status = 1
		Else
			$sound_status = 0
		EndIf
	Else
		If IniRead($save_file, "Misc", "IsoSoundBeepChck", "4") = "1" Then $sound_status = 0
	EndIf
;~ 	MsgBox(0, "", $file_sound_list[0] & @CRLF & $Counter & @CRLF & $sound_status)
	If $file_sound_list[0] = $Counter Then
		If $sound_status = 1 Then
			Return 1
		Else
			Return 2
		EndIf
	Else
		If $sound_status = 1 Then
			Return 2
		Else
			Return 0
		EndIf
	EndIf
;~ 	if $file_sound_list[0] = 1 AND $file_sound_list[1] = "eGem.wav" then $isolated = 1
;~ 	Return $isolated
EndFunc

Func _test_play($filename)
	Local $sound_destination_x = _sound_destination()
	if $sound_destination_x = 0 then Return 0
	Local $sound_destination = $sound_destination_x[0], $sound8_destination = $sound_destination_x[1];, $isolated = false
	If FileExists($sound_destination & "\" & $filename) Then
		SoundPlay($sound_destination & "\" & $filename, 1)
	Else
		SoundPlay($sound8_destination & "\" & $filename, 1)
	EndIf
EndFunc

func _isolate_jewel_sound()
	Local $sound_destination_x = _sound_destination()
	if $sound_destination_x = 0 then Return 0
	Local $sound_destination = $sound_destination_x[0], $sound8_destination = $sound_destination_x[1];, $isolated = false
	Local $isolated = _jewel_sound_status()
	DirCreate($sound8_destination)
	if $isolated = 0 Then ;izolacija:
		DirMove($sound_destination, $sound_destination & "5")
		DirMove($sound8_destination, $sound_destination)
		DirMove($sound_destination & "5", $sound8_destination)
		GUICtrlSetData($Isolate_jewel_status, "Sounds are isolated")
		GUICtrlSetColor($Isolate_jewel_status, $boje_zelena_GO)
		GUICtrlSetData($Isolate_jewel_button, "Return original")

		If IniRead($save_file, "Misc", "IsoSoundJewel", "1") = "1" Then
			FileCopy($sound8_destination & "\eGem.wav", $sound_destination, 1)
		Else
			FileDelete($sound_destination & "\eGem.wav")
		EndIf
		If IniRead($save_file, "Misc", "IsoSoundMailChck", "4") = "1" Then
			FileCopy($sound8_destination & "\iFMailAlert.wav", $sound_destination, 1)
		Else
			FileDelete($sound_destination & "\iFMailAlert.wav")
		EndIf
		If IniRead($save_file, "Misc", "IsoSoundWhispChck", "4") = "1" Then
			FileCopy($sound8_destination & "\iWhisper.wav", $sound_destination, 1)
		Else
			FileDelete($sound_destination & "\iWhisper.wav")
		EndIf
		If IniRead($save_file, "Misc", "IsoSoundGemChck", "4") = "1" Then
			FileCopy($sound8_destination & "\Jewel_Sound.wav", $sound_destination, 1)
		Else
			FileDelete($sound_destination & "\Jewel_Sound.wav")
		EndIf
		If IniRead($save_file, "Misc", "IsoSoundLVLUPChck", "4") = "1" Then
			FileCopy($sound8_destination & "\pLevelUp.wav", $sound_destination, 1)
		Else
			FileDelete($sound_destination & "\pLevelUp.wav")
		EndIf
		If IniRead($save_file, "Misc", "IsoSoundMaleDieChck", "4") = "1" Then
			FileCopy($sound8_destination & "\pMaleDie.wav", $sound_destination, 1)
		Else
			FileDelete($sound_destination & "\pMaleDie.wav")
		EndIf
		If IniRead($save_file, "Misc", "IsoSoundBeepChck", "4") = "1" Then
			FileCopy($sound8_destination & "\beep.wav", $sound_destination, 1)
		Else
			FileDelete($sound_destination & "\beep.wav")
		EndIf

		RegWrite($MU_REG_CONFIG, "MusicOnOff", "REG_DWORD", "0")
		GUICtrlSetState($Music_checkbox, $GUI_UNCHECKED)
		RegWrite($MU_REG_CONFIG, "SoundOnOff", "REG_DWORD", "1")
		GUICtrlSetState($Sound_checkbox, $GUI_CHECKED)
		RegWrite($MU_REG_CONFIG, "VolumeLevel", "REG_DWORD", "9")
;~ 		GUICtrlSetData($Volume_Slider, 10)
;~ 		GUICtrlSetData($Volume_status, "10")
;~ 		_test_play("eGem.wav")
		If FileExists($sound_destination & "\eGem.wav") then
			SoundPlay($sound_destination & "\eGem.wav", 1)
		Else
			SoundPlay($sound8_destination & "\eGem.wav", 1)
		EndIf
	Else;If $isolated = 1 then ;vracanje originala
		DirMove($sound_destination, $sound_destination & "5")
		DirMove($sound8_destination, $sound_destination)
		DirMove($sound_destination & "5", $sound8_destination)
		If IniRead($save_file, "Misc", "IsoSoundJewel", "1") = "1" Then FileCopy($sound8_destination & "\eGem.wav", $sound_destination, 1)
		If IniRead($save_file, "Misc", "IsoSoundMailChck", "4") = "1" Then FileCopy($sound8_destination & "\iFMailAlert.wav", $sound_destination, 1)
		If IniRead($save_file, "Misc", "IsoSoundWhispChck", "4") = "1" Then FileCopy($sound8_destination & "\iWhisper.wav", $sound_destination, 1)
		If IniRead($save_file, "Misc", "IsoSoundGemChck", "4") = "1" Then FileCopy($sound8_destination & "\Jewel_Sound.wav", $sound_destination, 1)
		If IniRead($save_file, "Misc", "IsoSoundLVLUPChck", "4") = "1" Then FileCopy($sound8_destination & "\pLevelUp.wav", $sound_destination, 1)
		If IniRead($save_file, "Misc", "IsoSoundMaleDieChck", "4") = "1" Then FileCopy($sound8_destination & "\pMaleDie.wav", $sound_destination, 1)
		If IniRead($save_file, "Misc", "IsoSoundBeepChck", "4") = "1" Then FileCopy($sound8_destination & "\beep.wav", $sound_destination, 1)
		GUICtrlSetData($Isolate_jewel_status, "Sounds NOT isolated")
		GUICtrlSetColor($Isolate_jewel_status, $boje_crvena_STOP)
		GUICtrlSetData($Isolate_jewel_button, "Isolate")
;~ 	Else
;~ 		MsgBox(0, "", "dirt")
	EndIf
	Return 0
EndFunc

func _General_tab()
	Local $rezolucija=RegRead($MU_REG_CONFIG, "Resolution")
	Local $rez
	if $rezolucija=0 Then
		$rez="640x480"
	elseif $rezolucija=1 Then
		$rez="800x600"
	elseif $rezolucija=2 Then
		$rez="1024x768"
	Else
		$rez="1280x1024"
	EndIf
	$General_tab = GUICtrlCreateTabItem("General")
	GUICtrlSetImage(-1, $Icons_file, -7)
	GUICtrlCreateGroup("Resolution", 7, 25+5, 121, 45)
	$Resolution_combo = GUICtrlCreateCombo("", 15, 40+5, 105, -1, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "800x600|1024x768|1280x1024", $rez)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
	GUICtrlCreateGroup("MU Destination", 137, 25+5, 300, 45)
	$destination_input = GUICtrlCreateInput(RegRead($MU_REG_CONFIG, "Exe"), 145, 40+5, 260, 21)
	$destination_browse = GUICtrlCreateButton("...", 405, 40+5, 23, 21)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
	GUICtrlCreateGroup("Options", 7, 75+5, 121, 110)
	$Window_mode_radio = GUICtrlCreateRadio("Window Mode", 20, 90+5, 90)
	$Fullscreen_mode_radio = GUICtrlCreateRadio("Fullscreen", 20, 90+22+5, 90)
	if RegRead($MU_REG_CONFIG, "WindowMode") = "1" Then
		GUICtrlSetState($Window_mode_radio, $GUI_CHECKED)
	Else
		GUICtrlSetState($Fullscreen_mode_radio, $GUI_CHECKED)
	EndIf
	$Sound_checkbox = GUICtrlCreateCheckbox("Sound Effects", 20, 90+44+5, 90)
	if RegRead($MU_REG_CONFIG, "SoundOnOff") = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
	$Music_checkbox = GUICtrlCreateCheckbox("Music", 20, 90+66+5, 90)
	if RegRead($MU_REG_CONFIG, "MusicOnOff") = "1" Then GUICtrlSetState(-1, $GUI_CHECKED)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
	GUICtrlCreateGroup("Global MU Online Starter", 137, 75+5, 300, 110)
	GUICtrlCreateLabel("Username:", 145, 93+4+5, 55, 17)
	$Username_Input = GUICtrlCreateCombo("", 200, 90+3+5, 100);IniRead($Save_file, "General", "Username", "Username")
;~ 	GUICtrlSetLimit(-1, 12)
	GUICtrlCreateLabel("StrID:", 145, 93+22+4+5, 60, 17)
	$StrID_Input = GUICtrlCreateCombo("", 200, 90+20+3+5, 100)
;~ 	_set_names_()
	$Get_str_ID_button = GUICtrlCreateButton("Get StrID", 355, 98, 75, 40)
	$Save_User_button = GUICtrlCreateButton("Save pair", 145, 142, 77, 20)
	$Delete_User_button = GUICtrlCreateButton("Delete pair", 223, 142, 77, 20)
;~ 	$Get_str_ID_button = GUICtrlCreateButton("Get StrID", 145, 142, 155, 20)
;~ 	$Save_User_button = GUICtrlCreateButton("Save pair", 355, 98, 75, 20)
;~ 	$Delete_User_button = GUICtrlCreateButton("Delete pair", 355, 98+20, 75, 20)
;~ 	$Password_Input = GUICtrlCreateInput(_StringEncrypt(0, IniRead($Save_file, "General", "Password", "Password"), $encryption_password, $encryption_level), 200, 90+22+3+5, 100, -1, $ES_PASSWORD)
;~ 	GUICtrlSetLimit(-1, 12)
	$START_MU_BUTTON = GUICtrlCreateButton("Start MU", 340, 142+5, 90, 35)
;~ 	$display_progress_checkbox = GUICtrlCreateCheckbox("Display progress", 145, 90+44+3+5, 100)
;~ 	GUICtrlSetState(-1, IniRead($save_file, "General", "Display progress", "4"))
	$Auto_START_GAME_checkbox = GUICtrlCreateCheckbox("AutoClick Start Game @ Launcher", 145, 90+66+3+5, 185)
	GUICtrlSetState(-1, IniRead($save_file, "General", "Autoclick Start Game", "1"))
;~ 	GUICtrlCreateLabel("WARNING!!! Use on your own risk...", 315, 92+5, 65, 60)
;~ 	GUICtrlSetColor(-1, 0xFF0000)
	$GMO_STARTER_help_icon = GUICtrlCreateIcon($SHELL32, -24, 310, 103, 32, 32)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
	GUICtrlCreateTabItem("")
EndFunc

func _Options_tab()
	$Options_tab = GUICtrlCreateTabItem("Options")
	GUICtrlSetImage(-1, $Icons_file, -16)

	GUICtrlCreateGroup("Repair items", 7, 125-95, 120, 65)
	$Repair_items_checkbox = GUICtrlCreateCheckbox("Auto-Repair items", 15, 140-95, 105)
	GUICtrlSetState(-1, IniRead($save_file, "Options", "Repair items", "4"))
	GUICtrlCreateLabel("Interval [min]:", 13, 165-95, 65)
	$Repair_items_interval_input = GUICtrlCreateInput(IniRead($save_file, "Options", "Repair interval", "40"), 78, 162-95, 42, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 3)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 999, 1)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Isolate sounds", 7, 30+70, 120, 90)
	Local $jewel_sound_status = _jewel_sound_status()
	Local $button_name = "Isolate", $status_jewel = "Sounds NOT isolated", $status_color = $boje_crvena_STOP
	if $jewel_sound_status = 1 then
		$button_name = "Return original"
		$status_jewel = "Sound are isolated"
		$status_color = $boje_zelena_GO
	ElseIf $jewel_sound_status = 2 Then
		$button_name = "Return original"
		$status_jewel = "Partially    isolated"
		$status_color = 0xFF8000
	EndIf
	$Isolate_jewel_button = GUICtrlCreateButton($button_name, 15, 45+70, 104, 21)
	GUICtrlCreateLabel("Status:", 15, 72+70, 50)
	$Isolate_jewel_status = GUICtrlCreateLabel($status_jewel, 15, 87+70, 70, 28)
	GUICtrlSetColor(-1, $status_color)
	$Isolate_jewel_help_icon = GUICtrlCreateIcon($SHELL32, -24, 87, 75+70, 32, 32)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Auto Party system:", 137, 30, 122, 110)
	$AutoParty_Help_icon = GUICtrlCreateIcon($SHELL32, -211, 240, 28, 16, 16)
	GUICtrlSetCursor(-1, 0)
	$AutoParty_checkbox = GUICtrlCreateCheckbox("Use Auto Party", 145, 45, 90, 17)
	GUICtrlSetState(-1, IniRead($save_file, "Options", "Auto Party", "4"))
	GUICtrlCreateLabel("Interval [sec]:", 143, 70, 65)
	$AutoParty_Interval_input = GUICtrlCreateInput(IniRead($save_file, "Options", "Party Interval", "60"), 210, 65, 42, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 3)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 999, 1)
	GUICtrlCreateLabel("Choose side for Party:", 145, 93, 105)
	$AutoParty_Side_combo = GUICtrlCreateCombo("", 145, 110, 105, -1, $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "Above my Char|Bellow my Char|To the Right|To the Left|Manual (Shift+F8)", IniRead($save_file, "Options", "Party Side", "To the Right"))
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Drop Items System:", 268, 30, 169, 110)
	$Drop_items_checkbox = GUICtrlCreateCheckbox("Drop down items", 275, 45, 100, 17)
	GUICtrlSetState(-1, IniRead($save_file, "Options", "Drop Items", "4"))
	GUICtrlCreateLabel("Interval [min]:", 275, 70, 65)
	$Drop_Items_Interval = GUICtrlCreateInput(IniRead($save_file, "Options", "Drop Items Interval", "40"), 340, 65, 42, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 3)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 999, 1)
	GUICtrlCreateLabel("More setups on button bellow:", 275, 90, 145, 17)
	$Drop_items_setup_button = GUICtrlCreateButton("Drop items setup", 275, 106, 155, 25)
	GUICtrlCreateIcon($Icons_file, -15, 395, 45, 32, 32)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("For more control click here:", 137, 145, 200, 45)
	$Additional_Setup_Button = GUICtrlCreateButton("Additional Setup", 145, 160, 183, 24)
	GUICtrlSetFont(-1, 9, 800)
;~ 	$Pause_bot_when_Chat_checkbox = GUICtrlCreateCheckbox("Pause bot if chat window is open", 150, 163, 185)
;~ 	GUICtrlSetState(-1, IniRead($save_file, "Options", "CheckForEnterPause", "1"))
;~ 	$Pause_bot_when_Chat_help_icon = GUICtrlCreateIcon($SHELL32, -211, 315, 144, 16, 16)
;~ 	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

;~ 	GUICtrlCreateGroup("In game volume:", 137, 145, 300-100, 45)
;~ 	$Volume_Slider = GUICtrlCreateSlider(140, 160, 260-100, 25)
;~ 	GUICtrlSetData(-1, RegRead($MU_REG_CONFIG, "VolumeLevel"))
;~ 	GUICtrlSetBkColor(-1, 0xFFFFFF)
;~ 	GUICtrlSetLimit(-1, 10, 0)
;~ 	$Volume_status = GUICtrlCreateLabel(RegRead($MU_REG_CONFIG, "VolumeLevel"), 408-100, 160, 40, 20)
;~ 	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
;~ 	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("PK Tool", 344, 145, 93, 45)
	$PK_Button = GUICtrlCreateButton("PK Tool", 351, 160, 79, 23)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateTabItem("")
EndFunc

func _BOTS_tab()
	$BOTS_tab = GUICtrlCreateTabItem("BOTS")
	GUICtrlSetImage(-1, $Icons_file, -3)
	GUICtrlCreateTabItem("")
EndFunc

func _AE_BOT_tab()
	$AE_Bot_Tab = GUICtrlCreateTabItem("AE")
	GUICtrlSetImage(-1, $Icons_file, "0")

	GUICtrlCreateGroup("Shooting directions and Pickup", 7, 30, 170, 138)
	Local $middle_x = 40, $middle_y = 70, $start_angle = 0
	for $i = 1 to 8
		$AE_Direction_Checkbox[$i] = GUICtrlCreateCheckbox("", Round(25*_cos($start_angle)+$middle_x), Round(25*_Sin($start_angle)+$middle_y), 17, 17)
		GUICtrlSetState(-1, IniRead($save_file, "AE Bot", "Shoot Direction " & $i, "1"))
		$start_angle += 45
	Next
	$AE_All_direction_button = GUICtrlCreateButton("all", $middle_x-4, $middle_y-2, 21, 20)
	GUICtrlCreateLabel("Change direction", 85, 43, 90, 17)
	$Direction_by_order_radio = GUICtrlCreateRadio("By order", 105, 58, 60, 17)
	$Direction_random_radio = GUICtrlCreateRadio("Random", 105, 76, 60, 17)
	if IniRead($save_file, "AE Bot", "Shoot order", "1") = "1" Then
		GUICtrlSetState($Direction_by_order_radio, $GUI_CHECKED)
	Else
		GUICtrlSetState($Direction_random_radio, $GUI_CHECKED)
	EndIf
	$AE_Pickup_items_checkbox = GUICtrlCreateCheckbox("Pickup Items", 90, 100, 80, 17)
	GUICtrlSetState(-1, IniRead($save_file, "AE Bot", "Pickup items", "1"))
	GUICtrlCreateLabel("Change direction speed:", 15, 122, 120, 17)
	$AE_Mouse_reduce_button = GUICtrlCreateButton("R", 150, 118, 20, 20)
	$AE_Direction_Speed_Slider = GUICtrlCreateSlider(11, 140, 135, 25)
	GUICtrlSetLimit(-1, 10, 1)
	GUICtrlSetBkColor(-1, 0xFFFFFF)
	GUICtrlSetData(-1, IniRead($save_file, "AE Bot", "Shoot speed", "5"))
	$AE_Direction_Speed_Status = GUICtrlCreateLabel(IniRead($save_file, "AE Bot", "Shoot speed", "5"), 150, 140, 25, 21)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Skills", 185, 30, 120, 138)
	GUICtrlCreateLabel("Weapon skill", 192, 45, 65, 17)
	$AE_Weapon_skill = GUICtrlCreateInput(IniRead($Save_file, "AE Bot", "Weapon skill", "1"), 260, 43, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$AE_Heal_buff_checkbox = GUICtrlCreateCheckbox("Heal buff", 192, 59, 60, 17)
	GUICtrlSetState(-1, IniRead($save_file, "AE Bot", "Heal buff", "4"))
	$AE_Heal_buff_skill = GUICtrlCreateInput(IniRead($Save_file, "AE Bot", "Heal skill", "6"), 260, 59, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$AE_Def_buff_checkbox = GUICtrlCreateCheckbox("Def buff", 192, 75, 60, 17)
	GUICtrlSetState(-1, IniRead($save_file, "AE Bot", "Def buff", "4"))
	$AE_Def_buff_skill = GUICtrlCreateInput(IniRead($Save_file, "AE Bot", "Def skill", "3"), 260, 75, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$AE_Dmg_buff_checkbox = GUICtrlCreateCheckbox("Dmg buff", 192, 91, 60, 17)
	GUICtrlSetState(-1, IniRead($save_file, "AE Bot", "Dmg buff", "4"))
	$AE_Dmg_buff_skill = GUICtrlCreateInput(IniRead($Save_file, "AE Bot", "Dmg skill", "4"), 260, 91, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$AE_Infinite_arrow_checkbox = GUICtrlCreateCheckbox("Inf.Arrow", 192, 107, 60, 17)
	GUICtrlSetState(-1, IniRead($save_file, "AE Bot", "Infinite Arrow", "4"))
	$AE_Infinite_arrow_skill = GUICtrlCreateInput(IniRead($Save_file, "AE Bot", "Infinite Arrow Skill", "7"), 260, 107, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	GUICtrlCreateLabel("Multishot", 192, 125, 60, 17)
	$AE_Multishot_skill = GUICtrlCreateInput(IniRead($Save_file, "AE Bot", "Multishot skill", "5"), 260, 123, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$AE_Combine_skills = GUICtrlCreateCheckbox("Multi+Weapon", 192, 143, 85, 17)
	GUICtrlSetState(-1, IniRead($save_file, "AE Bot", "Multishot combine", "4"))
	$AE_Skills_Help_icon = GUICtrlCreateIcon($SHELL32, -211, 282, 145, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Instructions", 313, 30, 124, 86)
	GUICtrlCreateLabel("Start Bot" & @TAB & "= F11", 320, 45, 110, 17)
	GUICtrlSetColor(-1, $boje_zelena_GO)
	GUICtrlCreateLabel("Stop Bot" & @TAB & "= F10", 320, 45+17*1, 110, 17)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateLabel("Left Click" & @TAB & "= F9", 320, 45+17*2, 110, 17)
	GUICtrlCreateLabel("Toggle pickup" & @TAB & "= F8", 320, 45+17*3, 110, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Current operation", 313, 120, 124, 48)
	$AE_Current_operation = GUICtrlCreateLabel("STOPPED", 320, 138, 110, 20, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateTabItem("")
EndFunc

func _EE_BOT_tab()
	$EE_Bot_Tab = GUICtrlCreateTabItem("EE")
	GUICtrlSetImage(-1, $Icons_file, -6)
	Local $Y_mover = -3
	GUICtrlCreateGroup("Party Members and buffs", 7, 30, 190, 140)
	GUICtrlCreateLabel("Member", 15-5, 45+$Y_mover, 45, 17)
	GUICtrlCreateLabel("Heal", 63-10, 45+$Y_mover, 30, 17)
	GUICtrlSetColor(-1, 0x0532A3)
	GUICtrlCreateLabel("Def", 90-10, 45+$Y_mover, 20, 17)
	GUICtrlSetColor(-1, 0x195900)
	GUICtrlCreateLabel("Dmg", 110-10, 45+$Y_mover, 23, 17)
	GUICtrlSetColor(-1, 0x903514)
	GUICtrlCreateLabel("Free", 138-10-3, 45+$Y_mover, 30, 17)
	GUICtrlSetTip(-1, "Heal member in free time" & @CRLF & "(after buffing all members)")
	GUICtrlSetColor(-1, 0x00626D)
	GUICtrlCreateLabel("Super", 165-10-6, 45+$Y_mover, 35, 17)
	GUICtrlSetTip(-1, "Heal member after each buff" & @CRLF & "(after buffing each member)")
	GUICtrlSetColor(-1, 0x3401A1)
	GUICtrlCreateLabel("DP", 165-10-6+30, 45+$Y_mover, 17)
	GUICtrlSetTip(-1, "DP = disposition, if checked your EE" & @CRLF & "will buff coordinate, instead of PT location" & @CRLF & "hotkey to set member coordinate = Shift+F1/2/3/4/5")

	Local $start_x = 15-10
	Local $start_x2 = $start_x
	Local $start_y = 57+$Y_mover+1
	for $i = 1 to 6
		$EE_Party_members_checkbox[$i] = GUICtrlCreateCheckbox($i, $start_x2+5, $start_y, 23, 17)
		GUICtrlSetState(-1, IniRead($Save_file, "EE Bot", "PT Member " & $i, "4"))
		$start_x2 += 28
		$EE_ALL_members_buff_button[$i] = GUICtrlCreateButton("all", $start_x2+3, $start_y, 21, 17)
		$start_x2 += 27
		$EE_Heal_members_checkbox[$i] = GUICtrlCreateCheckbox("", $start_x2, $start_y, 17, 17)
		GUICtrlSetState(-1, IniRead($Save_file, "EE Bot", "Heal Member " & $i, "4"))
		$start_x2 += 23
		$EE_Def_members_checkbox[$i] = GUICtrlCreateCheckbox("", $start_x2, $start_y, 17, 17)
		GUICtrlSetState(-1, IniRead($Save_file, "EE Bot", "Def Member " & $i, "4"))
		$start_x2 += 23
		$EE_Dmg_members_checkbox[$i] = GUICtrlCreateCheckbox("", $start_x2, $start_y, 17, 17)
		GUICtrlSetState(-1, IniRead($Save_file, "EE Bot", "Dmg Member " & $i, "4"))
		$start_x2 += 27
		$EE_Free_members_checkbox[$i] = GUICtrlCreateCheckbox("", $start_x2-3, $start_y, 17, 17)
		GUICtrlSetState(-1, IniRead($Save_file, "EE Bot", "Free Heal Member " & $i, "4"))
		$start_x2 += 30
		$EE_Super_members_checkbox[$i] = GUICtrlCreateCheckbox("", $start_x2-6, $start_y, 17, 17)
		GUICtrlSetState(-1, IniRead($Save_file, "EE Bot", "Super Heal Member " & $i, "4"))
		$start_x2 += 16
		$EE_DP_checkbox[$i] = GUICtrlCreateCheckbox("", $Start_x2, $start_y, 17, 17)
		GUICtrlSetState(-1, IniRead($Save_file, "EE Bot", "Use DP member " & $i, "4"))
		$start_y += 16
		$start_x2 = $start_x
	Next
;~ 	$start_y -= 0
	$EE_all_members_button = GUICtrlCreateButton("all", 15-5, $start_y, 21, 17)
	$EE_all_members_all_buff_button = GUICtrlCreateButton("all", 15+28-7, $start_y, 21, 17)
	$EE_all_members_heal_button = GUICtrlCreateButton("all", 15+28+23-10, $start_y, 21, 17)
	$EE_all_members_def_button = GUICtrlCreateButton("all", 15+28+23+23-10, $start_y, 21, 17)
	$EE_all_members_dmg_button = GUICtrlCreateButton("all", 15+28+23+23+23-10, $start_y, 21, 17)
	$EE_all_members_FREE_button = GUICtrlCreateButton("all", 15+28+23+23+23+27-10-3, $start_y, 21, 17)
	$EE_all_members_SUPER_button = GUICtrlCreateButton("all", 15+28+23+23+23+27+30-10-7, $start_y, 21, 17)
	$EE_all_members_DP_button = GUICtrlCreateButton("all", 15+28+23+23+23+27+35, $start_y, 21, 17)
	$EE_members_buff_help_icon = GUICtrlCreateIcon($SHELL32, -211, 172, 28+$Y_mover, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Skills and Pickup", 205, 30, 110, 83)
	GUICtrlCreateLabel("Heal buff", 212, 45, 50, 17)
	GUICtrlSetColor(-1, 0x0532A3)
	$EE_Heal_skill_input = GUICtrlCreateInput(IniRead($save_file, "EE Bot", "Heal skill", "2"), 265, 45, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	GUICtrlCreateLabel("Def. buff", 212, 45+16, 50, 17)
	GUICtrlSetColor(-1, 0x195900)
	$EE_Def_skill_input = GUICtrlCreateInput(IniRead($save_file, "EE Bot", "Def skill", "3"), 265, 45+16, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	GUICtrlCreateLabel("Dmg. buff", 212, 45+16*2, 50, 17)
	GUICtrlSetColor(-1, 0x903514)
	$EE_Dmg_skill_input = GUICtrlCreateInput(IniRead($save_file, "EE Bot", "Dmg skill", "4"), 265, 45+16*2, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$EE_Pickup_items = GUICtrlCreateCheckbox("Pickup items", 212, 46+16*3, 80, 17)
	GUICtrlSetState(-1, IniRead($save_file, "EE Bot", "Pickup Items", "1"))
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Buff delay [sec]", 205, 103+12, 110, 65-12)
	GUICtrlCreateLabel("Regular", 212, 132, 40, 17)
	$EE_Buff_delay_input = GUICtrlCreateInput(IniRead($save_file, "EE Bot", "Regular Delay", "55"), 265, 132, 42, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 60, 0)
	GUICtrlCreateLabel("Free heal", 212, 148, 45, 17)
	$EE_Free_heal_delay_input = GUICtrlCreateInput(IniRead($save_file, "EE Bot", "Free Heal Delay", "3,5"), 265, 132+16, 42, 17, $ES_CENTER+$ES_NUMBER+$ES_READONLY)
	$EE_Free_heal_delay_UpDown = GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 0)
	$EE_buff_delay_help_icon = GUICtrlCreateIcon($SHELL32, -211, 295, 114, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Instructions", 313+10, 30, 124-10, 86)
	GUICtrlCreateLabel("Start Bot          = F11", 320+10, 45, 110-10, 17)
	GUICtrlSetColor(-1, $boje_zelena_GO)
	GUICtrlCreateLabel("Stop Bot          = F10", 320+10, 45+17*1, 110-10, 17)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateLabel("Left Click         = F9", 320+10, 45+17*2, 110-10, 17)
	GUICtrlCreateLabel("Toggle pickup = F8", 320+10, 45+17*3, 110-10, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Current operation", 313+10, 120, 124-10, 48)
	$EE_Current_operation = GUICtrlCreateLabel("STOPPED", 320+10, 138, 110-10, 20, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateTabItem("")
EndFunc

func _SM_BOT_tab()
	$SM_Bot_Tab = GUICtrlCreateTabItem("SM")
	GUICtrlSetImage(-1, $Icons_file, -9)

	GUICtrlCreateGroup("SM bot type", 7, 30, 95, 65)
	$SM_bot_type_help_icon = GUICtrlCreateIcon($SHELL32, -211, 80, 27, 16, 16)
	GUICtrlSetCursor(-1, 0)
	$SM_regular_bot_radio = GUICtrlCreateRadio("Regular bot", 15, 47, 75, 17)
	$SM_NOVA_bot_radio = GUICtrlCreateRadio("NOVA bot", 15, 70, 75, 17)
	if IniRead($save_file, "SM Bot", "AFK type", "1") = "1" Then
		GUICtrlSetState($SM_regular_bot_radio, $GUI_CHECKED)
	Else
		GUICtrlSetState($SM_NOVA_bot_radio, $GUI_CHECKED)
	EndIf
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("NOVA setup", 7, 97, 95, 72)
	GUICtrlCreateLabel("Monster spawn time [sec]:", 15, 112, 80, 32)
	$SM_NOVA_delay_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Nova spawn", "5,3"), 15, 144, 52, 17, $ES_CENTER+$ES_NUMBER+$ES_READONLY)
	$SM_NOVA_delay_up_down = GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 999, 0)
	$SM_nova_spawn_help_icon = GUICtrlCreateIcon($SHELL32, -211, 75, 144, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Skills and speed", 110, 30, 175, 140)
	GUICtrlCreateLabel("Hotkey", 185, 47, 40, 17)
	GUICtrlCreateLabel("Interval [Sec]:", 235, 37, 40, 26, $ES_CENTER)
	$SM_main_afk_skill_checkbox = GUICtrlCreateCheckbox("Main skill", 117, 47+20, 65, 17)
	GUICtrlSetState(-1, IniRead($save_file, "SM Bot", "Use Main Skill", "1"))
	$SM_Main_afk_skill_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Main skill", "1"), 182, 45+20, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$SM_Main_afk_skill_delay_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Main skill interval", "1,0"), 235, 45+20, 42, 17, $ES_CENTER+$ES_NUMBER+$ES_READONLY)
	$SM_Main_afk_skill_delay_up_down = GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 0)
	GUICtrlCreateLabel("NOVA skill", 117, 47+16+21, 65, 17)
	$SM_Nova_skill_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Nova skill", "3"), 182, 45+16+20, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$Nova_skill_progress = GUICtrlCreateProgress(235, 45+16+20+1, 42, 15, 0x01)
;~ 	DllCall("UxTheme.dll", "int", "SetWindowTheme", "hwnd", GUICtrlGetHandle(-1), "wstr", 0, "wstr", 0)
;~ 	GUICtrlSetColor(-1, $boje_plava_tamno)
;~ 	GUICtrlSetBkColor(-1, 0xD6F4FF)
	$SM_afk_skill_2_checkbox = GUICtrlCreateCheckbox("Skill #2", 117, 45+16*2+20, 65, 17)
	GUICtrlSetState(-1, IniRead($save_file, "SM Bot", "use Skill #2", "4"))
	$SM_afk_skill_2_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Skill #2", "2"), 182, 45+16*2+20, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$SM_afk_skill2_delay_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Skill #2 interval", "30"), 235-10, 45+16*2+20, 42+10, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$SM_afk_skill_3_checkbox = GUICtrlCreateCheckbox("Skill #3", 117, 45+16*3+20, 65, 17)
	GUICtrlSetState(-1, IniRead($save_file, "SM Bot", "Use Skill #3", "4"))
	$SM_afk_skill_3_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Skill #3", "4"), 182, 45+16*3+20, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$SM_afk_skill3_delay_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Skill #3 interval", "30"), 235-10, 45+16*3+20, 42+10, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$SM_afk_skill_4_checkbox = GUICtrlCreateCheckbox("Skill #4", 117, 45+16*4+20, 65, 17)
	GUICtrlSetState(-1, IniRead($save_file, "SM Bot", "Use Skill #4", "4"))
	$SM_afk_skill_4_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Skill #4", "5"), 182, 45+16*4+20, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$SM_afk_skill4_delay_input = GUICtrlCreateInput(IniRead($save_file, "SM Bot", "Skill #4 Interval", "30"), 235-10, 45+16*4+20, 42+10, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$SM_pickup_items_checkbox = GUICtrlCreateCheckbox("Pickup items", 117, 55+16*5+14, 100, 17)
	GUICtrlSetState(-1, IniRead($save_file, "SM Bot", "Pickup items", "1"))
	$SM_skills_help_icon = GUICtrlCreateIcon($SHELL32, -211, 255, 149, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Instructions", 313-20, 30, 124+20, 86)
	GUICtrlCreateLabel("Start Bot" & @TAB & "     = F11", 320-20, 45, 110+20, 17)
	GUICtrlSetColor(-1, $boje_zelena_GO)
	GUICtrlCreateLabel("Stop Bot" & @TAB & "     = F10", 320-20, 45+17*1, 110+20, 17)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateLabel("Left Click" & @TAB & "     = F9", 320-20, 45+17*2, 110+20, 17)
	GUICtrlCreateLabel("Toggle pickup" & @TAB & "     = F8", 320-20, 45+17*3, 110+20, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Current operation", 313-20, 120, 124+20, 48)
	$SM_Current_operation = GUICtrlCreateLabel("STOPPED", 320-20, 138, 110+20, 20, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateTabItem("")
EndFunc

func _BK_BOT_tab()
	$BK_Bot_Tab = GUICtrlCreateTabItem("BK")
	GUICtrlSetImage(-1, $Icons_file, -2)

	GUICtrlCreateGroup("Skills", 7, 30, 170, 138)
	GUICtrlCreateLabel("Hotkey", 68+10, 47, 40, 17)
	GUICtrlCreateLabel("Interval [sec]:", 125, 40, 45, 27, $ES_CENTER)
	$BK_Main_skill_checkbox = GUICtrlCreateCheckbox("Main", 15, 65+5, 45, 17)
	GUICtrlSetState(-1, IniRead($save_file, "BK Bot", "Use main skill", "1"))
	$BK_Main_skill_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Main skill", "1"), 65+10, 65+5, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$BK_Main_skill_interval_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Main skill interval", "1,5"), 125, 65+5, 42, 17, $ES_CENTER+$ES_NUMBER+$ES_READONLY)
;~ 	GUICtrlSetLimit(-1, 3)
	$BK_Main_skill_interval_up_down = GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 0)
	$BK_Skill_2_checkbox = GUICtrlCreateCheckbox("Skill #2", 15, 65+16*1+5, 55, 17)
	GUICtrlSetState(-1, IniRead($save_file, "BK Bot", "Use skill #2", "4"))
	$BK_Skill_2_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Skill #2", "2"), 65+10, 65+16*1+5, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$BK_skill_2_interval = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Skill #2 interval", "30"), 125, 65+16*1+5, 42, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$BK_Skill_3_checkbox = GUICtrlCreateCheckbox("Skill #3", 15, 65+16*2+5, 55, 17)
	GUICtrlSetState(-1, IniRead($save_file, "BK Bot", "Use skill #3", "4"))
	$BK_Skill_3_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Skill #3", "3"), 65+10, 65+16*2+5, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$BK_skill_3_interval = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Skill #3 interval", "30"), 125, 65+16*2+5, 42, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$BK_Skill_4_checkbox = GUICtrlCreateCheckbox("Skill #4", 15, 65+16*3+5, 55, 17)
	GUICtrlSetState(-1, IniRead($save_file, "BK Bot", "Use skill #4", "4"))
	$BK_Skill_4_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Skill #4", "4"), 65+10, 65+16*3+5, 42, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$BK_skill_4_interval = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Skill #4 interval", "30"), 125, 65+16*3+5, 42, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$BK_Pickup_items_checkbox = GUICtrlCreateCheckbox("Pickup items", 15, 145, 80, 17)
	GUICtrlSetState(-1, IniRead($save_file, "BK Bot", "Pickup items", "1"))
	$BK_skills_help_icon = GUICtrlCreateIcon($SHELL32, -211, 150, 145, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Combo", 185, 30, 120, 138)
	GUICtrlCreateLabel("Skill 1", 195, 47, 40, 17)
	GUICtrlCreateLabel("Skill 2", 195+36, 47, 40, 17)
	GUICtrlCreateLabel("Skill 3", 195+36*2, 47, 40, 17)
	$BK_Combo_skill_1_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Combo skill 1", "1"), 190, 65, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$BK_Combo_skill_2_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Combo skill 2", "2"), 190+36, 65, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$BK_Combo_skill_3_input = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Combo skill 3", "3"), 190+36*2, 65, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	GUICtrlCreateLabel("Clicking speed for each skill:", 192, 85, 110, 28, $ES_CENTER)
	$BK_Combo_skill_1_interval = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Combo skill 1 interval", "70"), 190, 113, 37, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 0)
	$BK_Combo_skill_2_interval = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Combo skill 2 interval", "63"), 190+36, 113, 37, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 0)
	$BK_Combo_skill_3_interval = GUICtrlCreateInput(IniRead($save_file, "BK Bot", "Combo skill 3 interval", "76"), 190+36*2, 113, 37, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 0)
	$BK_Combo_instructions_label = GUICtrlCreateLabel("Hold middle mouse button to do combo", 189, 137, 115, 28, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	$BK_combo_help_icon = GUICtrlCreateIcon($SHELL32, -211, 280, 29, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Instructions", 313, 30, 124, 86)
	GUICtrlCreateLabel("Start Bot" & @TAB & "= F11", 320, 45, 110, 17)
	GUICtrlSetColor(-1, $boje_zelena_GO)
	GUICtrlCreateLabel("Stop Bot" & @TAB & "= F10", 320, 45+17*1, 110, 17)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateLabel("Left Click" & @TAB & "= F9", 320, 45+17*2, 110, 17)
	GUICtrlCreateLabel("Toggle pickup" & @TAB & "= F8", 320, 45+17*3, 110, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Current operation", 313, 120, 124, 48)
	$BK_Current_operation = GUICtrlCreateLabel("STOPPED", 320, 138, 110, 20, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateTabItem("")
EndFunc

func _DL_BOT_tab()
	$DL_Bot_Tab = GUICtrlCreateTabItem("DL")
	GUICtrlSetImage(-1, $Icons_file, -5)

	GUICtrlCreateGroup("Mouse movement", 7, 30, 168, 138)
	$DL_Pic_ver = GUICtrlCreatePic(@ScriptDir & "\data\ver.jpg", 8+15, 45-4, 55-10, 39-10)
	GUICtrlSetCursor(-1, 0)
	$DL_Pic_Hor = GUICtrlCreatePic(@ScriptDir & "\data\hor.jpg", 8+100, 45-4, 55-10, 39-10)
	GUICtrlSetCursor(-1, 0)
	$DL_Pic_Cir = GUICtrlCreatePic(@ScriptDir & "\data\cir.jpg", 8+15, 45+38, 55-10, 39-10)
	GUICtrlSetCursor(-1, 0)
	$DL_Pic_Ran = GUICtrlCreatePic(@ScriptDir & "\data\ran.jpg", 8+100, 45+38, 55-10, 39-13)
	GUICtrlSetCursor(-1, 0)
	$DL_Mouse_movement_vert_radio = GUICtrlCreateRadio("Vertical", 17, 85-18, 55, 17)
	$DL_Mouse_movement_horiz_radio = GUICtrlCreateRadio("Horizontal", 15+83, 85-18, 65, 17)
	$DL_Mouse_movement_round_radio = GUICtrlCreateRadio("Round", 19, 85+25, 50, 17)
	$DL_Mouse_movement_random_radio = GUICtrlCreateRadio("Chaotic", 102, 85+25, 58, 17)
	if IniRead($save_file, "DL Bot", "Mouse movement", "3") = "1" Then
		GUICtrlSetState($DL_Mouse_movement_vert_radio, $GUI_CHECKED)
	elseif IniRead($save_file, "DL Bot", "Mouse movement", "3") = "2" Then
		GUICtrlSetState($DL_Mouse_movement_horiz_radio, $GUI_CHECKED)
	elseif IniRead($save_file, "DL Bot", "Mouse movement", "3") = "3" Then
		GUICtrlSetState($DL_Mouse_movement_round_radio, $GUI_CHECKED)
	Else
		GUICtrlSetState($DL_Mouse_movement_random_radio, $GUI_CHECKED)
	EndIf
	$DL_Mouse_reduce_button = GUICtrlCreateButton("R", 75, 90, 20, 20)
	GUICtrlCreateLabel("Mouse movement speed:", 15, 115+12, 120, 17)
	$DL_Mouse_movement_slider = GUICtrlCreateSlider(10, 135+5, 135, 25)
	GUICtrlSetData(-1, IniRead($Save_file, "DL Bot", "Mouse speed", "5"))
	GUICtrlSetBkColor(-1, 0xFFFFFF)
	GUICtrlSetLimit(-1, 10, 1)
	$DL_Mouse_movement_label = GUICtrlCreateLabel(IniRead($Save_file, "DL Bot", "Mouse speed", "5"), 150, 135+5, 20, 20)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Skills", 181, 30, 136, 138)
	GUICtrlCreateLabel("Hotkey", 238, 47, 40, 17)
	GUICtrlCreateLabel("Interval [sec]:", 273, 40, 45, 27, $ES_CENTER)
	GUICtrlCreateLabel("Main skill", 189, 65, 50, 17)
	$DL_Main_skill_input = GUICtrlCreateInput(IniRead($Save_file, "DL Bot", "Main skill", "1"), 240, 65, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$DL_Skill2_checkbox = GUICtrlCreateCheckbox("Skill#2", 189, 65+16*1, 50, 17)
	GUICtrlSetState(-1, IniRead($Save_file, "DL Bot", "Use Skill #2", "4"))
	$DL_Skill2_input = GUICtrlCreateInput(IniRead($Save_file, "DL Bot", "Skill #2", "2"), 240, 65+16*1, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$DL_skill2_interval = GUICtrlCreateInput(IniRead($Save_file, "DL Bot", "Skill #2 interval", "12"), 240+36, 65+16*1, 37, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$DL_Skill3_checkbox = GUICtrlCreateCheckbox("Skill#3", 189, 65+16*2, 50, 17)
	GUICtrlSetState(-1, IniRead($Save_file, "DL Bot", "Use Skill #3", "4"))
	$DL_Skill3_input = GUICtrlCreateInput(IniRead($Save_file, "DL Bot", "Skill #3", "3"), 240, 65+16*2, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$DL_skill3_interval = GUICtrlCreateInput(IniRead($Save_file, "DL Bot", "Skill #3 interval", "72"), 240+36, 65+16*2, 37, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
	$DL_Skill4_checkbox = GUICtrlCreateCheckbox("Skill#4", 189, 65+16*3, 50, 17)
	GUICtrlSetState(-1, IniRead($Save_file, "DL Bot", "Use Skill #4", "4"))
	$DL_Skill4_input = GUICtrlCreateInput(IniRead($Save_file, "DL Bot", "Skill #4", "4"), 240, 65+16*3, 37, 17, $ES_CENTER)
	GUICtrlSetLimit(-1, 1)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9, 0)
	$DL_skill4_interval = GUICtrlCreateInput(IniRead($Save_file, "DL Bot", "Skill #4 interval", "30"), 240+36, 65+16*3, 37, 17, $ES_CENTER+$ES_NUMBER)
	GUICtrlSetLimit(-1, 4)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 9999, 0)
;~ 	$DL_repair_horse_checkbox = GUICtrlCreateCheckbox("Repair horse", 189, 67+16*4, 80, 17)
;~ 	GUICtrlSetState(-1, IniRead($Save_file, "DL Bot", "Repair horse", "4"))
	$DL_pickup_items_checkbox = GUICtrlCreateCheckbox("Pickup items", 189, 67+16*5, 80, 17)
	GUICtrlSetState(-1, IniRead($Save_file, "DL Bot", "Pickup items", "4"))
	$DL_skills_help_icon = GUICtrlCreateIcon($SHELL32, -211, 285, 140, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Instructions", 313+10, 30, 124-10, 86)
	GUICtrlCreateLabel("Start Bot          = F11", 320+10, 45, 110-10, 17)
	GUICtrlSetColor(-1, $boje_zelena_GO)
	GUICtrlCreateLabel("Stop Bot          = F10", 320+10, 45+17*1, 110-10, 17)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateLabel("Left Click         = F9", 320+10, 45+17*2, 110-10, 17)
	GUICtrlCreateLabel("Toggle pickup = F8", 320+10, 45+17*3, 110-10, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Current operation", 313+10, 120, 124-10, 48)
	$DL_Current_operation = GUICtrlCreateLabel("STOPPED", 320+10, 138, 110-10, 20, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
	GUICtrlCreateTabItem("")
EndFunc

func _Macro_BOT_tab()
	$Macro_Bot_Tab = GUICtrlCreateTabItem("Macro")
	GUICtrlSetImage(-1, $Icons_file, -8)

	GUICtrlCreateGroup("Macro setup", 7, 30, 300, 138)
	Local $x_coordz = 15
	Local $y_coordz = 45
	Local $folder = StringLeft(GUICtrlRead($destination_input), StringInStr(GUICtrlRead($destination_input), "\", 0, -1)) & "Data\Macro.txt"
	for $i = 0 to 9
		$Macro_checkbox[$i] = GUICtrlCreateCheckbox($i, $x_coordz, $y_coordz, 25, 17)
		GUICtrlSetState(-1, IniRead($save_file, "Macro Bot", "Use macro " & $i, "4"))
		$Macro_input[$i] = GUICtrlCreateInput("", $x_coordz+25, $y_coordz, 115, 17)
		GUICtrlSetLimit(-1, 50)
		if IniRead($save_file, "Macro Bot", "Macro text " & $i, "") <> "" Then
			GUICtrlSetData(-1, IniRead($save_file, "Macro Bot", "Macro text " & $i, ""))
		Else
			if $i <> 0 then
				Local $input_txt = FileReadLine($folder, $i)
				if NOT @error Then GUICtrlSetData(-1, FileReadLine($folder, $i))
			Else
				Local $input_txt = FileReadLine($folder, 10)
				if NOT @error Then GUICtrlSetData(-1, FileReadLine($folder, $i))
			EndIf
		EndIf
		$y_coordz += 16
		if $i = 4 then
			$x_coordz += 145
			$y_coordz = 45
		EndIf
	Next
	$Macro_all_button = GUICtrlCreateButton("Check all", 15, 132, 60, 25)
	GUICtrlCreateLabel("Macro type:", 88, 132-3, 60, 17)
	$Macro_Send_text_radio = GUICtrlCreateRadio("Send text", 150, 130-3, 70, 17)
	$Macro_Alt_Number_radio = GUICtrlCreateRadio("Alt+number", 225, 130-3, 70, 17)
	if IniRead($save_file, "Macro bot", "alt", "1") = "1" Then
		GUICtrlSetState($Macro_Alt_Number_radio, $GUI_CHECKED)
	Else
		GUICtrlSetState($Macro_Send_text_radio, $GUI_CHECKED)
	EndIf
	GUICtrlCreateLabel("Switching interval [sec]:", 88, 150, 120, 17)
	$Macro_interval_input = GUICtrlCreateInput(Number(IniRead($save_file, "Macro bot", "Macro interval", "10")), 208, 147, 45, 17, $ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99, 1)
	$Macro_help_icon = GUICtrlCreateIcon($SHELL32, -211, 285, 148, 16, 16)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Instructions", 313, 30, 124, 86)
	GUICtrlCreateLabel("Start Bot" & @TAB & "= F11", 320, 45, 110, 17)
	GUICtrlSetColor(-1, $boje_zelena_GO)
	GUICtrlCreateLabel("Stop Bot" & @TAB & "= F10", 320, 45+17*1, 110, 17)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlCreateLabel("Left Click" & @TAB & "= F9", 320, 45+17*2, 110, 17)
	GUICtrlCreateLabel("Toggle pickup" & @TAB & "= F8", 320, 45+17*3, 110, 17)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlSetFont(-1, -1, -1, 8)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Current operation", 313, 120, 124, 48)
	$MACRO_Current_operation = GUICtrlCreateLabel("STOPPED", 320, 138, 110, 20, $ES_CENTER)
	GUICtrlSetColor(-1, $boje_crvena_STOP)
	GUICtrlSetFont(-1, 12, 800, 2, "Arial")
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateTabItem("")
EndFunc

func _Timer_tab()
	$Timer_tab = GUICtrlCreateTabItem("Timer")
	GUICtrlSetImage(-1, $Icons_file, -10)

	$Timer_listview = GUICtrlCreateListView("             Operation              |   Repeat|      Interval    | Time remaining", 7, 30, 430, 138, -1, $WS_EX_CLIENTEDGE+$LVS_EX_GRIDLINES+$LVS_EX_CHECKBOXES+$LVS_EX_FULLROWSELECT)
	$Timer_contextMenu = GUICtrlCreateContextMenu($Timer_listview)
	$Timer_context_Add_item = GUICtrlCreateMenuitem("Add item", $Timer_contextMenu)
	$Timer_context_Edit_item = GUICtrlCreateMenuitem("Edit item", $Timer_contextMenu)
	$Timer_context_Delete_item = GUICtrlCreateMenuitem("Delete item", $Timer_contextMenu)
	Local $ini_reader = IniReadSectionNames($Timer_file)
	if NOT @error Then
		for $i = 1 to $ini_reader[0]
			_GUICtrlListViewInsertItem($Timer_listview, $i-1, $ini_reader[$i])
			_GUICtrlListViewSetItemText($Timer_listview, $i-1, 1, IniRead($Timer_file, $ini_reader[$i], "Repeat", "1"))
			_GUICtrlListViewSetItemText($Timer_listview, $i-1, 2, IniRead($Timer_file, $ini_reader[$i], "Interval", "00:00:01"))
			_GUICtrlListViewSetItemText($Timer_listview, $i-1, 3, IniRead($Timer_file, $ini_reader[$i], "Interval", "00:00:01"))
			_GUICtrlListViewSetCheckState($Timer_listview, $i-1, Number(IniRead($Timer_file, $ini_reader[$i], "Checked", "1")))
		Next
	EndIf
	$Timer_Add_button = GUICtrlCreateButton("Add", 7, 173, 45, 20)
	$Timer_Edit_button = GUICtrlCreateButton("Edit", 7+45, 173, 45, 20)
	$Timer_Delete_button = GUICtrlCreateButton("Delete", 7+45*2, 173, 45, 20)
	$Timer_Start_button = GUICtrlCreateButton("Start", 347, 172, 45, 20)
	$Timer_Stop_button = GUICtrlCreateButton("Stop", 347+45, 172, 45, 20)
	GUICtrlSetState(-1, $GUI_DISABLE)
	$Timer_help_icon = GUICtrlCreateIcon($SHELL32, -211, 7+45*3+5, 175, 16, 16)
	GUICtrlSetCursor(-1, 0)

	$Timer_check_all = GUICtrlCreateButton("Check all", 210, 173, 60, 20)

	GUICtrlCreateTabItem("")
EndFunc

func _Chat_tab()
	$Chat_tab = GUICtrlCreateTabItem("Chat")
	GUICtrlSetImage(-1, $Icons_file, -4)

	GUICtrlCreateGroup("Chat program", 7, 30, 180, 119)
	GUICtrlCreateLabel("Nickname:", 15, 50, 55, 17)
	$CHAT_nickname_input = GUICtrlCreateInput(IniRead($Chat_file, "CHAT", "Nick", "Player"), 70, 47, 108, 20)
	GUICtrlSetLimit(-1, 12)
	$CHAT_keep_logs_checkbox = GUICtrlCreateCheckbox("Keep LOG files", 15, 72, 90, 17)
	GUICtrlSetState(-1, IniRead($Chat_file, "CHAT", "LOGS", "1"))
	$Chat_view_logs_button = GUICtrlCreateButton("View LOGs", 110, 70, 68, 19)
	$CHAT_Logs_folder_input = GUICtrlCreateInput(IniRead($Chat_file, "CHAT", "LOG Folder", @ScriptDir & "\Data\LOG"), 15, 90, 140, 20)
	$CHAT_browse_folder_button = GUICtrlCreateButton("...", 155, 90, 23, 20)
	$CHAT_Start_program_button = GUICtrlCreateButton("Start CHAT program", 15, 115, 163, 25)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	GUICtrlCreateGroup("Other methods and contacts", 195, 30, 242, 119)
	GUICtrlCreateLabel("Forum:", 202, 50, 45, 17)
	$CHAT_Forum_label = GUICtrlCreateLabel("http://sndbots.wetpaint.com/forum", 250, 50, 170, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateLabel("Mail:", 202, 73-5, 45, 17)
	$CHAT_Mail_label = GUICtrlCreateLabel("sandin@tippnet.rs", 250, 73-5, 90, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateLabel("MSN:", 202, 100-10, 45, 17)
	GUICtrlCreateInput("nebojsasandin@hotmail.com", 250, 96-10, 155, 20, $ES_CENTER+$ES_READONLY)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlCreateLabel("Official website:", 202, 125-15, 80, 17)
	$CHAT_Official_Website_label = GUICtrlCreateLabel("http://sndbots.wetpaint.com", 285, 125-15, 140, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlSetCursor(-1, 0)
	Local $pre_title = "v" & $Version_of_the_bot
	If $Is_beta = True then $pre_title &= " (Beta " & $beta_version & ")"
	GUICtrlCreateLabel("Your " & $pre_title, 202, 130, 130, 17)
	$CHAT_check_for_update_button = GUICtrlCreateLabel("Check for update?", 325, 130, 120, 17)
	GUICtrlSetColor(-1, $boje_plava_tamno)
	GUICtrlSetCursor(-1, 0)
;~ 	GUICtrlSetBkColor(-1, $boje_crvena_STOP)
;~ 	GUICtrlCreateLabel("I will try to reply soon as I receive message from you, every question will be answered.", 202, 115, 225, 36)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

;~ 	GUICtrlCreateLabel("Official web page:", 7, 153, 120, 17)
	GUICtrlCreateLabel("Chat program is new form for users to share their experience. It's new so there may not be so much users online on the start, so if you connect and see there is none online, try to stay online for a while and WE should be able to build a chatting community. Thank you.", 7, 153, 430, 40)
	GUICtrlSetColor(-1, $boje_plava_tamno)

	GUICtrlCreateTabItem("")
EndFunc

func _Disconnect_tab()
	$DC_TAB = GUICtrlCreateTabItem("Disconnect")
	GUICtrlSetImage(-1, $SHELL32, -257)

	GUICtrlCreateGroup("User info", 7, 30, 170, 160)
	GUICtrlCreateLabel("Username:", 15, 47+5, 50, 17)
	$DC_Nickname_input = GUICtrlCreateCombo("", 70, 45+3, 100, 20)
	GUICtrlCreateLabel("Password:", 15, 47+16+7, 50, 17)
	$DC_Password_input = GUICtrlCreateInput("", 70, 45+20+3, 100, 17, $ES_PASSWORD+ $ES_LEFT+$ES_AUTOHSCROLL)
	GUICtrlCreateLabel("StrID:", 15, 47+20*2+1, 50, 17)
	$DC_StrID_input = GUICtrlCreateCombo("", 70, 44+40, 100, 20)
	$DC_GetStrID_button = GUICtrlCreateButton("Get StrID", 15, 110, 120, 20)
	$DC_Save_pair_button = GUICtrlCreateButton("Save pair", 15, 132, 60, 20)
	$DC_Delete_pair_button = GUICtrlCreateButton("Delete pair", 75, 132, 60, 20)
	$DC_Bot_and_server_setup = GUICtrlCreateButton("Bot and Server setup", 15, 158, 154, 25)
	$DC_User_info_help_icon = GUICtrlCreateIcon($SHELL32, -24, 140, 115, 32, 32)
	GUICtrlSetCursor(-1, 0)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
;~
	GUICtrlCreateGroup("Counter", 185, 30, 250, 115)
	$DC_Counter_list = GUICtrlCreateListView("Disconnect type|Count|Time of last", 187, 45, 246, 94);, -1, $WS_EX_WINDOWEDGE+$LVS_EX_GRIDLINES+$LVS_EX_FULLROWSELECT+$LVS_EX_FLATSB)
;~ 	GUICtrlSetFont(-1, 8)
	GUICtrlSendMsg($DC_Counter_list, $LVM_SETEXTENDEDLISTVIEWSTYLE, $LVS_EX_GRIDLINES, $LVS_EX_GRIDLINES)
	GUICtrlCreateListViewItem("Lag|0|-", $DC_Counter_list)
	GUICtrlCreateListViewItem("MU crash|0|-", $DC_Counter_list)
	GUICtrlCreateListViewItem("Internet|0|-", $DC_Counter_list)
	GUICtrlCreateListViewItem("TOTAL|0|-", $DC_Counter_list)
	GUICtrlCreateListViewItem("Reconnected||-", $DC_Counter_list)
	_GUICtrlListViewSetColumnWidth($DC_Counter_list, 0, 100)
	_GUICtrlListViewSetColumnWidth($DC_Counter_list, 1, 50)
	_GUICtrlListViewSetColumnWidth($DC_Counter_list, 2, 75)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group
;~
	GUICtrlCreateGroup("Controls", 185, 150-3, 215, 43)
	$DC_Start_button = GUICtrlCreateButton("Start checking for DC", 190, 165-3, 160, 21)
	$DC_Stop_button = GUICtrlCreateButton("Stop", 295+60, 165-3, 40, 21)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUICtrlCreateGroup ("",-99,-99,1,1)  ;close group

	$DC_TOTAL_help_icon = GUICtrlCreateIcon($SHELL32, -24, 406, 155, 32, 32)
	GUICtrlSetCursor(-1, 0)

	GUICtrlCreateTabItem("")
EndFunc

func _Save_data()
	WinSetTrans($Form_4_shade, "", 200)
	GUICtrlSetData($DISPLAY_SAVING, "Saving data, please wait...")
	GUISetState(@SW_SHOW, $Form_4_shade)
	if $PK_tool_is_out = True then
		GUISetState(@SW_HIDE, $Form7_PkTool)
		$PK_tool_is_out = False
	EndIf

	if NOT FileExists($save_file) Then FileWrite($save_file, "")
	IniWrite($save_file, "Misc", "Main tab", GUICtrlRead($Tab1))
	IniWrite($save_file, "Misc", "Sec tab", GUICtrlRead($Tab2))
;~ 	IniWrite($save_file, "Misc", "Drop start X", IniRead($save_file, "Misc", "Drop X", "593"))
;~ 	IniWrite($save_file, "Misc", "Drop start Y", IniRead($save_file, "Misc", "Drop Y", "262"))
;~ 	IniWrite($Save_file, "General", "Username", GUICtrlRead($Username_Input))
	IniWrite($Save_file, "General", "Autoclick START GAME", GUICtrlRead($Auto_START_GAME_checkbox))
	IniWrite($Save_file, "Options", "Repair Items", GUICtrlRead($Repair_items_checkbox))
	IniWrite($Save_file, "Options", "Repair Interval", GUICtrlRead($Repair_items_interval_input))
	IniWrite($save_file, "Options", "Auto Party", GUICtrlRead($AutoParty_checkbox))
	IniWrite($save_file, "Options", "Party Interval", GUICtrlRead($AutoParty_Interval_input))
	IniWrite($save_file, "Options", "Party Side", GUICtrlRead($AutoParty_Side_combo))
	IniWrite($save_file, "Options", "Drop Items", GUICtrlRead($Drop_items_checkbox))
	IniWrite($save_file, "Options", "Drop Items Interval", GUICtrlRead($Drop_Items_Interval))
	IniWrite($Save_file, "Options", "Drop items Random", GUICtrlRead($Drop_items_random_perc_input))
	IniWrite($save_file, "Options", "Drop Items Side", GUICtrlRead($drop_items_side_combo))
;~ 	IniWrite($save_file, "Options", "CheckForEnterPause", GUICtrlRead($Pause_bot_when_Chat_checkbox))
	for $i = 1 to 8
		IniWrite($save_file, "AE Bot", "Shoot Direction " & $i, GUICtrlRead($AE_Direction_Checkbox[$i]))
		for $j = 1 to 8
			IniWrite($Drop_items_File, "Coordinate", $i*8-(8-$j), GUICtrlRead($Drop_items_field[$i][$j]))
		Next
	Next
	IniWrite($save_file, "AE Bot", "Pickup items", GUICtrlRead($AE_Pickup_items_checkbox))
	IniWrite($save_file, "AE Bot", "Shoot order", GUICtrlRead($Direction_by_order_radio))
	IniWrite($save_file, "AE Bot", "Shoot speed", GUICtrlRead($AE_Direction_Speed_Slider))
	IniWrite($save_file, "AE Bot", "Weapon skill", GUICtrlRead($AE_Weapon_skill))
	IniWrite($save_file, "AE Bot", "Heal buff", GUICtrlRead($AE_Heal_buff_checkbox))
	IniWrite($save_file, "AE Bot", "Heal skill", GUICtrlRead($AE_Heal_buff_skill))
	IniWrite($save_file, "AE Bot", "Def buff", GUICtrlRead($AE_Def_buff_checkbox))
	IniWrite($save_file, "AE Bot", "Def skill", GUICtrlRead($AE_Def_buff_skill))
	IniWrite($save_file, "AE Bot", "Dmg buff", GUICtrlRead($AE_Dmg_buff_checkbox))
	IniWrite($save_file, "AE Bot", "Dmg skill", GUICtrlRead($AE_Dmg_buff_skill))
	IniWrite($save_file, "AE Bot", "Infinite Arrow",GUICtrlRead($AE_Infinite_arrow_checkbox))
	IniWrite($save_file, "AE Bot", "Infinite Arrow Skill", GUICtrlRead($AE_Infinite_arrow_skill))
	IniWrite($save_file, "AE Bot", "Multishot skill", GUICtrlRead($AE_Multishot_skill))
	IniWrite($save_file, "AE Bot", "Multishot combine", GUICtrlRead($AE_Combine_skills))
	IniWrite($save_file, "EE Bot", "Heal skill", GUICtrlRead($EE_Heal_skill_input))
	IniWrite($save_file, "EE Bot", "Def skill", GUICtrlRead($EE_Def_skill_input))
	IniWrite($save_file, "EE Bot", "Dmg skill", GUICtrlRead($EE_Dmg_skill_input))
	IniWrite($save_file, "EE Bot", "Pickup items", GUICtrlRead($EE_Pickup_items))
	IniWrite($save_file, "EE Bot", "Regular delay", GUICtrlRead($EE_Buff_delay_input))
	IniWrite($save_file, "EE Bot", "Free Heal delay", GUICtrlRead($EE_Free_heal_delay_input))
	for $i = 1 to 6
		IniWrite($save_file, "EE Bot", "PT Member " & $i, GUICtrlRead($EE_Party_members_checkbox[$i]))
		IniWrite($save_file, "EE Bot", "Heal Member " & $i, GUICtrlRead($EE_Heal_members_checkbox[$i]))
		IniWrite($save_file, "EE Bot", "Def Member " & $i, GUICtrlRead($EE_Def_members_checkbox[$i]))
		IniWrite($save_file, "EE Bot", "Dmg Member " & $i, GUICtrlRead($EE_Dmg_members_checkbox[$i]))
		IniWrite($save_file, "EE Bot", "Free Heal Member " & $i, GUICtrlRead($EE_Free_members_checkbox[$i]))
		IniWrite($save_file, "EE Bot", "Super Heal Member " & $i, GUICtrlRead($EE_Super_members_checkbox[$i]))
		IniWrite($Save_file, "EE Bot", "Use DP member " & $i, GUICtrlRead($EE_DP_checkbox[$i]))
	Next
	IniWrite($save_file, "SM Bot", "AFK Type", GUICtrlRead($SM_regular_bot_radio))
	IniWrite($save_file, "SM Bot", "Nova spawn", GUICtrlRead($SM_NOVA_delay_input))
	IniWrite($save_file, "SM Bot", "Main skill", GUICtrlRead($SM_Main_afk_skill_input))
	IniWrite($save_file, "SM Bot", "Use Main Skill", GUICtrlRead($SM_main_afk_skill_checkbox))
	IniWrite($save_file, "SM Bot", "Nova skill", GUICtrlRead($SM_Nova_skill_input))
	IniWrite($save_file, "SM Bot", "Skill #2", GUICtrlRead($SM_afk_skill_2_input))
	IniWrite($save_file, "SM Bot", "Skill #3", GUICtrlRead($SM_afk_skill_3_input))
	IniWrite($save_file, "SM Bot", "Skill #4", GUICtrlRead($SM_afk_skill_4_input))
	IniWrite($save_file, "SM Bot", "Use skill #2", GUICtrlRead($SM_afk_skill_2_checkbox))
	IniWrite($save_file, "SM Bot", "Use skill #3", GUICtrlRead($SM_afk_skill_3_checkbox))
	IniWrite($save_file, "SM Bot", "Use skill #4", GUICtrlRead($SM_afk_skill_4_checkbox))
	IniWrite($Save_file, "SM Bot", "Main skill interval", GUICtrlRead($SM_Main_afk_skill_delay_input))
	IniWrite($Save_file, "SM Bot", "Skill #2 interval", GUICtrlRead($SM_afk_skill2_delay_input))
	IniWrite($Save_file, "SM Bot", "Skill #3 interval", GUICtrlRead($SM_afk_skill3_delay_input))
	IniWrite($Save_file, "SM Bot", "Skill #4 interval", GUICtrlRead($SM_afk_skill4_delay_input))
	IniWrite($save_file, "SM Bot", "Pickup items", GUICtrlRead($SM_pickup_items_checkbox))
	IniWrite($save_file, "BK Bot", "Use main skill", GUICtrlRead($BK_Main_skill_checkbox))
	IniWrite($Save_file, "BK Bot", "Main skill", GUICtrlRead($BK_Main_skill_input))
	IniWrite($Save_file, "BK Bot", "Main skill interval", GUICtrlRead($BK_Main_skill_interval_input))
	IniWrite($Save_file, "BK Bot", "use skill #2", GUICtrlRead($BK_Skill_2_checkbox))
	IniWrite($Save_file, "BK Bot", "use skill #3", GUICtrlRead($BK_Skill_3_checkbox))
	IniWrite($Save_file, "BK Bot", "use skill #4", GUICtrlRead($BK_Skill_4_checkbox))
	IniWrite($Save_file, "BK Bot", "skill #2", GUICtrlRead($BK_Skill_2_input))
	IniWrite($Save_file, "BK Bot", "skill #3", GUICtrlRead($BK_Skill_3_input))
	IniWrite($Save_file, "BK Bot", "skill #4", GUICtrlRead($BK_Skill_4_input))
	IniWrite($Save_file, "BK Bot", "Skill #2 interval", GUICtrlRead($BK_skill_2_interval))
	IniWrite($Save_file, "BK Bot", "Skill #3 interval", GUICtrlRead($BK_skill_3_interval))
	IniWrite($Save_file, "BK Bot", "Skill #4 interval", GUICtrlRead($BK_skill_4_interval))
	IniWrite($save_file, "BK Bot", "Combo Skill 1", GUICtrlRead($BK_Combo_skill_1_input))
	IniWrite($save_file, "BK Bot", "Combo Skill 2", GUICtrlRead($BK_Combo_skill_2_input))
	IniWrite($save_file, "BK Bot", "Combo Skill 3", GUICtrlRead($BK_Combo_skill_3_input))
	IniWrite($save_file, "BK Bot", "Combo Skill 1 interval", GUICtrlRead($BK_Combo_skill_1_interval))
	IniWrite($save_file, "BK Bot", "Combo Skill 2 interval", GUICtrlRead($BK_Combo_skill_2_interval))
	IniWrite($save_file, "BK Bot", "Combo Skill 3 interval", GUICtrlRead($BK_Combo_skill_3_interval))
	IniWrite($save_file, "BK Bot", "Pickup items", GUICtrlRead($BK_Pickup_items_checkbox))
	if GUICtrlRead($DL_Mouse_movement_vert_radio) = $GUI_CHECKED Then
		IniWrite($Save_file, "DL Bot", "Mouse movement", "1")
	ElseIf GUICtrlRead($DL_Mouse_movement_horiz_radio) = $GUI_CHECKED Then
		IniWrite($Save_file, "DL Bot", "Mouse movement", "2")
	ElseIf GUICtrlRead($DL_Mouse_movement_round_radio) = $GUI_CHECKED Then
		IniWrite($Save_file, "DL Bot", "Mouse movement", "3")
	Else
		IniWrite($Save_file, "DL Bot", "Mouse movement", "4")
	EndIf
	IniWrite($Save_file, "DL Bot", "Mouse speed", GUICtrlRead($DL_Mouse_movement_slider))
	IniWrite($save_file, "DL Bot", "Main skill", GUICtrlRead($DL_Main_skill_input))
	IniWrite($save_file, "DL Bot", "Use skill #2", GUICtrlRead($DL_Skill2_checkbox))
	IniWrite($Save_file, "DL Bot", "Skill #2", GUICtrlRead($DL_Skill2_input))
	IniWrite($save_file, "DL Bot", "Skill #2 interval", GUICtrlRead($DL_skill2_interval))
	IniWrite($save_file, "DL Bot", "Use skill #3", GUICtrlRead($DL_Skill3_checkbox))
	IniWrite($Save_file, "DL Bot", "Skill #3", GUICtrlRead($DL_Skill3_input))
	IniWrite($save_file, "DL Bot", "Skill #3 interval", GUICtrlRead($DL_skill3_interval))
	IniWrite($save_file, "DL Bot", "Use skill #4", GUICtrlRead($DL_Skill4_checkbox))
	IniWrite($Save_file, "DL Bot", "Skill #4", GUICtrlRead($DL_Skill4_input))
	IniWrite($save_file, "DL Bot", "Skill #4 interval", GUICtrlRead($DL_skill4_interval))
	IniWrite($save_file, "DL Bot", "Pickup items", GUICtrlRead($DL_pickup_items_checkbox))
;~ 	IniWrite($save_file, "DL Bot", "Repair horse", GUICtrlRead($DL_repair_horse_checkbox))
	for $i = 0 to 9
		IniWrite($save_file, "Macro bot", "Use macro " & $i, GUICtrlRead($Macro_checkbox[$i]))
		IniWrite($save_file, "Macro bot", "Macro text " & $i, GUICtrlRead($Macro_input[$i]))
	Next
	IniWrite($save_file, "Macro bot", "Alt", GUICtrlRead($Macro_Alt_Number_radio))
	IniWrite($save_file, "Macro bot", "Macro interval", GUICtrlRead($Macro_interval_input))
	if FileExists($Timer_file) then FileDelete($Timer_file)
	for $i = 0 to _GUICtrlListViewGetItemCount($Timer_listview)-1
		IniWrite($Timer_file, _GUICtrlListViewGetItemText($Timer_listview, $i, 0), "Repeat", _GUICtrlListViewGetItemText($Timer_listview, $i, 1))
		IniWrite($Timer_file, _GUICtrlListViewGetItemText($Timer_listview, $i, 0), "Interval", _GUICtrlListViewGetItemText($Timer_listview, $i, 2))
		IniWrite($Timer_file, _GUICtrlListViewGetItemText($Timer_listview, $i, 0), "Checked", _GUICtrlListViewGetCheckedState($Timer_listview, $i))
	Next
	IniWrite($save_file, "DC", "Bot type", GUICtrlRead($DC_bot_type_combo))
	IniWrite($save_file, "DC", "Character", GUICtrlRead($DC_bot_char_number_combo))
	IniWrite($save_file, "DC", "Realm", GUICtrlRead($DC_Bot_realm_combo))
	IniWrite($save_file, "DC", "Server", GUICtrlRead($DC_bot_server_combo))
	IniWrite($save_file, "DC", "Logs", GUICtrlRead($DC_Logs_checkbox))
	GUICtrlSetData($DISPLAY_SAVING, "Done!")
EndFunc

;~ Func _GUICtrlTreeView_SelectItem($hWnd, $hItem, $iFlag = 0)
;~ 	Local $TVGN_CARET = 0x00000009
;~ 	Local $TV_FIRST = 0x1100
;~ 	Local $TVM_SELECTITEM = $TV_FIRST + 11
;~ 	If Not IsHWnd($hWnd) Then $hWnd = GUICtrlGetHandle($hWnd)

;~ 	If $iFlag = 0 Then $iFlag = $TVGN_CARET
;~ 	Return _SendMessage($hWnd, $TVM_SELECTITEM, $iFlag, $hItem, 0, "wparam", "hwnd") <> 0
;~ EndFunc   ;==>_GUICtrlTreeView_SelectItem

;~ func _GUICtrlTreeView_FindItem($hWnd, $itemText, $iStart = 1)
;~ 	Local $return_val = "0"
;~ 	If Not IsHWnd($hWnd) Then $hWnd = GUICtrlGetHandle($hWnd)
;~ 	for $i = $iStart to _GUICtrlTreeViewGetCount($hWnd)
;~ 		if _GUICtrlTreeViewGetText($hWnd, $i) = $itemText Then
;~ 			$return_val = $i
;~ 			ExitLoop
;~ 		EndIf
;~ 	Next
;~ 	Return $i
;~ EndFunc

func _add_item_child($title = "Add", $Repeat = 0, $Timer = "00:00:00", $operationzzz = "")
	$Form3_Add_timer_item = GUICreate($title & " timer item: " & $operationzzz, 330+6, 200+33, 58, $Thick_border+11, $WS_CLIPSIBLINGS, $WS_EX_MDICHILD, $Form1)
;~ 	WinSetTrans($Form3_Add_timer_item, "", 255)
	GUISetBkColor(0xFFFFFF, $Form3_Add_timer_item)
	GUICtrlCreateGroup("Operation", 5, 5, 152+30, 190)
	$timer_treeview = GUICtrlCreateTreeView(10, 20, 142+30, 170, -1, $WS_EX_CLIENTEDGE)
	Local $OPERATIONS = "Activate:|Exit:|Warp to:|Set speed:|Say:|Switch bot:|Switch char:|Make:"
	Local $divided_operations = StringSplit($OPERATIONS, "|")
	dim $operations_in_treeview[$divided_operations[0]+1]
	Local $ICONS_timer = "274|240|244|290|282|255|171|248"
	Local $Divided_icons = StringSplit($ICONS_timer, "|")
	Local $Sub_op_Activate = "Infinite arrow|Auto party|Repair items|Drop items|Check 4 DC"
	Local $divided_sub_op_activate = StringSplit($Sub_op_Activate, "|")
	Local $Sub_op_Exit = "Exit MU Game|Close bot|Shutdown PC|Restart PC|DC Internet"
	Local $divided_sub_op_exit = StringSplit($Sub_op_Exit, "|")
	Local $Sub_op_warp = "Arena|Elveland|Elveland2|Elveland3|Lorencia|Noria|Devias|Devias2|Devias3|Devias4|Dungeon|Dungeon2|Dungeon3|Atlans|Atlans2|Atlans3|LostTower|LostTower2|LostTower3|LostTower4|LostTower5|LostTower6|LostTower7|Tarkan|Tarkan2|Icarus|Aida|Aida2|Kanturu|Kanturu2|Kanturu3|LaCleon|Swamp|other"
	Local $divided_Sub_op_warp = StringSplit($Sub_op_warp, "|")
	Local $Sub_op_Speed = "0,3|0,5|0,8|1|1,5|2|3|4|5|6|7|8|9|10|other"
	Local $divided_Sub_op_Speed = StringSplit($Sub_op_Speed, "|")
	Local $Sub_op_Say = "Go away|Find other spot|Nub|no KS|Hustle|-.-|Rush|Win|No share|NO PT|^^|lol|other"
	Local $divided_Sub_op_Say  = StringSplit($Sub_op_Say , "|")
	Local $Sub_op_SwitchBot = "AE|EE|DL|SM|BK|Macro"
	Local $divided_Sub_op_SwitchBot  = StringSplit($Sub_op_SwitchBot , "|")
;~ 	ConsoleWrite($operationzzz & @CRLF)
	_GUICtrlTreeViewSetBkColor($timer_treeview, 0xEAF4FE)
	for $i = 1 to $divided_operations[0]
		$operations_in_treeview[$i] = GUICtrlCreateTreeViewItem($divided_operations[$i], $timer_treeview)
		_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
		_GUICtrlTreeViewSetState($timer_treeview, -1, $TVIS_BOLD)
		Switch $i
			case 1
				for $j = 1 to $divided_sub_op_activate[0]
					GUICtrlCreateTreeViewItem($divided_sub_op_activate[$j], $operations_in_treeview[$i])
					_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
				Next
			case 2
				for $j = 1 to $divided_sub_op_exit[0]
					GUICtrlCreateTreeViewItem($divided_sub_op_exit[$j], $operations_in_treeview[$i])
					_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
				Next
			case 3
				for $j = 1 to $divided_Sub_op_warp[0]
					GUICtrlCreateTreeViewItem($divided_Sub_op_warp[$j], $operations_in_treeview[$i])
					_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
				Next
			case 4
				for $j = 1 to $divided_Sub_op_Speed[0]
					GUICtrlCreateTreeViewItem($divided_Sub_op_Speed[$j], $operations_in_treeview[$i])
					_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
				Next
			case 5
				for $j = 1 to $divided_Sub_op_Say[0]
					GUICtrlCreateTreeViewItem($divided_Sub_op_Say[$j], $operations_in_treeview[$i])
					_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
				Next
			case 6
				for $j = 1 to $divided_Sub_op_SwitchBot[0]
					GUICtrlCreateTreeViewItem($divided_Sub_op_SwitchBot[$j], $operations_in_treeview[$i])
					_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
				Next
			Case 7
				for $j = 1 to 5
					GUICtrlCreateTreeViewItem("Character " & $j, $operations_in_treeview[$i])
					_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
				Next
			case 8
				GUICtrlCreateTreeViewItem("ScreenShot", $operations_in_treeview[$i])
				_GUICtrlTreeViewSetIcon($timer_treeview, -1, "shell32.dll", -(Number($Divided_icons[$i])))
		EndSwitch
	Next
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateGroup("Repeat times", 165+30, 5, 157-30, 48)
	Local $Timer_add_repeat_input = GUICtrlCreateInput($Repeat, 175+30, 25-3, 137-30, 21, $ES_NUMBER+$ES_CENTER)
	GUICtrlSetLimit(-1, 9)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 999999, 0)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateGroup("Repeat interval [h:m:s]", 165+30, 65-10, 157-30, 48)
	Local $timer_add_interval_hours_input = GUICtrlCreateInput(StringLeft($Timer, 2), 205, 72, 35, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 99)
	Local $timer_add_interval_minutes_input = GUICtrlCreateInput(StringMid($Timer, 4, 2), 205+36, 72, 35, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 59)
	Local $timer_add_interval_seconds_input = GUICtrlCreateInput(StringRight($Timer, 2), 205+36*2, 72, 35, 21, $ES_NUMBER)
	GUICtrlSetLimit(-1, 2)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 59)
;~ 	Local $Timer_add_interval_input = GUICtrlCreateDate($Timer, 175+30, 85-10-3, 137-30, 21, 0x09)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Local $Timer_group_add_setup = GUICtrlCreateGroup("Other:", 165+30, 125-10*2+10, 157-30, 48)
	Local $timer_other_icon = GUICtrlCreateIcon($SHELL32, -211, 165+30+105, 113, 16, 16)
	GUICtrlSetCursor(-1, 0)
	Local $Timer_add_setup_input = GUICtrlCreateInput("", 175+30, 145-10*2-3+10, 137-30, 21)
;~ 	GUICtrlSetState($Timer_group_add_setup, $GUI_HIDE)
;~ 	GUICtrlSetState($Timer_add_setup_input, $GUI_HIDE)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

;~ 	if $title = "Edit" then
;~ 		Local $split_operation = StringSplit($operationzzz, ":")
;~ 		Local $foundeed = _GUICtrlTreeView_FindItem($timer_treeview, StringTrimLeft($split_operation[2], 1))
;~ 		if $foundeed <> "0" then
;~ 			_GUICtrlTreeView_SelectItem($timer_treeview, $foundeed)
;~ 		Else
;~ 			_GUICtrlTreeView_SelectItem($timer_treeview, );_GUICtrlTreeView_GetLastChild($timer_treeview, _GUICtrlTreeView_FindItem($timer_treeview, $split_operation[1] & ":")))
;~ 			GUICtrlSetData($Timer_add_setup_input, StringTrimLeft($split_operation[2], 1))
;~ 			ControlFocus($Form1, "", $Timer_add_setup_input)
;~ 		EndIf
;~ 	EndIf

	Local $Timer_button_OK = GUICtrlCreateButton("OK", 165+30, 170, 80-15, 25, 0)
	Local $Timer_Button_Cancel = GUICtrlCreateButton("Cancel", 245+15, 170, 80-15, 25, 0)
	GUISetState(@SW_DISABLE, $Form1)
	GUISetState(@SW_SHOW, $Form_4_shade)
	GUISetState(@SW_SHOW, $Form3_Add_timer_item)

	While 1

		if GUICtrlRead($timer_add_interval_minutes_input) > 59 then GUICtrlSetData($timer_add_interval_minutes_input, 59)
		if GUICtrlRead($timer_add_interval_seconds_input) > 59 then GUICtrlSetData($timer_add_interval_seconds_input, 59)
		if GUICtrlRead($Timer_add_repeat_input) = "999999999" Or GUICtrlRead($Timer_add_repeat_input) = "0" then GUICtrlSetData($Timer_add_repeat_input, " infinite")
;~ 		ElseIf GUICtrlRead($Timer_add_repeat_input) = "0" Then
;~ 			GUICtrlSetData($Timer_add_repeat_input, " infinite")
		Local $nMsg = GUIGetMsg()
		Switch $nMsg
			Case $timer_add_interval_minutes_input
				GUICtrlSetData($timer_add_interval_minutes_input, StringFormat("%02d", GUICtrlRead($timer_add_interval_minutes_input)))
			case $timer_add_interval_seconds_input
				GUICtrlSetData($timer_add_interval_seconds_input, StringFormat("%02d", GUICtrlRead($timer_add_interval_seconds_input)))
			case $timer_add_interval_hours_input
				GUICtrlSetData($timer_add_interval_hours_input, StringFormat("%02d", GUICtrlRead($timer_add_interval_hours_input)))
			Case $timer_other_icon
				MsgBox(0, "Help!", "If you select some operations such as Warp to, Set speed or Say," & @CRLF & "and you select sub-option as Other, then you can type a map you" & @CRLF & _
									"wish to warp or speed you wish to input, or something you wish to" & @CRLF & "say...  It is very useful for stuff that aren't displayed in the list.")
			Case $Timer_Button_Cancel
				GUISetState(@SW_HIDE, $Form_4_shade)
				GUISetState(@SW_ENABLE, $Form1)
				GUIDelete($Form3_Add_timer_item)
				if NOT WinActive($form1) then WinActivate($Form1)
				ExitLoop
			case $Timer_button_OK
				if GUICtrlRead(_GUICtrlTreeViewGetParentID($timer_treeview), 1) <> "0" OR StringLen(WinGetTitle($Form3_Add_timer_item)) > 17 Then
					Local $display
					Local $continue = true
					Local $repeat_read = GUICtrlRead($Timer_add_repeat_input)
					Local $TIMEEE = StringFormat("%02d:%02d:%02d",GUICtrlRead($timer_add_interval_hours_input),GUICtrlRead($timer_add_interval_minutes_input),GUICtrlRead($timer_add_interval_seconds_input));GUICtrlRead($Timer_add_interval_input)
					if StringInStr($repeat_read, ",") then $repeat_read = StringReplace($repeat_read, ",", "")
					if StringLen(WinGetTitle($Form3_Add_timer_item)) > 17 Then
						Local $display2 = GUICtrlRead(_GUICtrlTreeViewGetParentID($timer_treeview), 1)
						If GUICtrlRead(_GUICtrlTreeViewGetParentID($timer_treeview), 1) <> "0" then
							if GUICtrlRead($timer_treeview, 1) <> "other" then
								If GUICtrlRead($timer_treeview, 1) <> "" Then
									$display2 &= " " & GUICtrlRead($timer_treeview, 1)
								Else
									$display2 = ""
								EndIf
							Else
								if GUICtrlRead($Timer_add_setup_input) <> "" Then
									$display2 &= " " & GUICtrlRead($Timer_add_setup_input)
								Else
									$display2 = ""
								EndIf
							EndIf
						Else
							$display2 = ""
						EndIf

						$display = StringTrimLeft(WinGetTitle($Form3_Add_timer_item), StringInStr(WinGetTitle($Form3_Add_timer_item), ": ")+1)
						If $display2 <> "" AND $display <> $display2 Then $display = $display2

;~ 							MsgBox(0, "", "NE POKLAPA SE" & @CRLF & "novo je: " & $display2 & @CRLF & "staro: " & $display)
;~ 						EndIf
					Else
						$display = GUICtrlRead(_GUICtrlTreeViewGetParentID($timer_treeview), 1)
						if GUICtrlRead($timer_treeview, 1) <> "other" then
							$display &= " " & GUICtrlRead($timer_treeview, 1)
						Else
							if GUICtrlRead($Timer_add_setup_input) <> "" Then
								$display &= " " & GUICtrlRead($Timer_add_setup_input)
							Else
								MsgBox(0, "Error", "You haven't inserted anything instead of ""other""")
								$continue = false
							EndIf
						EndIf
					EndIf
					if $repeat_read = " infinite" then $repeat_read = "infinite"
					if $repeat_read <> "infinite" AND $repeat_read = 0 Then
						$repeat_read = "infinite"
;~ 						Switch MsgBox(3, "Error", "You haven't set the repeat time." & @CRLF & "Minimum is 1 time." & @CRLF & @CRLF & "Would you like me to set repeat to 1?")
;~ 							case 6 ;Yes
;~ 								$repeat_read = "1"
;~ 							case 7, 2 ;No, Cancel
;~ 								$continue = False
;~ 						EndSwitch
					ElseIf $repeat_read = " infinite" Then
						$repeat_read  = "infinite"
					EndIf
					if $TIMEEE = "00:00:00" AND $continue = True Then
						Switch MsgBox(3, "Error", "You haven't set the time interval." & @CRLF & "Minimum is 1 second." & @CRLF & @CRLF & "Would you like me to set timer to 1 sec?")
							case 6 ;Yes
								$TIMEEE = "00:00:01"
							case 7, 2 ;No, Cancel
								$continue = False
						EndSwitch
					EndIf
					if $continue = True then
						if $title = "Add" Then
							GuiCtrlCreateListViewItem($display & "|" & $repeat_read & "|" & $TIMEEE & "|" & $TIMEEE, $Timer_listview)
							_GUICtrlListViewSetCheckState($Timer_listview, _GUICtrlListViewGetItemCount($Timer_listview)-1, 1)
						Else
							_GUICtrlListViewSetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 0, $display)
							_GUICtrlListViewSetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 1, $repeat_read)
							_GUICtrlListViewSetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 2, $TIMEEE)
							_GUICtrlListViewSetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 3, $TIMEEE)
						EndIf
						GUISetState(@SW_ENABLE, $Form1)
						GUISetState(@SW_HIDE, $Form_4_shade)
						GUIDelete($Form3_Add_timer_item)
						$Form3_Add_timer_item = 0
						if NOT WinActive($form1) then WinActivate($Form1)
						ExitLoop
					EndIf
				Else
					MsgBox(0, "Error", "Sorry, but you haven't selected an option")
				EndIf
		EndSwitch
	WEnd
EndFunc

func _check_all_timers()
	Local $unchecked_timers = False
	Local $total_count = _GUICtrlListViewGetItemCount($Timer_listview)
	for $i = 0 to $total_count
		if _GUICtrlListViewGetCheckedState($Timer_listview, $i) = 0 Then
			$unchecked_timers = True
			ExitLoop
		EndIf
	Next
	if $unchecked_timers = True Then
		for $i = 0 to $total_count
			_GUICtrlListViewSetCheckState($Timer_listview, $i, 1)
		Next
	Else
		for $i = 0 to $total_count
			_GUICtrlListViewSetCheckState($Timer_listview, $i, 0)
		Next
	EndIf
EndFunc

func _set_names_($default = "")
	Local $names_x = IniReadSection($Usernames_file, "Usernames")
	if NOT @error Then
		Local $string_names = ""
		Local $string_IDs = ""
		for $i = 1 to $names_x[0][0]
			$string_names &= $names_x[$i][0] & "|"
			$string_IDs &= $names_x[$i][1] & "|"
		Next
		$string_names = StringTrimRight($string_names, 1)
		$string_IDs = StringTrimRight($string_IDs, 1)
		if $default = "" then
			Local $name_z = IniRead($Usernames_file, "Misc", "LastUsed", "")
			if $name_z <> "" then
				for $i = 1 to $names_x[0][0]
					if $name_z = $names_x[$i][0] Then
						GUICtrlSetData($Username_Input, $string_names, $names_x[$i][0])
						GUICtrlSetData($StrID_Input, $string_IDs, $names_x[$i][1])
						GUICtrlSetData($DC_Nickname_input, $string_names, $names_x[$i][0])
						GUICtrlSetData($DC_StrID_input, $string_IDs, $names_x[$i][1])
						IniWrite($Usernames_file, "Misc", "LastUsed", GUICtrlRead($Username_Input))
						GUICtrlSetData($DC_Password_input, _StringEncrypt(0, IniRead($Usernames_file, "Passwords", GUICtrlRead($Username_Input), ""), $encryption_password, $encryption_level))
						ExitLoop
					EndIf
				Next
			Else
				GUICtrlSetData($DC_Nickname_input, $string_names, $names_x[1][0])
				GUICtrlSetData($DC_StrID_input, $string_IDs, $names_x[1][1])
				GUICtrlSetData($Username_Input, $string_names, $names_x[1][0])
				GUICtrlSetData($StrID_Input, $string_IDs, $names_x[1][1])
				IniWrite($Usernames_file, "Misc", "LastUsed", GUICtrlRead($Username_Input))
				GUICtrlSetData($DC_Password_input, _StringEncrypt(0, IniRead($Usernames_file, "Passwords", GUICtrlRead($Username_Input), ""), $encryption_password, $encryption_level))
			EndIf
		Else
			GUICtrlSetData($Username_Input, $string_names, $default)
			GUICtrlSetData($DC_Nickname_input, $string_names, $default)
			IniWrite($Usernames_file, "Misc", "LastUsed", GUICtrlRead($Username_Input))
			GUICtrlSetData($DC_Password_input, _StringEncrypt(0, IniRead($Usernames_file, "Passwords", GUICtrlRead($Username_Input), ""), $encryption_password, $encryption_level))
			for $i = 1 to $names_x[0][0]
				if $names_x[$i][0] = $default Then
					GUICtrlSetData($DC_StrID_input, $string_IDs, $names_x[$i][1])
					GUICtrlSetData($StrID_Input, $string_IDs, $names_x[$i][1])
					ExitLoop
				EndIf
			Next
		EndIf
	EndIf
EndFunc

Func _ProcessListProperties($Process = "", $sComputer = ".") ;get strID
    Local $sUserName, $sMsg, $sUserDomain, $avProcs, $dtmDate
    Local $avProcs = ""
    $oWMI = ObjGet("winmgmts:{impersonationLevel=impersonate,authenticationLevel=pktPrivacy, (Debug)}!\\" & $sComputer & "\root\cimv2")
    If IsObj($oWMI) Then
        $colProcs = $oWMI.ExecQuery("select * from win32_process where Name = '" & $Process & "'")
        If IsObj($colProcs) Then
            If $colProcs.count = 0 Then Return $avProcs
            For $oProc In $colProcs
                $avProcs = $oProc.CommandLine
            Next
        Else
            SetError(2)
        EndIf
        $colProcs = 0
    Else
        SetError(1)
    EndIf
    Return $avProcs
EndFunc

func _set_mu_folder()
	Local $destination
	$destination = FileOpenDialog("Browse for MU file", "", "Mu.exe (Mu.exe)")
	if NOT @error Then
		RegWrite($MU_REG_CONFIG, "EXE", "REG_SZ", $destination)
		GUICtrlSetData($destination_input, $destination)
		Return 1
	EndIf
	Return 0
EndFunc

Func _start_mu()
	if IniRead($DC_File, "Options", "GMO Server", "1") = "1" then
		if NOT FileExists(@SystemDir & "\CMStarterCore.exe") Then
			If MsgBox(3, "Error", "Install latest webzen starter from:" & @CRLF & "http://www.webzen.net/_Files/WebzenGameStarter.exe" & @CRLF & "first, it's required for starting GMO..." & @CRLF & @CRLF & "Would you like me to download it for you?") Then ShellExecute("http://www.webzen.net/_Files/WebzenGameStarter.exe")
			Return 0
		EndIf
		if GUICtrlRead($Username_Input) <> "" Then
			if GUICtrlRead($StrID_Input) = "" Then
				MsgBox(0, "Error", "Please input strID")
				Return 0
			EndIf
		Else
			MsgBox(0, "Error", "Please type in your username")
			Return 0
		EndIf
		ShellExecute("CMStarterCore.exe", IniRead($Save_file, "Options", "XmlUrl", "http://www.webzen.net/_Files/StarterInfo.xml") & "|" & GUICtrlRead($StrID_Input) & "|" & GUICtrlRead($Username_Input) & "|" & IniRead($Save_file, "Options", "strKey", "EC33FD71-C518-4CC6-A934-B1377C9ADEB4") & "|" & IniRead($Save_file, "Options", "GameID", "1") & "|" & IniRead($Save_file, "Options", "ServiceID", "1") & "|" & IniRead($Save_file, "Options", "CountryID", "2") & "|" & IniRead($Save_file, "Options", "AuthUseType", "2"))
		if @error then
			MsgBox(0, "Error", "Install webzen launcher first!")
			Return 0
		EndIf
	Else
		Local $folder_for_mu = StringLeft(GUICtrlRead($destination_input), StringInStr(GUICtrlRead($destination_input), "\mu.exe"))
		ShellExecute("mu.exe", "", $folder_for_mu)
	EndIf
	IniWrite($Usernames_file, "Misc", "LastUsed", GUICtrlRead($Username_Input))
	if IniRead($DC_File, "Options", "Have launcher", "1") <> "1" then Return 0
	WinWait("MU Auto Update", "", 20)
	if NOT WinExists("MU Auto Update") then
		MsgBox(0, "Error", "Couldn't run Launcher window...")
		Return 0
	EndIf
	if GUICtrlRead($Auto_START_GAME_checkbox) = $GUI_CHECKED Then
        Local $brojac = 0
        Local $varrr = ""
        Local $pronasao = True
        do
            $brojac = $brojac+1
            $varrr = ControlCommand("MU Auto Update", "", "[CLASS:Button; INSTANCE:2]", "IsEnabled", "")
			if NOT WinExists("MU Auto Update") then
				$pronasao = False
				ExitLoop
			EndIf
            Sleep(125)
            if $brojac = 160 then
                $pronasao = False
;~                 ControlClick("MU Auto Update", "", "[CLASS:Button; INSTANCE:1]")
                ExitLoop
            EndIf
        Until $varrr = 1
        if $pronasao = True then ControlClick("MU Auto Update", "", "[CLASS:Button; INSTANCE:2]")
	EndIf
	Return 0
EndFunc

func _Create_shade_window_child()
	$Form_4_shade = GUICreate("", 447, 200+20, 0, 0, $WS_POPUP, $WS_EX_MDICHILD, $Form1)
	WinSetTrans($Form_4_shade, "", 120)
	GUISetBkColor(0)
	$DISPLAY_SAVING = GUICtrlCreateLabel("", 20, 50, 447-40, 150, $ES_CENTER)
	GUICtrlSetColor(-1, 0xB02D09)
	GUICtrlSetFont(-1, 36, 800, 2, "Arial")
	GUISetState(@SW_DISABLE, $Form_4_shade)
	GUISetState(@SW_HIDE, $Form_4_shade)
EndFunc

Func _unload_hotkeys()
	Local $allHK = IniReadSection($Hotkeys_File, "Hotkeys")
	If @error then Return 0
	For $i = 1 to $allHK[0][0]
		If $allHK[$i][1] <> "" then HotKeySet(IniRead($Hotkeys_File, "Hotkeys", $allHK[$i][0], $allHK[$i][1]))
	Next
EndFunc

Func _Load_Hotkeys()
	$HK_Start = IniRead($Hotkeys_File, "Hotkeys", "Start bot", "")
	$HK_Stop = IniRead($Hotkeys_File, "Hotkeys", "Stop bot", "")
	$HK_Left_clck = IniRead($Hotkeys_File, "Hotkeys", "Left clicking", "")
	$HK_Tog_Pick = IniRead($Hotkeys_File, "Hotkeys", "Toggle pickup", "")
	$HK_Rq_On = IniRead($Hotkeys_File, "Hotkeys", "Request on", "")
	$HK_Rq_Off = IniRead($Hotkeys_File, "Hotkeys", "Request off", "")
	$HK_Filt_Off = IniRead($Hotkeys_File, "Hotkeys", "Filter off", "")
	$HK_Filt_On = IniRead($Hotkeys_File, "Hotkeys", "Filter on", "")
	$HK_Set_Drop = IniRead($Hotkeys_File, "Hotkeys", "Set Drop Pos", "")
	$HK_Set_Pt = IniRead($Hotkeys_File, "Hotkeys", "Set AutoParty Pos", "")
	$HK_Act_PK = IniRead($Hotkeys_File, "Hotkeys", "Activate PK", "")
	$HK_Stop_DC = IniRead($Hotkeys_File, "Hotkeys", "Stop DC", "")
	$HK_Force_Drop = IniRead($Hotkeys_File, "Hotkeys", "Force drop", "")
	$HK_Force_Repair = IniRead($Hotkeys_File, "Hotkeys", "Force repair", "")
	$HK_Force_Exit = IniRead($Hotkeys_File, "Hotkeys", "Force close bot", "")
	$HK_Get_Color = IniRead($Hotkeys_File, "Hotkeys", "Get Item Color", "")
	For $i = 1 to 6
		$HK_EE_PT[$i] = IniRead($Hotkeys_File, "Hotkeys", "Set EE Party Member " & $i & " pos", "")
	Next
	HotKeySet($HK_Stop, "_Stop_Bot")
	HotKeySet($HK_Left_clck, "_Left_Click")
	HotKeySet($HK_Tog_Pick, "_Toggle_Pickup")
	HotKeySet($HK_Rq_On, "_Request_on")
	HotKeySet($HK_Rq_Off, "_Request_off")
	HotKeySet($HK_Filt_On, "_filter_on")
	HotKeySet($HK_Filt_Off, "_filter_off")
	HotKeySet($HK_Set_Drop, "_set_drop_spot")
	HotKeySet($HK_Set_Pt, "_set_party_spot")
	HotKeySet($HK_Force_Drop, "_drop_items")
	HotKeySet($HK_Force_Repair, "_Repair_items")
	HotKeySet($HK_Force_Exit, "_Close_bot")
	HotKeySet($HK_Get_Color, "Get_item_color")

	Switch GUICtrlRead($Tab2)
		case 0 ;AE
			HotKeySet($HK_Start, "_AE_Bot")
		case 1 ;EE
			HotKeySet($HK_Start, "_EE_Bot")
			HotKeySet($HK_EE_PT[1], "_Set_EE_member_loc")
			HotKeySet($HK_EE_PT[2], "_Set_EE_member_loc")
			HotKeySet($HK_EE_PT[3], "_Set_EE_member_loc")
			HotKeySet($HK_EE_PT[4], "_Set_EE_member_loc")
			HotKeySet($HK_EE_PT[5], "_Set_EE_member_loc")
			HotKeySet($HK_EE_PT[6], "_Set_EE_member_loc")
		case 2 ;SM
			HotKeySet($HK_Start, "_SM_Bot")
		case 3 ;BK
			HotKeySet($HK_Start, "_BK_Bot")
		case 4 ;DL
			HotKeySet($HK_Start, "_DL_Bot")
		case 5 ;Macro
			HotKeySet($HK_Start, "_Macro_Bot")
	EndSwitch
EndFunc

Func MyErrFunc()
    Local $HexNumber=hex($oMyError.number,8)
    Msgbox(0,"","We intercepted a COM Error !" & @CRLF & _
                "Number is: " & $HexNumber & @CRLF & _
                "WinDescription is: " & $oMyError.windescription & @CRLF & _
                "Source is: " & $oMyError.source & @CRLF & _
                "Line is: " & $oMyError.scriptline)
   $f_COMError = True
Endfunc

;~ While 1
;~ 	if GUIGetMsg() = $GUI_EVENT_CLOSE Then
;~ 		Exit
;~ 	EndIf
;~ WEnd