#include <snd2gui.au3>
;~ _Restore_child_positions()
#include <Constants.au3>
;~ #Include <A3LScreenCap.au3>
#Include <Misc.au3>

Opt ("PixelCoordMode", 2)
Opt ("CaretCoordMode", 2)
Opt ("MouseCoordMode", 2)
Opt ("WinTitleMatchMode", 3)
Opt ("MouseClickDownDelay", IniRead($Save_file, "Misc", "MouseDelay", $default_sleep_for_opts))
Opt ("MouseClickDelay", IniRead($Save_file, "Misc", "MouseDelay", $default_sleep_for_opts))
Opt ("SendKeyDownDelay", IniRead($Save_file, "Misc", "KeyboardDelay", $default_sleep_for_opts))
Opt ("SendKeyDelay", IniRead($Save_file, "Misc", "KeyboardDelay", $default_sleep_for_opts))
Opt ("GUICloseOnESC", 0)
Opt ("OnExitFunc", "Bot_Shut_Down")

;~ HotKeySet("{ESC}", "_QUITT")
;~ Func _QUITT()
;~ 	Exit
;~ EndFunc


#region bot's working variables
Global $ANY_BOT = False
Global $Mouse_Down_Click = Number(IniRead($save_file, "Misc", "RepairDropClickDelay", "500")), $Is_Bot_Key = False, $already_paused = False
Global $START_AE_Bot_from_bot = False,   $START_EE_Bot_from_bot = False, $START_BK_Bot_from_bot = False, $START_SM_Bot_from_bot = False, $START_DL_Bot_from_bot = False, $START_Macro_Bot_from_bot = False
Global $AfteR_Enter = Number(IniRead($Save_file, "Misc", "AfterEnterBreak", $default_sleep_for_opts)), $Timer_check = False, $ultima_x, $ultima_y

#endregion

;timer regulators (making timers go only once at a time
Global $AE_Regulator = False, $DL_regulator = False, $repair_regulator = False, $AutoParty_regulator = False, $drop_regulator = False
Global $CheckIfMuIsActiveTimer = TimerInit()

;for while
Global $check4pauseIni = IniRead($save_file, "Misc", "CheckForEnterPause", "1")
Global $checkifmuisactiveini = IniRead($save_file, "Misc", "CheckIfMuIsActive", "4")

AdlibEnable("_MAIN_TIMER", 250)

;Option Globals:
Global $Repair_items_timer, $AutoParty_timer, $Drop_items_timer, $repair_ready = False, $AutoParty_ready = False, $drop_ready = False
Global $Form2_visible, $Form_Drop_items_visible, $Form5_DC_setup_visible, $Form7_PkTool_visible, $Form3_Add_timer_item_visible, $Form_4_shade_visible

Global $HK_Rq_Off, $HK_Rq_Off

#region - if window is moved, then the child windows should not be visible (because of display bug)
Global Const $WM_ENTERSIZEMOVE = 0x0231
Global Const $WM_EXITSIZEMOVE = 0x0232
GUIRegisterMsg($WM_ENTERSIZEMOVE,"WM_ENTERSIZEMOVE")
GUIRegisterMsg($WM_EXITSIZEMOVE, "WM_EXITSIZEMOVE")

func WM_ENTERSIZEMOVE()
;~ 	GUISetState(@SW_HIDE, $form2)
	$Form2_visible = _win_get_visible($form2)
	$Form_Drop_items_visible = _win_get_visible($Form_Drop_items)
	$Form5_DC_setup_visible = _win_get_visible($Form5_DC_setup)
;~ 	$Form3_Add_timer_item_visible = _win_get_visible($Form3_Add_timer_item)
	$Form7_PkTool_visible = _win_get_visible($Form7_PkTool)
;~ 	$Form3_Add_timer_item_visible = _win_get_visible($Form3_Add_timer_item)
;~ 	$Form_4_shade_visible = _win_get_visible($Form_4_shade)
EndFunc

func WM_EXITSIZEMOVE()
;~ 	MsgBox(0, "", $Form2_visible)
;~ 	GUISetState(@SW_SHOWNOACTIVATE, $form2)
	if $Form2_visible then GUISetState(@SW_SHOWNOACTIVATE, $form2)
	if $Form_Drop_items_visible then GUISetState(@SW_SHOWNOACTIVATE, $Form_Drop_items)
	if $Form5_DC_setup_visible then GUISetState(@SW_SHOWNOACTIVATE, $Form5_DC_setup)
;~ 	if $Form3_Add_timer_item_visible then GUISetState(@SW_SHOWNOACTIVATE, $Form3_Add_timer_item)
	if $Form7_PkTool_visible then GUISetState(@SW_SHOWNOACTIVATE, $Form7_PkTool)
;~ 	if $Form3_Add_timer_item_visible then GUISetState(@SW_SHOWNOACTIVATE, $Form3_Add_timer_item)
;~ 	if $Form_4_shade_visible then GUISetState(@SW_SHOW, $Form_4_shade)
EndFunc

Func _win_get_visible($winHandle)
	Local $state = WinGetState($winHandle)
	GUISetState(@SW_HIDE, $winHandle)
;~ 	WinSetState($winHandle, "", @SW_HIDE)
	Return BitAND($state, 2)
EndFunc
#endregion

;~ GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
Global $Virtual_Box = False
Global $Fast_Start_Checking = False
Global $Fast_checking_pause = 15
Global $Start_String_check_dc = "/DC"

if $CmdLine[0] <> 0 Then
	for $i = 1 to $CmdLine[0]
		if $CmdLine[$i] = "/V" then
			$Virtual_Box = True
		ElseIf StringLeft($CmdLine[$i], StringLen($Start_String_check_dc)) = $Start_String_check_dc Then
			$Fast_Start_Checking = True
			Local $Pause_zxc = $CmdLineRaw
			$Pause_zxc = StringTrimLeft($Pause_zxc, StringInStr($Pause_zxc, $Start_String_check_dc)+StringLen($Start_String_check_dc)-1)
			if StringInStr($Pause_zxc, " ") then $Pause_zxc = StringLeft($Pause_zxc, StringInStr($Pause_zxc, " ")+1)
			$Fast_checking_pause = $Pause_zxc
		EndIf
	Next
EndIf

;~ Func _Force_MU_activation()
;~ 	If WinExists("MU") and NOT _winactive_ex("MU") then
;~ 		WinActivate("MU")
;~ 	ElseIf WinExists("MU (Not Responding") and Not _winactive_ex("MU (Not Responding") Then
;~ 		WinActivate("MU (Not Responding")
;~ 	EndIf
;~ 	Local $hwnd = DllCall($dll_load, "hwnd", "GetForegroundWindow")
;~ 	$hwnd = $hwnd[0]
;~ 	If WinGetTitle($hwnd) <> "MU" then
;~ 		WinActivate("MU")
;~ 	ElseIf WinGetTitle($hwnd) = "MU (Not Responding)" And Not _winactive_ex($hwnd) then
;~ 		WinActivate("MU (Not Responding)")
;~ 	EndIf
;~ EndFunc

Func _winactive_ex($title)
	Local $hwnd = _get_proper_handle()
;~ 	Local $hwnd = DllCall($dll_load, "hwnd", "GetForegroundWindow")
;~ 	$hwnd = $hwnd[0]
	If WinGetTitle($hwnd) = $title Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc

Func _get_proper_handle()
	Local $hwnd = DllCall($dll_load, "hwnd", "GetForegroundWindow")
	$hwnd = $hwnd[0]
	Local $parent = DllCall($dll_load, "hwnd", "GetParent", "hwnd", $hwnd)
;~ 	TrayTip("", $parent[0], 10)
	If $parent[0] <> 0 Then $hwnd = $parent[0]

;~ 	If WinGetTitle($hwnd) = "MU" Or WinGetTitle($hwnd) = "MU (Not Responding)" Then
		Return $hwnd
;~ 	ElseIf WinGetTitle($hwnd) = "MU (Not Responding)" Then
;~ 		Return $hwnd
;~ 	ElseIf WinExists("MU") then
;~ 		Return WinGetHandle("MU")
;~ 	Else
;~ 		Return -1
;~ 	EndIf
EndFunc

#include <DL BOT.au3>
#include <EE BOT.au3>
#include <RepairDrop.au3>
#include <Other.au3>
#include <AE BOT.au3>
#include <SM BOT.au3>
#include <BK BOT.au3>
#include <Macro.au3>
#include <Send Text.au3>
#include <GetPixel.au3>
#include <Disconnection.au3>
#include <Timer BOT.au3>

#region - starting parameters ----------
if $Fast_Start_Checking = True Then
	Local $ControlData
	Local $Pefrorm_operation = True
	Switch GUICtrlRead($Tab2)
		case 0 ;AE
			$ControlData = ($AE_Current_operation)
		case 1 ;EE
			$ControlData = ($EE_Current_operation)
		case 2 ;SM
			$ControlData = ($SM_Current_operation)
		case 3 ;BK
			$ControlData = ($BK_Current_operation)
		case 4 ;DL
			$ControlData = ($DL_Current_operation)
		case 5 ;Macro
			$ControlData = ($Macro_Current_operation)
	EndSwitch
	GUICtrlSetState($DC_Start_button, $GUI_DISABLE)
	GUICtrlSetState($DC_Stop_button, $GUI_ENABLE)
	Local $Counter_blahz = $Fast_checking_pause+1
	Local $Some_timer_z = 0;TimerInit()
	While 1
		$xnMsg = GUIGetMsg()
		Switch $xnMsg
			Case $GUI_EVENT_CLOSE
				Exit
			Case $DC_Stop_button
				$Pefrorm_operation = False
				GUICtrlSetState($DC_Stop_button, $GUI_DISABLE)
				GUICtrlSetState($DC_Start_button, $GUI_ENABLE)
				GUICtrlSetData($DC_Start_button, "Start checking for DC")
				ExitLoop
		EndSwitch
		if TimerDiff($Some_timer_z) >= 1000 OR TimerDiff($Some_timer_z) < 0 Then
			$Counter_blahz -= 1
			GUICtrlSetData($ControlData, "Wait: " & $Counter_blahz)
			GUICtrlSetData($DC_Start_button, "Wait: " & $Counter_blahz)
			$Some_timer_z = TimerInit()
		EndIf
		if $Counter_blahz = 0 then ExitLoop
	WEnd
	if $Pefrorm_operation = True then _Start_check_dc()
EndIf
#endregion

_Load_Hotkeys()

GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")

While 1
	if GUICtrlRead($EE_Buff_delay_input) > 60 then GUICtrlSetData($EE_Buff_delay_input, 60)
	if $check4pauseIni = "1" AND $Is_Bot_Key = False then
		if ControlCommand("MU", "", "[CLASS:Edit; INSTANCE:5]", "IsVisible", "") Then
			_Pause_Bot()
		EndIf
	EndIf
	if $PK_active = True then
		if NOT _IsPressed("11", $dll_load) Then
			Deactivate_PK()
		EndIf
	EndIf
	if GUICtrlRead($Tab2) = 3 AND GUICtrlRead($Tab1) = 2 AND _IsPressed("04", $dll_load) Then
		GUICtrlSetData($BK_Current_operation, "Combo!")
		GUICtrlSetColor($BK_Current_operation, $boje_zelena_GO)
		Do
			_BK_perform_combo()
		Until NOT _IsPressed("04", $dll_load)
		GUICtrlSetColor($BK_Combo_instructions_label, $boje_crvena_STOP)
		GUICtrlSetData($BK_Current_operation, "STOPPED")
		GUICtrlSetColor($BK_Current_operation, $boje_crvena_STOP)
	EndIf
	if GUICtrlRead($AE_Direction_Speed_Slider) <> $AE_Direction_Status_old Then
		$AE_Direction_Status_old = GUICtrlRead($AE_Direction_Speed_Slider)
		GUICtrlSetData($AE_Direction_Speed_Status, $AE_Direction_Status_old)
	EndIf
	if GUICtrlRead($DL_Mouse_movement_slider) <> $DL_speed_old Then
		$DL_speed_old = GUICtrlRead($DL_Mouse_movement_slider)
		GUICtrlSetData($DL_Mouse_movement_label, $DL_speed_old)
	EndIf

	if $START_AE_Bot_from_bot = True Then
		$START_AE_Bot_from_bot = False
		_AE_Bot()
	ElseIf $START_EE_Bot_from_bot = True Then
		$START_EE_Bot_from_bot = False
		_EE_Bot()
	ElseIf $START_SM_Bot_from_bot = True Then
		$START_SM_Bot_from_bot = False
		_SM_Bot()
	ElseIf $START_BK_Bot_from_bot = True Then
		$START_BK_Bot_from_bot = False
		_BK_Bot()
	ElseIf $START_DL_Bot_from_bot = True Then
		$START_DL_Bot_from_bot = False
		_DL_Bot()
	ElseIf $START_Macro_Bot_from_bot = True Then
		$START_Macro_Bot_from_bot = False
		_Macro_Bot()
	EndIf

	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $DL_Mouse_reduce_button
			_set_the_mouse_reduction("DL")
		Case $AE_Mouse_reduce_button
			_set_the_mouse_reduction("AE")
		Case $Additional_Setup_Button
			_Create_Additional_Setup_Window()
		Case $GUI_EVENT_RESTORE
			_Restore_child_positions()
		Case $GUI_EVENT_CLOSE
			_Close_bot()
		case $Resolution_combo
			if GUICtrlRead($Resolution_combo) = "800x600" Then
				RegWrite($MU_REG_CONFIG, "Resolution", "REG_DWORD", "1")
			ElseIf GUICtrlRead($Resolution_combo) = "1024x768" Then
				RegWrite($MU_REG_CONFIG, "Resolution", "REG_DWORD", "2")
			Else
				RegWrite($MU_REG_CONFIG, "Resolution", "REG_DWORD", "3")
			EndIf
		case $EE_Free_heal_delay_UpDown
			Local $EE_time_read = GUICtrlRead($EE_Free_heal_delay_input)
			if StringLen($EE_time_read) = 1 AND $EE_time_read <> "0" then
				GUICtrlSetData($EE_Free_heal_delay_input, "0" & "," & StringRight($EE_time_read, 1))
			elseif $EE_time_read <> "9,9" AND $EE_time_read <> "0" then
				GUICtrlSetData($EE_Free_heal_delay_input, StringTrimRight($EE_time_read, 1) & "," & StringRight($EE_time_read, 1))
			EndIf
		case $SM_NOVA_delay_up_down
			Local $SM_time_read1 = GUICtrlRead($SM_NOVA_delay_input)
			if StringLen($SM_time_read1) = 1 AND $SM_time_read1 <> "0" Then
				GUICtrlSetData($SM_NOVA_delay_input, "0" & "," & StringRight($SM_time_read1, 1))
			ElseIf $SM_time_read1 <> "99,9" AND $SM_time_read1 <> "0" Then
				GUICtrlSetData($SM_NOVA_delay_input, StringTrimRight($SM_time_read1, 1) & "," & StringRight($SM_time_read1, 1))
			EndIf
		case $SM_Main_afk_skill_delay_up_down
			Local $SM_time_read1 = GUICtrlRead($SM_Main_afk_skill_delay_input)
			if StringLen($SM_time_read1) = 1 AND $SM_time_read1 <> "0" Then
				GUICtrlSetData($SM_Main_afk_skill_delay_input, "0" & "," & StringRight($SM_time_read1, 1))
			ElseIf $SM_time_read1 <> "9,9" AND $SM_time_read1 <> "0" Then
				GUICtrlSetData($SM_Main_afk_skill_delay_input, StringTrimRight($SM_time_read1, 1) & "," & StringRight($SM_time_read1, 1))
			EndIf
		case $BK_Main_skill_interval_up_down
			Local $BK_Time_read1 = GUICtrlRead($BK_Main_skill_interval_input)
			if StringLen($BK_Time_read1) = 1 AND $BK_Time_read1 <> "0" Then
				GUICtrlSetData($BK_Main_skill_interval_input, "0" & "," & StringRight($BK_Time_read1, 1))
			ElseIf $BK_Time_read1 <> "9,9" AND $BK_Time_read1 <> "0" Then
				GUICtrlSetData($BK_Main_skill_interval_input, StringTrimRight($BK_Time_read1, 1) & "," & StringRight($BK_Time_read1, 1))
			EndIf
		case $Username_Input, $DC_Nickname_input
			if $nMsg = $Username_Input Then
				GUICtrlSetData($DC_Nickname_input, GUICtrlRead($Username_Input))
			Else
				GUICtrlSetData($Username_Input, GUICtrlRead($DC_Nickname_input))
			EndIf
			GUICtrlSetData($DC_Password_input, _StringEncrypt(0, IniRead($Usernames_file, "Passwords", GUICtrlRead($Username_Input), ""), $encryption_password, $encryption_level))
			GUICtrlSetData($StrID_Input, IniRead($Usernames_file, "Usernames", GUICtrlRead($Username_Input), ""))
			GUICtrlSetData($DC_StrID_input, IniRead($Usernames_file, "Usernames", GUICtrlRead($Username_Input), ""))
			if GUICtrlRead($Username_Input) <> "" AND GUICtrlRead($StrID_Input) <> "" then IniWrite($Usernames_file, "Misc", "LastUsed", GUICtrlRead($Username_Input))
		case $StrID_Input, $DC_StrID_input
			Local $names_x = IniReadSection($Usernames_file, "Usernames")
			Local $strr_read
			if $nMsg = $StrID_Input Then
				$strr_read = GUICtrlRead($StrID_Input)
			Else
				$strr_read = GUICtrlRead($DC_StrID_input)
			EndIf
			if NOT @error Then
				for $i = 1 to $names_x[0][0]
					if $names_x[$i][1] = $strr_read then
						GUICtrlSetData($Username_Input, $names_x[$i][0])
						GUICtrlSetData($DC_Nickname_input, $names_x[$i][0])
						if $nMsg = $StrID_Input Then
							GUICtrlSetData($DC_StrID_input, GUICtrlRead($StrID_Input))
						Else
							GUICtrlSetData($StrID_Input, GUICtrlRead($DC_StrID_input))
						EndIf
						GUICtrlSetData($DC_Password_input, _StringEncrypt(0, IniRead($Usernames_file, "Passwords", GUICtrlRead($Username_Input), ""), $encryption_password, $encryption_level))
						IniWrite($Usernames_file, "Misc", "LastUsed", GUICtrlRead($Username_Input))
						ExitLoop
					EndIf
				Next
			EndIf
			if GUICtrlRead($Username_Input) <> "" AND GUICtrlRead($StrID_Input) <> "" then IniWrite($Usernames_file, "Misc", "LastUsed", GUICtrlRead($Username_Input))
		case $Timer_Add_button, $Timer_context_Add_item
			_add_item_child()
		case $Timer_Edit_button, $Timer_context_Edit_item
			if _GUICtrlListViewGetCurSel($Timer_listview) <> -1 then _add_item_child("Edit", _GUICtrlListViewGetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 1), _GUICtrlListViewGetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 2), _GUICtrlListViewGetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 0))
		case $Tab1
			if GUICtrlRead($Tab1) = 2 then
				GUISetState(@SW_SHOWNOACTIVATE, $Form2)
				GUISetState(@SW_SHOWNOACTIVATE, $Form1)
			Else
				GUISetState(@SW_HIDE, $Form2)
				GUISetState(@SW_SHOWNOACTIVATE, $Form1)
			EndIf
		case $Tab2
			Switch GUICtrlRead($Tab2)
				case 0 ;AE
					HotKeySet($HK_Start, "_AE_Bot")
					HotKeySet($HK_EE_PT[1])
					HotKeySet($HK_EE_PT[2])
					HotKeySet($HK_EE_PT[3])
					HotKeySet($HK_EE_PT[4])
					HotKeySet($HK_EE_PT[5])
					HotKeySet($HK_EE_PT[6])
				case 1 ;EE
					HotKeySet($HK_Start, "_EE_Bot")
					HotKeySet($HK_EE_PT[1], "_Set_EE_member_loc")
					HotKeySet($HK_EE_PT[2], "_Set_EE_member_loc")
					HotKeySet($HK_EE_PT[3], "_Set_EE_member_loc")
					HotKeySet($HK_EE_PT[4], "_Set_EE_member_loc")
					HotKeySet($HK_EE_PT[5], "_Set_EE_member_loc")
					HotKeySet($HK_EE_PT[6], "_Set_EE_member_loc")
				case 2 ;SM
					HotKeySet($HK_Start, "_SM_Bot")
					HotKeySet($HK_EE_PT[1])
					HotKeySet($HK_EE_PT[2])
					HotKeySet($HK_EE_PT[3])
					HotKeySet($HK_EE_PT[4])
					HotKeySet($HK_EE_PT[5])
					HotKeySet($HK_EE_PT[6])
				case 3 ;BK
					HotKeySet($HK_Start, "_BK_Bot")
					HotKeySet($HK_EE_PT[1])
					HotKeySet($HK_EE_PT[2])
					HotKeySet($HK_EE_PT[3])
					HotKeySet($HK_EE_PT[4])
					HotKeySet($HK_EE_PT[5])
					HotKeySet($HK_EE_PT[6])
				case 4 ;DL
					HotKeySet($HK_Start, "_DL_Bot")
					HotKeySet($HK_EE_PT[1])
					HotKeySet($HK_EE_PT[2])
					HotKeySet($HK_EE_PT[3])
					HotKeySet($HK_EE_PT[4])
					HotKeySet($HK_EE_PT[5])
					HotKeySet($HK_EE_PT[6])
				case 5 ;Macro
					HotKeySet($HK_Start, "_Macro_Bot")
					HotKeySet($HK_EE_PT[1])
					HotKeySet($HK_EE_PT[2])
					HotKeySet($HK_EE_PT[3])
					HotKeySet($HK_EE_PT[4])
					HotKeySet($HK_EE_PT[5])
					HotKeySet($HK_EE_PT[6])
			EndSwitch
	EndSwitch
	Sleep(1)
WEnd

func _MAIN_TIMER();check for other skills, Repair, Drop items, Party, Pickup, Timer, Disconnect
	if $check4pauseIni = "1" AND $Is_Bot_Key = False then
		if ControlCommand("MU", "", "[CLASS:Edit; INSTANCE:5]", "IsVisible", "") Then
			_Pause_Bot()
		EndIf
	EndIf
	if $AE_Bot = true then ;AE Timer
		if $AE_Ready = True AND $AE_Regulator = True Then
			$AE_Regulator = False
			if TimerDiff($AE_Buff_timer) >= $AE_Buff_Interval*1000 OR TimerDiff($AE_Buff_timer) < 0 Then
;~ 				MouseUp("Right")
				_AE_buff()
			EndIf
			if TimerDiff($AE_Combine_Skills_Timer) >= $AE_Combine_Skills_Random OR TimerDiff($AE_Combine_Skills_Timer) < 0 Then
				_AE_Switch_skills()
			EndIf
			if TimerDiff($AE_Inf_Arrow_timer) >= (($Inf_Arrow_duration*60000)-($inf_arrow_reduceee*1000)) OR TimerDiff($AE_Inf_Arrow_timer) < 0 Then
				MouseUp("Right")
				_AE_Infinite_arrow()
			EndIf
			$AE_Regulator = True
		EndIf
	EndIf
	If $SM_Bot = true then ;SM Timer
		if GUICtrlRead($SM_NOVA_bot_radio) = $GUI_CHECKED AND $SM_Nova_down = True AND $SM_Bot_Ready = True Then
			if StringInStr(GUICtrlRead($SM_NOVA_delay_input), ",") Then
				Local $split_nova = StringSplit(GUICtrlRead($SM_NOVA_delay_input), ",")
				Local $sec_nova = $split_nova[1]
				Local $mil_nova = $split_nova[2]
			Else
				$sec_nova = 0
				$mil_nova = 0
			EndIf
			GUICtrlSetData($Nova_skill_progress, TimerDiff($SM_Nova_timer)*100/($SM_Nova_Timer_Delay+$sec_nova*1000+$mil_nova*100))
		EndIf
	EndIf
	If $DL_Bot = true then ;DL Timer
		if $DL_Bot_Ready = True AND $DL_regulator = True Then
			if GUICtrlRead($DL_Skill2_checkbox) = $GUI_CHECKED OR GUICtrlRead($DL_Skill3_checkbox) = $GUI_CHECKED OR GUICtrlRead($DL_Skill4_checkbox) = $GUI_CHECKED then
				$DL_regulator = False
				_DL_check_for_other_skills()
				$DL_regulator = True
			EndIf
		EndIf
	EndIf
	if GUICtrlRead($Repair_items_checkbox) = $GUI_CHECKED AND TimerDiff($Repair_items_timer) >= Number(GUICtrlRead($Repair_items_interval_input))*1000*60 OR TimerDiff($Repair_items_timer) < 0 then
		if $SM_Bot = True Then
			if $SM_Nova_down = False Then
				if $repair_ready = True AND $repair_regulator = True then
					$repair_regulator = False
					_Repair_items()
					$Repair_items_timer = TimerInit()
					$repair_regulator = True
				EndIf
			EndIf
		Else
			if $repair_ready = True AND $repair_regulator = True then
				$repair_regulator = False
				_Repair_items()
				$Repair_items_timer = TimerInit()
				$repair_regulator = True
			EndIf
		EndIf
	EndIf
	if GUICtrlRead($AutoParty_checkbox) = $GUI_CHECKED AND TimerDiff($AutoParty_timer) >= Number(GUICtrlRead($AutoParty_Interval_input))*1000 OR TimerDiff($AutoParty_timer) < 0 then
		if $SM_Bot = True Then
			if $SM_Nova_down = False Then
				if $AutoParty_ready = True AND $AutoParty_regulator = True then
					$AutoParty_regulator = False
					_Auto_party()
					$AutoParty_timer = TimerInit()
					$AutoParty_regulator = True
				EndIf
			EndIf
		Else
			if $AutoParty_ready = True AND $AutoParty_regulator = True then
				$AutoParty_regulator = False
				_Auto_party()
				$AutoParty_timer = TimerInit()
				$AutoParty_regulator = True
			EndIf
		EndIf
	EndIf
	if GUICtrlRead($Drop_items_checkbox) = $GUI_CHECKED AND TimerDiff($Drop_items_timer) >= Number(GUICtrlRead($Drop_Items_Interval))*1000*60 OR TimerDiff($Drop_items_timer) < 0 then
		if $SM_Bot = True Then
			if $SM_Nova_down = False Then
				if $drop_ready = True AND $drop_regulator = True then
					$drop_regulator = False
					_Drop_items()
					$Drop_items_timer = TimerInit()
					$drop_regulator = True
				EndIf
			EndIf
		Else
			if $drop_ready = True AND $drop_regulator = True then
				$drop_regulator = False
				_Drop_items()
				$Drop_items_timer = TimerInit()
				$drop_regulator = True
			EndIf
		EndIf
	EndIf
	if $Timer_check = True Then
		$Timer_check = False
		_Timer_check()
		$Timer_check = True
	EndIf
	if $Check_for_DC = True then; AND TimerDiff($DC_Check_timer) >= 1000 Then ;each second
;~ 		$Check_for_DC = False
;~ 		$DC_Check_timer = TimerInit()
		_DC_Check()
;~ 		if $Starting_to_login = True then $Check_for_DC = True
	EndIf
	if GUICtrlRead($Tab1) = 2 AND WinGetState($form2) = 5 Then
		GUISetState(@SW_SHOWNOACTIVATE, $form2)
	ElseIf GUICtrlRead($Tab1) <> 2 AND WinGetState($form2) >= 7 Then
		GUISetState(@SW_HIDE, $form2)
	EndIf
	If $DrinkHPState = True Then
		If _winactive_ex("MU") OR _winactive_ex("MU (Not Responding)") then
			If TimerDiff($DrinkHPTimer) >= $DrinkHPInterval Or TimerDiff($DrinkHPTimer) < 0 Then
				Local $polovina_x = Number(StringLeft(GUICtrlRead($Resolution_combo), StringInStr(GUICtrlRead($Resolution_combo), "x")-1))
;~ 				Local $MU_size = _client_size(("MU"))
				Switch $polovina_x
					Case 800
						Local $coordinates[3] = [225, 542, 578]
					Case 1024
						Local $coordinates[3] = [288, 694, 740]
					Case else
						Local $coordinates[3] = [360, 925, 986]
;~ 					case Else
;~ 						Local $polovina_x = Number(StringLeft(GUICtrlRead($Resolution_combo), StringInStr(GUICtrlRead($Resolution_combo), "x")-1))
;~ 						If $polovina_x = 800 Then
;~ 							Local $coordinates[3] = [225, 542, 578]
;~ 						ElseIf $polovina_x = 1024 Then
;~ 							Local $coordinates[3] = [288, 694, 740]
;~ 						Else
;~ 							Local $coordinates[3] = [360, 925, 986]
;~ 						EndIf
;	~ 					Local $polovina_Y = $MU_size[1];Number(StringTrimLeft(GUICtrlRead($Resolution_combo), StringInStr(GUICtrlRead($Resolution_combo), "x")))
				EndSwitch
				Local $y_coordinate = Round((90-$DrinkHPpcntg)*($coordinates[2]-$coordinates[1])/(90-10)+$coordinates[1])
				Local $HPColor = pixel_get_color($coordinates[0], $y_coordinate)
				Local $sivooo = _get_Gray_(Hex($HPColor, 6), 5)
				If $sivooo = True then Send("{" & $DrinkHPHK & "}")
				$DrinkHPTimer = TimerInit()
			EndIf
		EndIf
	EndIf
;~ 	$Watch4AG = False, $Watch4AGTimer, $Watch4AGInterval, $Watch4AG_recharging = False, $Watch4AG_recharge_pcntg, $Watch4AG_low_pcntg, $Watch4AGSkill1, $Watch4AGSkill2
	If $Watch4AG = True Then
		If _winactive_ex("MU") OR _winactive_ex("MU (Not Responding)") then
			If TimerDiff($Watch4AGTimer) >= $Watch4AGInterval Or TimerDiff($Watch4AGTimer) < 0 Then
				Local $polovina_x = Number(StringLeft(GUICtrlRead($Resolution_combo), StringInStr(GUICtrlRead($Resolution_combo), "x")-1))
				Switch $polovina_x
					Case 800
						Local $coordinates[3] = [534, 542, 578]
					Case 1024
						Local $coordinates[3] = [683, 694, 740]
					Case else
						Local $coordinates[3] = [854, 925, 986]
				EndSwitch
				If $Watch4AG_recharging = True Then
					Local $y_coordinate = Round((90-$Watch4AG_high_pcntg)*($coordinates[2]-$coordinates[1])/(90-10)+$coordinates[1])
					Local $Watch4AGColor = pixel_get_color($coordinates[0], $y_coordinate)
					Local $sivooo = _get_Gray_(Hex($Watch4AGColor, 6), 5)
					If $sivooo = False then
						Switch GUICtrlRead($Tab2)
							case 0 ;AE
								GUICtrlSetData($AE_Weapon_skill, $Watch4AGSkill1)
							Case 2 ;SM
								if GUICtrlRead($SM_NOVA_bot_radio) = $GUI_CHECKED then
									GUICtrlSetData($SM_Nova_skill_input, $Watch4AGSkill1)
								Else
									GUICtrlSetData($SM_Main_afk_skill_input, $Watch4AGSkill1)
								EndIf
							Case 3 ;BK
								GUICtrlSetData($BK_Main_skill_input, $Watch4AGSkill1)
							Case 4 ;DL
								GUICtrlSetData($DL_Main_skill_input, $Watch4AGSkill1)
						EndSwitch
						If GUICtrlRead($Tab2) <> 1 AND GUICtrlRead($Tab2) <> 5 then Send("{" & $Watch4AGSkill1 & "}" & "{" & $Watch4AGSkill1 & "}")
						$Watch4AG_recharging = False
					EndIf
				Else
					Local $y_coordinate = Round((90-$Watch4AG_recharge_pcntg)*($coordinates[2]-$coordinates[1])/(90-10)+$coordinates[1])
					Local $Watch4AGColor = pixel_get_color($coordinates[0], $y_coordinate)
					Local $sivooo = _get_Gray_(Hex($Watch4AGColor, 6), 5)
					If $sivooo = True then
						Switch GUICtrlRead($Tab2)
							case 0 ;AE
								GUICtrlSetData($AE_Weapon_skill, $Watch4AGSkill2)
							Case 2 ;SM
								if GUICtrlRead($SM_NOVA_bot_radio) = $GUI_CHECKED then
									GUICtrlSetData($SM_Nova_skill_input, $Watch4AGSkill2)
								Else
									GUICtrlSetData($SM_Main_afk_skill_input, $Watch4AGSkill2)
								EndIf
							Case 3 ;BK
								GUICtrlSetData($BK_Main_skill_input, $Watch4AGSkill2)
							Case 4 ;DL
								GUICtrlSetData($DL_Main_skill_input, $Watch4AGSkill2)
						EndSwitch
						If GUICtrlRead($Tab2) <> 1 AND GUICtrlRead($Tab2) <> 5 then Send("{" & $Watch4AGSkill2 & "}" & "{" & $Watch4AGSkill2 & "}")
						$Watch4AG_recharging = True
					EndIf
				EndIf
				$Watch4AGTimer = TimerInit()
			EndIf
		EndIf
	EndIf
	If $ANY_BOT = True Then
		If $checkifmuisactiveini = "1" Then
			If TimerDiff($CheckIfMuIsActiveTimer) >= $CheckIfMuIsActiveInterval Or TimerDiff($CheckIfMuIsActiveTimer) < 0 Then
				If Not _winactive_ex("MU") then WinActivate("MU")
				$CheckIfMuIsActiveTimer = TimerInit()
			EndIf
		EndIf
	EndIf
EndFunc

func _Pause_Bot()
	_Mouse_Capture()
	if $already_paused = True then Return 0
	$already_paused = True
	Local $ControlData, $cur_trap = 0
	Switch GUICtrlRead($Tab2)
		case 0 ;AE
			$ControlData = ($AE_Current_operation)
			$cur_trap = 2
		case 1 ;EE
			$ControlData = ($EE_Current_operation)
			$cur_trap = 2
		case 2 ;SM
			$ControlData = ($SM_Current_operation)
			$cur_trap = 1
		case 3 ;BK
			$ControlData = ($BK_Current_operation)
			$cur_trap = 1
		case 4 ;DL
			$ControlData = ($DL_Current_operation)
			$cur_trap = 2
		case 5 ;Macro
			$ControlData = ($Macro_Current_operation)
	EndSwitch
	AdlibDisable()
	Local $return_text = GUICtrlRead($ControlData)
	GUICtrlSetData($ControlData, "PAUSE 4 CHAT")
	GUICtrlSetColor($ControlData, $boje_crvena_STOP)
;~ 	if $DEBUGGING = True then FileWrite($Debug_file, "Pause bot for chatting" & @TAB & @TAB & @HOUR & ":" & @MIN & ":" & @SEC & @TAB & @MDAY & "\" & @MON & "\" & @YDAY & @CRLF)
	While 1 ;pause bot
		_sleep_ex(10)
		if NOT WinExists("MU") then ExitLoop
		If NOT ControlCommand("MU", "", "[CLASS:Edit; INSTANCE:5]", "IsVisible", "") then ExitLoop
	WEnd
;~ 	Until NOT ControlCommand("MU", "", "[CLASS:Edit; INSTANCE:5]", "IsVisible", "")
	$already_paused = False
	AdlibEnable("_MAIN_TIMER", 250)
	GUICtrlSetData($ControlData, $return_text)
	If $ANY_BOT = True Then _Mouse_Capture($cur_trap)
	Return 0
EndFunc

#region initiate bot's through bot itself
func _Real_AE_bot()
;~ 	if $ANY_BOT = True then Return 0
;~ 	$AE_Bot = true
;~ 	$ANY_BOT = True
	$START_AE_Bot_from_bot = True
EndFunc

func _Real_EE_bot()
;~ 	if $ANY_BOT = True then Return 0
;~ 	$EE_Bot = true
;~ 	$ANY_BOT = True
	$START_EE_Bot_from_bot = True
EndFunc

func _Real_SM_bot()
;~ 	if $ANY_BOT = True then Return 0
;~ 	$SM_Bot = true
;~ 	$ANY_BOT = True
	$START_SM_Bot_from_bot = True
EndFunc

func _Real_BK_bot()
;~ 	if $ANY_BOT = True then Return 0
;~ 	$SBK_Bot = true
;~ 	$ANY_BOT = True
	$START_BK_Bot_from_bot = True
EndFunc

func _Real_DL_bot()
;~ 	if $ANY_BOT = True then Return 0
;~ 	$DL_Bot = true
;~ 	$ANY_BOT = True
	$START_DL_Bot_from_bot = True
EndFunc

func _Real_Macro_bot()
;~ 	if $ANY_BOT = True then Return 0
;~ 	$Macro_Bot = true
;~ 	$ANY_BOT = True
	$START_Macro_Bot_from_bot = True
EndFunc
#endregion

func _Stop_Bot()
;~ 	if $DEBUGGING = True then FileWrite($Debug_file, "STOP BOT" & @TAB & @TAB & @HOUR & ":" & @MIN & ":" & @SEC & @TAB & @MDAY & "\" & @MON & "\" & @YDAY & @CRLF)
	$Repairing = False
	$Dropping = False
	$repair_ready = False
	$AutoParty_ready = False
	$drop_ready = False
	$AE_Bot = False
	$AE_Ready = False
	$EE_Bot = False
	$SM_Bot = False
	$SM_Bot_Ready = False
	$SM_Nova_down = False
	GUICtrlSetData($Nova_skill_progress, 0)
	$BK_Bot = False
	$DL_Bot = False
	$DL_Bot_Ready = False
	$Macro_Bot = False
	$Left_Click = False
	Local $ControlData
	Switch GUICtrlRead($Tab2)
		case 0 ;AE
			$ControlData = ($AE_Current_operation)
		case 1 ;EE
			$ControlData = ($EE_Current_operation)
		case 2 ;SM
			$ControlData = ($SM_Current_operation)
		case 3 ;BK
			$ControlData = ($BK_Current_operation)
		case 4 ;DL
			$ControlData = ($DL_Current_operation)
		case 5 ;Macro
			$ControlData = ($Macro_Current_operation)
	EndSwitch
	GUICtrlSetData($ControlData, "STOPPED")
	GUICtrlSetColor($ControlData, $boje_crvena_STOP)
	$ANY_BOT = False
	MouseUp("Right")
	_Mouse_Capture()
	$DrinkHPState = False
	$undropable = ""
	Return 0
EndFunc

func _Close_bot()
	MouseUp("Right")
	if $Timer_check = True then _Stop_Timer()
;~ 	WinSetTrans($Form_4_shade, "", 200)
;~ 	GUICtrlSetData($DISPLAY_SAVING, "Saving data, please wait...")
;~ 	GUISetState(@SW_SHOW, $Form_4_shade)
;~ 	if $PK_tool_is_out = True then
;~ 		GUISetState(@SW_HIDE, $Form7_PkTool)
;~ 		$PK_tool_is_out = False
;~ 	EndIf
	_Save_data()
;~ 	$Data_Savedd = 1
;~ 	GUICtrlSetData($DISPLAY_SAVING, "Done!")
	Exit
EndFunc

func Bot_Shut_Down()
	_Mouse_Capture()
;~ 	if $Data_Savedd = 0 then _Save_data()
	DllClose($NTDll)
	DllClose($dll_load)
	DllClose($ByPassDll)
EndFunc

;~ Func WM_NOTIFY($hWndGUI, $MsgID, $wParam, $lParam)
;~ 	#forceref $hWndGUI, $MsgID, $wParam
;~ 	$nID = BitAnd($wParam, 0x0000FFFF)
;~ 	;TrayTip("", $nID, 10)
;~ 	;if $hWndGUI = $Form3_Add_timer_item AND $nID = 24598 then TrayTip("", $lParam, 10);AND $lParam <> 0x0012F5D0  AND $lParam <> 0x0012F5D4 AND $lParam <> 0x0012F40C AND $lParam <> 0x0012EFA4  AND  $lParam <> 0x0012EC88 AND $lParam <> 0x0012EFA0  AND $lParam <> 0x0012F2B0  AND $lParam <> 0x0012E7C0  AND $lParam <> 0x0012F4AC AND $lParam <> 0x0012EAB0 then TrayTip($nID, $lParam, 10)
;~ 	if $lParam = 0x0012EAB0 OR $lParam = 0x0012E700 AND $nID = 24598 AND $hWndGUI = $Form3_Add_timer_item then
;~ 		if StringLen(WinGetTitle($Form3_Add_timer_item)) > 17 Then
;~ 			WinSetTitle($Form3_Add_timer_item, "", StringLeft(WinGetTitle($Form3_Add_timer_item), StringInStr(WinGetTitle($Form3_Add_timer_item), ": ")))
;~ 		EndIf
;~ 		Local $readings = GUICtrlRead(_GUICtrlTreeViewGetParentID($timer_treeview), 1)
;~ 		Switch $readings
;~ 			case "Warp to:"
;~ 				if GUICtrlRead($timer_treeview, 1) = "other" Then
;~ 					if GUICtrlRead($Timer_group_add_setup) <> "Warp to: (map name)" Then
;~ 						GUICtrlSetData($Timer_add_setup_input, "")
;~ 						GUICtrlSetData($Timer_group_add_setup, "Warp to: (map name)")
;~ 					EndIf
;~ 					if ControlCommand($Form3_Add_timer_item, "", "[CLASS:Edit; INSTANCE:2]", "IsVisible", "") <> 1 then
;~ 						GUICtrlSetData($Timer_add_setup_input, "")
;~ 						GUICtrlSetState($Timer_group_add_setup, $GUI_SHOW)
;~ 						GUICtrlSetState($Timer_add_setup_input, $GUI_SHOW)
;~ 					EndIf
;~ 				Else
;~ 					if ControlCommand($Form3_Add_timer_item, "", "[CLASS:Edit; INSTANCE:2]", "IsVisible", "") = 1 then
;~ 						GUICtrlSetState($Timer_group_add_setup, $GUI_HIDE)
;~ 						GUICtrlSetState($Timer_add_setup_input, $GUI_HIDE)
;~ 					EndIf
;~ 				EndIf
;~ 			case "Set Speed:"
;~ 				if GUICtrlRead($timer_treeview, 1) = "other" Then
;~ 					if GUICtrlRead($Timer_group_add_setup) <> "Set speed to:" then
;~ 						GUICtrlSetData($Timer_add_setup_input, "")
;~ 						GUICtrlSetData($Timer_group_add_setup, "Set speed to:")
;~ 					EndIf
;~ 					if ControlCommand($Form3_Add_timer_item, "", "[CLASS:Edit; INSTANCE:2]", "IsVisible", "") <> 1 then
;~ 						GUICtrlSetData($Timer_add_setup_input, "")
;~ 						GUICtrlSetState($Timer_group_add_setup, $GUI_SHOW)
;~ 						GUICtrlSetState($Timer_add_setup_input, $GUI_SHOW)
;~ 					EndIf
;~ 				Else
;~ 					if ControlCommand($Form3_Add_timer_item, "", "[CLASS:Edit; INSTANCE:2]", "IsVisible", "") = 1 then
;~ 						GUICtrlSetState($Timer_group_add_setup, $GUI_HIDE)
;~ 						GUICtrlSetState($Timer_add_setup_input, $GUI_HIDE)
;~ 					EndIf
;~ 				EndIf
;~ 			case "Say:"
;~ 				if GUICtrlRead($timer_treeview, 1) = "other" Then
;~ 					if GUICtrlRead($Timer_group_add_setup) <> "Say something:" Then
;~ 						GUICtrlSetData($Timer_add_setup_input, "")
;~ 						GUICtrlSetData($Timer_group_add_setup, "Say something:")
;~ 					EndIf
;~ 					if ControlCommand($Form3_Add_timer_item, "", "[CLASS:Edit; INSTANCE:2]", "IsVisible", "") <> 1 then
;~ 						GUICtrlSetData($Timer_add_setup_input, "")
;~ 						GUICtrlSetState($Timer_group_add_setup, $GUI_SHOW)
;~ 						GUICtrlSetState($Timer_add_setup_input, $GUI_SHOW)
;~ 					endif
;~ 				Else
;~ 					if ControlCommand($Form3_Add_timer_item, "", "[CLASS:Edit; INSTANCE:2]", "IsVisible", "") = 1 then
;~ 						GUICtrlSetState($Timer_group_add_setup, $GUI_HIDE)
;~ 						GUICtrlSetState($Timer_add_setup_input, $GUI_HIDE)
;~ 					EndIf
;~ 				EndIf
;~ 			case Else
;~ 				if ControlCommand($Form3_Add_timer_item, "", "[CLASS:Edit; INSTANCE:2]", "IsVisible", "") = 1 then
;~ 					GUICtrlSetState($Timer_group_add_setup, $GUI_HIDE)
;~ 					GUICtrlSetState($Timer_add_setup_input, $GUI_HIDE)
;~ 				EndIf
;~ 		EndSwitch
;~ 		Return 0
;~ 	EndIf
;~ 	Return $GUI_RUNDEFMSG
;~ EndFunc

Func WM_COMMAND($hWnd, $iMsg, $iwParam, $ilParam)
	Switch $iwParam
		Case $IsoSoundJewelBtn
			_test_play("eGem.wav")
		Case $IsoSoundMailBtn
			_test_play("iFMailAlert.wav")
		Case $IsoSoundWhispBtn
			_test_play("iWhisper.wav")
		Case $IsoSoundGemBtn
			_test_play("Jewel_Sound.wav")
		Case $IsoSoundLVLUPBtn
			_test_play("pLevelUp.wav")
		Case $IsoSoundMaleDieBtn
			_test_play("pMaleDie.wav")
		Case $IsoSoundBeepBtn
			_test_play("beep.wav")
		Case $CHAT_check_for_update_button
			Local $get_version = _INetGetSource2("http://personal.stcable.net/~bata55/Snd/cvsb.txt")
			Local $split_version = StringSplit($get_version, "|")
			If IsArray($split_version) Then
				Local $pre_title = "v" & $Version_of_the_bot
				If $Is_beta = True then $pre_title &= " (Beta " & $beta_version & ")"
				If $split_version[1] = $pre_title Then
					MsgBox(0, "Already updated", "Your version is: " & $pre_title & @CRLF & "It's most recent version published.")
				Else
					Switch MsgBox(4, "Update?", "Your version is: " & $pre_title & @CRLF & "Version " & $split_version[1] & " is available for downloading." & @CRLF & @CRLF & "Would you like me to download latest version?")
						Case 6 ;yes
							ShellExecute($split_version[2])
					EndSwitch
				EndIf
			EndIf
		Case $Change_Hotkeys_button
			ShellExecute($Hotkeys_File)
		Case $ServerIPButton
			ShellExecute($DC_File)
		case $Chat_view_logs_button
			if FileExists(GUICtrlRead($CHAT_Logs_folder_input)) then ShellExecute(GUICtrlRead($CHAT_Logs_folder_input))
		case $Donate_PayPal_ico, $Donate_Label, $Donate_Smiley
			ShellExecute("https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=9318350")
		case $CHAT_Official_Website_label
			ShellExecute("http://sndbots.wetpaint.com")
		Case $DC_Start_button
			_Start_check_dc()
		case $DC_Stop_button
			_Stop_check_dc()
		Case $Timer_Start_button
			_Start_Timer()
		Case $Timer_Stop_button
			_Stop_Timer()
		Case $DL_Pic_ver
			GUICtrlSetState($DL_Mouse_movement_vert_radio, $GUI_CHECKED)
		case $DL_pic_hor
			GUICtrlSetState($DL_Mouse_movement_horiz_radio, $GUI_CHECKED)
		case $DL_pic_cir
			GUICtrlSetState($DL_Mouse_movement_round_radio, $GUI_CHECKED)
		Case $DL_Pic_Ran
			GUICtrlSetState($DL_Mouse_movement_random_radio, $GUI_CHECKED)
		case $DC_View_logs_button
			if FileExists($DC_Log_file) Then
				ShellExecute($DC_Log_file)
			Else
				MsgBox(0, "Error", "There is nothing recoreded yet...")
			EndIf
		case $PK_Button
			$PK_tool_is_out = True
			GUISetState(@SW_SHOW, $Form7_PkTool)
			GUICtrlSetState($PK_Button, $GUI_DISABLE)
			HotKeySet($HK_Act_PK, "Activate_PK")
			HotKeySet("^" & $HK_Act_PK, "Deactivate_PK")
		case $PK_Tool_close_button
			$PK_tool_is_out = False
			GUISetState(@SW_HIDE, $Form7_PkTool)
			GUICtrlSetState($PK_Button, $GUI_ENABLE)
			HotKeySet($HK_Filt_Off, "_filter_off")
			HotKeySet("^" & $HK_Act_PK)
		case $DC_Bot_and_server_setup
			GUISetState(@SW_SHOW, $Form_4_shade)
			GUISetState(@SW_SHOW, $Form5_DC_setup)
		case $DC_Setup_close_button
			GUISetState(@SW_HIDE, $Form_4_shade)
			GUISetState(@SW_HIDE, $Form5_DC_setup)
		case $drop_items_close_button
			GUISetState(@SW_HIDE, $Form_4_shade)
			GUISetState(@SW_HIDE, $Form_Drop_items)
		case $Drop_items_setup_button
			GUISetState(@SW_SHOW, $Form_4_shade)
			GUISetState(@SW_SHOW, $Form_Drop_items)
		case $START_MU_BUTTON
			if RegRead($MU_REG_CONFIG, "EXE") = "" Then
				MsgBox(0, "Error", "You must set Mu folder first!")
				Local $ret = _set_mu_folder()
				if $ret = 1 then _start_mu()
			Else
				_start_mu()
			EndIf
		case $Get_str_ID_button, $DC_GetStrID_button
			Local $avRET = _ProcessListProperties("CMStarterCore.exe")
			if $avRET = "" then
				if WinExists("Mu Auto Update") Then
					MsgBox(0, "Error", "You probably have outdated webzen starter" & @CRLF & "or ran mu via main.exe or mu.exe (which is not" & @CRLF & "permited - must run it from webzen webpage)")
				Else
					MsgBox(0, "Error", "Launcher (Mu Auto Update) window" & @CRLF & "doesn't exist..." & @CRLF & @CRLF & "Get to launcher window via your" & @CRLF & "browser, then press this button...")
				EndIf
			Else
				Local $divided_process = StringSplit($avRET, "|")
				Local $XmlUrl = StringTrimLeft($divided_process[1], StringInStr($divided_process[1], "http://")-1)
				Local $strrIDD = $divided_process[2]
				Local $usser_name = $divided_process[3]
				Local $StrKeyy = $divided_process[4]
				Local $Game_ID = $divided_process[5]
				Local $Service_ID = $divided_process[6]
				Local $Country_ID = $divided_process[7]
				Local $AuthUseType = $divided_process[8]
				IniWrite($Save_file, "Misc", "strKey", $StrKeyy)
				IniWrite($Save_file, "Misc", "GameID", $Game_ID)
				IniWrite($Save_file, "Misc", "ServiceID", $Service_ID)
				IniWrite($Save_file, "Misc", "CountryID", $Country_ID)
				IniWrite($Save_file, "Misc", "AuthUseType", $AuthUseType)
				IniWrite($Save_file, "Misc", "XmlUrl", $XmlUrl)
				GUICtrlSetData($Username_Input, $usser_name, $usser_name)
				GUICtrlSetData($DC_Nickname_input, $usser_name, $usser_name)
				GUICtrlSetData($StrID_Input, $strrIDD, $strrIDD)
				GUICtrlSetData($DC_StrID_input, $strrIDD, $strrIDD)
			EndIf
		case $Save_User_button, $DC_Save_pair_button
			Local $read_username
			Local $read_strID
			if $iwParam = $Save_User_button Then
				$read_username = GUICtrlRead($Username_Input)
				$string_IDs = GUICtrlRead($StrID_Input)
			Else
				$read_username = GUICtrlRead($DC_Nickname_input)
				$string_IDs = GUICtrlRead($DC_StrID_input)
			EndIf
			Local $globalz = Number(IniRead($DC_File, "Options", "GMO Server", "1"))
			if $read_username <> "" Or $globalz <> 1 Then
				if $string_IDs <> "" Or $globalz <> 1 Then
					$exit_loop = false
					Local $names_x = IniReadSection($Usernames_file, "Usernames")
					if NOT @error AND $iwParam = $Save_User_button Then
						for $i = 1 to $names_x[0][0]
							if $names_x[$i][0] = $read_username then
								MsgBox(0, "Error", "Such username already exist.")
								$exit_loop = true
								ExitLoop
							EndIf
							if $names_x[$i][1] = $string_IDs And $globalz <> 1 then
								MsgBox(0, "Error", "Such strID already exist.")
								$exit_loop = true
								ExitLoop
							EndIf
						Next
					EndIf
					if $exit_loop = False then
						If $globalz <> 1 then Regwrite("HKEY_CURRENT_USER\Software\Webzen\Mu\Config", "ID", "REG_SZ", GUICtrlRead($DC_Nickname_input))
						IniWrite($Usernames_file, "Usernames", $read_username, $string_IDs)
						if $iwParam = $DC_Save_pair_button then IniWrite($Usernames_file, "Passwords", $read_username, _StringEncrypt(1, GUICtrlRead($DC_Password_input), $encryption_password, $encryption_level))
						GUICtrlSetData($Username_Input, $read_username, $read_username)
						GUICtrlSetData($StrID_Input, $string_IDs, $string_IDs)
						GUICtrlSetData($DC_Nickname_input,$read_username, $read_username)
						GUICtrlSetData($DC_StrID_input, $string_IDs, $string_IDs)
						IniWrite($Usernames_file, "Misc", "LastUsed", $read_username)
					EndIf
				Else
					MsgBox(0, "Error", "strID can't be empty.")
				EndIf
			Else
				MsgBox(0, "Error", "Username can't be empty.")
			EndIf
		case $Delete_User_button, $DC_Delete_pair_button
			Local $read_username
			if $iwParam = $Delete_User_button Then
				$read_username = GUICtrlRead($Username_Input)
			Else
				$read_username = GUICtrlRead($DC_Nickname_input)
			EndIf
			IniDelete($Usernames_file, "Usernames", $read_username)
			IniDelete($Usernames_file, "Passwords", $read_username)
			GUICtrlSetData($Username_Input, "")
			GUICtrlSetData($StrID_Input, "")
			GUICtrlSetData($DC_Nickname_input, "")
			GUICtrlSetData($DC_StrID_input, "")
			IniWrite($Usernames_file, "Misc", "LastUsed", $read_username)
			Local $reader = IniReadSection($Usernames_file, "Usernames")
			if NOT @error Then
				Local $name_j = $reader[1][0]
				_set_names_($name_j)
			Else
				_set_names_()
			EndIf
		case $CHAT_browse_folder_button
			Local $log_fl = FileSelectFolder("Choose LOG folder", "", 7)
			if NOT @error then GUICtrlSetData($CHAT_Logs_folder_input, $log_fl)
		case $CHAT_Forum_label
			ShellExecute("http://sndbots.wetpaint.com/forum")
		case $CHAT_Mail_label
			ShellExecute("mailto:sandin@tippnet.rs")
		case $CHAT_Start_program_button
			Local $nickk = GUICtrlRead($CHAT_nickname_input)
			if $nickk = "sandin" OR $nickk = "SYSTEM" OR $nickk = "chanserv" then
				MsgBox(0, "Error", "You can't choose that nick, it's locked!")
			Else
				IniWrite($Chat_file, "CHAT", "Nick", GUICtrlRead($CHAT_nickname_input))
				IniWrite($Chat_file, "CHAT", "LOGs", GUICtrlRead($CHAT_keep_logs_checkbox))
				IniWrite($Chat_file, "CHAT", "LOG Folder", GUICtrlRead($CHAT_Logs_folder_input))
				IniWrite($Chat_file, "CHAT", "First Run", "0")
				if FileExists(@ScriptDir & "\Data\SndChat.exe") then ShellExecute(@ScriptDir & "\Data\SndChat.exe")
			EndIf
		case $Timer_check_all
			_check_all_timers()
		case $Timer_Delete_button, $Timer_context_Delete_item
			IniDelete($Timer_file, _GUICtrlListViewGetItemText($Timer_listview, _GUICtrlListViewGetCurSel($Timer_listview), 0))
			_GUICtrlListViewDeleteItemsSelected($Timer_listview)
		Case $Repair_all_items_button
			_check_all($Repair_items)
		case $Macro_all_button
			_check_all($Macro_checkbox, 0)
		case $EE_all_members_button
			_check_all($EE_Party_members_checkbox)
		case $EE_all_members_def_button
			_check_all($EE_Def_members_checkbox)
		case $EE_all_members_dmg_button
			_check_all($EE_Dmg_members_checkbox)
		case $EE_all_members_heal_button
			_check_all($EE_Heal_members_checkbox)
		case $EE_all_members_FREE_button
			_check_all($EE_Free_members_checkbox)
		case $EE_all_members_DP_button
			_check_all($EE_DP_checkbox)
		case $EE_all_members_SUPER_button
			_check_all($EE_Super_members_checkbox)
		case $EE_all_members_all_buff_button
			_check_all_ult()
		case $EE_ALL_members_buff_button[1], $EE_ALL_members_buff_button[2], $EE_ALL_members_buff_button[3], $EE_ALL_members_buff_button[4], $EE_ALL_members_buff_button[5], $EE_ALL_members_buff_button[6]
			_check_all2($iwParam)
		case $AE_All_direction_button
			_check_all($AE_Direction_Checkbox)
		case $Drop_items_fill_all_button
			if GUICtrlRead($Drop_items_field[1][1]) = $GUI_CHECKED Then
				for $i = 1 to 8
					for $j = 1 to 8
						GUICtrlSetState($Drop_items_field[$i][$j], $GUI_UNCHECKED)
					Next
				Next
			Else
				for $i = 1 to 8
					for $j = 1 to 8
						GUICtrlSetState($Drop_items_field[$i][$j], $GUI_CHECKED)
					Next
				Next
			EndIf
		case $Drop_Items_fill_random_button
			for $i = 1 to 8
				for $j = 1 to 8
					if Random(1, 100, 1) <= GUICtrlRead($Drop_items_random_perc_input) then
						GUICtrlSetState($Drop_items_field[$i][$j], $GUI_CHECKED)
					Else
						GUICtrlSetState($Drop_items_field[$i][$j], $GUI_UNCHECKED)
					EndIf
				Next
			Next
		Case $AutoParty_Help_icon
			MsgBox(0, "Help!", "If you select Manual as party side, then you must" & @CRLF & "define auto-party location by moving your mouse" & @CRLF & _
								"to desired location and hitting Shift+F8.")
		Case $Drop_items_side_help_icon
			MsgBox(0, "Help!", "If you select Manual as drop side, then you must" & @CRLF & "define drop location by moving your mouse to desired" & @CRLF & _
								"place and hitting Shift+F7. If you have trouble" & @CRLF & "with bot clicking to wrong inventory fields then you" & @CRLF & _
								"must define first inventory field by moving your" & @CRLF & "mouse to middle of first inventory field and hitting" & @CRLF & _
								"Shift+F6.")
		Case $Pause_bot_when_Chat_help_icon
			MsgBox(0, "Help!", "When checked, bot will pause itself everytime you" & @CRLF & "start chatting with in-game whisper-chat. Usefull for" & @CRLF & _
								"EE bot, but for SM/AE/BK/DL it's easier to press" & @CRLF & "F8 and toggle pickup, so you can chat while bot is still" & @CRLF & _
								"working, though if you use advanced options of each" & @CRLF & "bot type, with sending more than 1 skills in game, you" & @CRLF & _
								"should consider using this option.")
		case $PK_Tool_help_icon
			MsgBox(0, "Help!", "PK Tool is addition to Snd.Bot which will allow you" & @CRLF & "to PK without holding CTRL button. All you need to" & @CRLF & _
								"do is press hotkey F5 and bot will hold down CTRL" & @CRLF & "button, so you won't have to hold it during PK. Please" & @CRLF & _
								"be advised that when CTRL is holding down, other" & @CRLF & "keys don't work normally, so if u want to chat, or do" & @CRLF & _
								"something else, press Ctrl+F5 so Bot will release" & @CRLF & "CTRL and you will continue to play normally.")
		case $DC_TOTAL_help_icon
			MsgBox(0, "Help!", "This entire TAB is used to setup your bot in case of" & @CRLF & "disconnection. So, it means that you can setup bot" & @CRLF & _
								"to reconnect after disconnection and continue to work." & @CRLF & "This ofcourse means you have to input your pass, so" & @CRLF & _
								"USE ON YOUR OWN RISK, I dont want to be accused if" & @CRLF & "you get hacked for using some other tools and then" & @CRLF & _
								"blaim me!" & @CRLF & @CRLF & _
								"Press Bot and Server setup button to set your realm," & @CRLF & "server and bot type. If you check Save logs as well" & @CRLF & _
								"bot will keep records on all of your disconnections" & @CRLF & "and reconnections, and the counter will keep records" & @CRLF & _
								"since the last time you started bot." & @CRLF & @CRLF & _
								"To start checking for disconnection press Start checking" & @CRLF & "button, or Stop button to stop.")
		case $Timer_help_icon
			MsgBox(0, "Help!", "You can set various operations to this timer, which" & @CRLF & "may help you in game for certain things, such as" & @CRLF & _
								"make screen-shot, repair items, teleport to maps," & @CRLF & "disconnect, activate other bot, change speed (both" & @CRLF & _
								"mouse movement or main skill click), play song..." & @CRLF & @CRLF & _
								"Use right click on the list, or press buttons bellow" & @CRLF & "to add / remove / or edit items from the list. Only" & @CRLF & _
								"checked timers will be performed, unchecked will" & @CRLF &"not! Press Start / Stop button to activate or stop" & @CRLF & _
								"checked items from the list.")
		case $Macro_help_icon
			MsgBox(0, "Help!", "Select your macro type. Send text - When checked," & @CRLF & "bot will send exact txt you typed into fileds" & @CRLF & _
								"in this section. Alt+number - When checked, bot" & @CRLF & "will send ALT+Numbers from 0 to 9, but in order" & @CRLF & _
								"for game to send some txt, you must setup your" & @CRLF & "macro in game. To do so, press ENTER for normal" & @CRLF & _
								"chat, and type in: ""/7 #S>Items"" without quotes" & @CRLF & "where 7 is number for which we want to define" & @CRLF & _
								"macro, and # means it will last longer.")
		case $DL_skills_help_icon
			MsgBox(0, "Help!", "Set main skill you use for your AFK with DL, you" & @CRLF & "can use FireBurst, FireScream or other. You" & @CRLF & _
								"can also use 3 more different skills, like Horse" & @CRLF & "skill, or Critical Dmg, or Raven skill..." & @CRLF & _
								"Each skill can have it's own interval for it to" & @CRLF & "repeat itself, for example Horse can recharge" & @CRLF & _
								"in 12 seconds, Critical Dmg ~70+sec, etc..." & @CRLF & @CRLF & _
								"If you check Repair horse checkbox, then your DL" & @CRLF & "will repair your horse when repair time occur" & @CRLF & _
								"which you can setup in the Options tab.")
		case $BK_combo_help_icon
			MsgBox(0, "Help!", "First you set skill hotkeys you use in combo," & @CRLF & "then you set speed clicking for each of the" & @CRLF & _
								"skills (higher number = faster clicking - for" & @CRLF & "BKs with greater speed, and lower number =" & @CRLF & _
								"slower clicking - for BKs with less speed)." & @CRLF & @CRLF & _
								"When you setup all the requires things, simply" & @CRLF & "hold your middle mouse button to perform" & @CRLF & _
								"combo with your BK. You may miss combo if your" & @CRLF & "BK is too far from monster, or when your" & @CRLF & _
								"BK is filling MANA.")
		case $BK_skills_help_icon
			MsgBox(0, "Help!", "Set your main skill hotkey to your Twisting slash," & @CRLF & "or regefull or any other skill you usually use" & @CRLF & _
								"during your AFK time. And set the main skill's" & @CRLF & "time interval (which indicates after how many" & @CRLF & _
								"seconds will the skill repeat itself). You can do" & @CRLF & "this for 3 more skills (which you can setup as" & @CRLF & _
								"Fortitude, or other).")
		case $SM_bot_type_help_icon
			MsgBox(0, "Help!", "Use regular bot type for normal AFK, such as" & @CRLF & "bot with evil spirit and similar, or choose" & @CRLF & _
								"NOVA type to AFK using NOVA skill. Both types" & @CRLF & "support multiple skills, which means, you" & @CRLF & _
								"can choose more skills with your AFK type.")
		case $SM_skills_help_icon
			MsgBox(0, "Help!", "Select skills you wish to use, and their time" & @CRLF & "intervals in seconds. As main skill you can" & @CRLF & _
								"use Evil Spirit, Decay, Icestorm, etc... or any" & @CRLF & "other skill you use during your AFK. You can" & @CRLF & _
								"also use other skills under ""skill #2/3/4"" for" & @CRLF & "additional skills, such as Soul Barrier, or" & @CRLF & _
								"similar, and their time intervals. Nova skill" & @CRLF & "interval can be set under NOVA SETUP section.")
		case $SM_nova_spawn_help_icon
			MsgBox(0, "Help!", "The monster spawn time is time required for monster" & @CRLF & "to spawn/summon after his death. But that's the" & @CRLF & _
								"time without NOVA charge time. For example, if mob." & @CRLF & "need 14 seconds to spawn, then you input 6 sec." & @CRLF & _
								"cuz 14-8 = 6 (max Nova charge time = 8 sec.). That's" & @CRLF & "How you hit monster soon as they spawns. If you" & @CRLF & _
								"still don't understand, go to Lost Tower 2, set mob" & @CRLF & "spawn time to 5,3 sec. and test NOVA AFK to see" & @CRLF & _
								"what I mean.")
		case $EE_members_buff_help_icon
			MsgBox(0, "Help!", "Check members you wish to buff, and buffs you" & @CRLF & "wish them to get. There are two new buffs:" & @CRLF & @CRLF & _
								"Free heal - member will be healed until next" & @CRLF & "buff session. It means that after you buff" & @CRLF & _
								"all your party members, the one selected with" & @CRLF & "free heal will be healed until next buff" & @CRLF & _
								"session. Usefull for low def party members..." & @CRLF & @CRLF & _
								"Super heal - member will be healed after you" & @CRLF & "buff any of your members. It means that after" & @CRLF & _
								"each of your members recieve buff, the one" & @CRLF & "with super heal will be healed right after. It" & @CRLF & _
								"can be combined with free heal, and it's very" & @CRLF & "usefull for low defense party members." & @CRLF & @CRLF & _
								"DP stands for disposition, and if the DP checkbox" & @CRLF & "is checked for member, then the bot will" & @CRLF & _
								"buff his in game coordinates instead of his place" & @CRLF & "in party. To set the coordinate for a PT member," & @CRLF & _
								"move mouse to desired coordinate and press" & @CRLF & "Shift+F1, Shift+F2, ... to set location of" & @CRLF & _
								"member 1, 2, ...")
		case $GMO_STARTER_help_icon, $DC_User_info_help_icon
								MsgBox(0, "Help", "Every username has it's own StrID, which is numeric" & @CRLF & "and if you don't know yours, this button can get it" & @CRLF & _
								"for you. Before you press this button you must get" & @CRLF & "to your launcher (MU Auto Update) window via your" & @CRLF & _
								"browser (IE, Firefox...). When you get to launcher" & @CRLF & "window, press this button to get your StrID number." & @CRLF & @CRLF & _
								"Press Save pair button to save new username and it's" & @CRLF & "strID into save file, or Delete to delete a pair." & @CRLF & @CRLF & _
								"P.S. It requires latest webzen starter, if you don't" & @CRLF & "have it, you can download it from:" & @CRLF & @CRLF & _
								"http://www.webzen.net/_Files/WebzenGameStarter.exe" & @CRLF & @CRLF & _
								"When you get your strID you will never have to login" & @CRLF & "to webpage in browser to start MU, simply click" & @CRLF & _
								"START MU button on GENERAL TAB and Mu Launcher will" & @CRLF & "appear." & @CRLF & @CRLF & _
								"AutoClick Start Game @ Launcher = when checked bot" & @CRLF & "will instantly click START GAME on MU Update Window" & @CRLF & _
								"- on Launcher window.")
		case $destination_browse
			Local $new_destination = FileOpenDialog("MU Exe file", "", "Mu exe file (mu.exe)")
			if NOT @error then
				GUICtrlSetData($destination_input, $new_destination)
				RegWrite($MU_REG_CONFIG, "EXE", "REG_SZ", $new_destination)
			EndIf
		case $Window_mode_radio
			RegWrite($MU_REG_CONFIG, "WindowMode", "REG_DWORD", "1")
		case $Fullscreen_mode_radio
			RegWrite($MU_REG_CONFIG, "WindowMode", "REG_DWORD", "0")
		case $Sound_checkbox
			if GUICtrlRead($Sound_checkbox) = $GUI_CHECKED Then
				RegWrite($MU_REG_CONFIG, "SoundOnOff", "REG_DWORD", "1")
			Else
				RegWrite($MU_REG_CONFIG, "SoundOnOff", "REG_DWORD", "0")
			EndIf
		case $Music_checkbox
			if GUICtrlRead($Music_checkbox) = $GUI_CHECKED Then
				RegWrite($MU_REG_CONFIG, "MusicOnOff", "REG_DWORD", "1")
			Else
				RegWrite($MU_REG_CONFIG, "MusicOnOff", "REG_DWORD", "0")
			EndIf
		case $Isolate_jewel_button
			_isolate_jewel_sound()
		case $Isolate_jewel_help_icon
			MsgBox(0, "Help!", "Sound Isolation will isolate specified sounds from" & @CRLF & "additional setup. It means that when you start game" & @CRLF & _
								"with isolated sounds you will hear only those sound" & @CRLF & "in game. It will allow you to pay more attention when" & @CRLF & _
								"jewel dropps, etc...." & @CRLF & @CRLF & "P.S. If you want to use this option, you must click" & @CRLF & "the button before you start game!")
		case $AE_Skills_Help_icon
			MsgBox(0, "Help!", "When any of skills is checked it will be used while" & @CRLF & "playing with bot. For example if Def skill is checked" & @CRLF & _
								"bot will def buff yourself every ~50 sec. If Inf.Arrow" & @CRLF & "skill is checked your bot will send Infinite Arrow skill" & @CRLF & _
								"every 10 minutes + 5 sec (5 sec to refill Mana+AG for" & @CRLF & "activation of that skill." & @CRLF & @CRLF & _
								"You can combine weapon skill and multishot if you" & @CRLF & "check last checkbox, then bot will switch multishot" & @CRLF & _
								"and weapon skill every 1-3 seconds.")
		case $EE_buff_delay_help_icon
			MsgBox(0, "Help!", "Select delay time for your buff session. Regular means" & @CRLF & "normal buff delay, and Free heal means delay for free" & @CRLF & _
								"heal buff. Delay inputs are in seconds, max is 60 sec" & @CRLF & "'cause buff last max 60 sec. For example if you set" & @CRLF & _
								"regular to 30, you will buff all your selected members" & @CRLF & "every 30 seconds.")
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc